# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
##############################################################################

from gi.repository import Gtk, Pango
from d_viewer import ShowPoem
from d_tablabel import TabLabel
import d_customs, d_araby, d_tools


# class صفحة المصفاة-------------------------------------------------------------------    
    
class AssemblePoems(Gtk.Box):
    
    def visible_cb(self, model, itr, data):
        if len(self.theword) == 0: return
        if d_araby.fuzzy(self.theword[0]) in d_araby.fuzzy(model.get_value(itr, 2)):
            return True
        else: return False
        
    def search_on_page(self, text):
        self.theword = [text]
        self.modelfilter.refilter()
    
    def near_page(self, v):
        self.size_font_dawawin += v
        self.tree_assemble.override_font(Pango.FontDescription("{}".format(self.size_font_dawawin,))) 
        
    def load_assemble(self, *a):
        self.store_assemble.clear()
        assembles = self.parent.db.get_assembles()
        for a in assembles:
            self.store_assemble.append(None, a)
    
    def on_button_press(self, widget, event):
        if event.button == 3:
            self.popup.show_all()
            self.popup.popup(None, None, None, None, 3,
                             Gtk.get_current_event_time())
        elif event.button == 1 and event.get_click_count()[1] == 2:
            self.show_poem_cb()
     
    def to_poet_cb(self, btn, *a):
        model, i = self.tree_assemble.get_selection().get_selected()
        if i:
            id_poem = model.get_value(i, 0)
            id_poet = self.parent.db.id_poet(id_poem)
            if id_poet == 0: return 
            self.parent.dawawin_page.notebook.set_current_page(0)
            self.parent.main_notebook.set_current_page(1)
            self.parent.dawawin_page.to_poet(id_poet)
                
    def modify_poem_cb(self, *a):
        if d_customs.can_modify(self.parent):
            model, i = self.tree_assemble.get_selection().get_selected()
            if i:
                nm_poem = model.get_value(i, 2)
                nm_poet = model.get_value(i, 3)
                self.parent.main_notebook.set_current_page(5)
                if nm_poet == "أحدهم": nm_poet = 'ما لا يعرف قائله'
                self.parent.organiz.search_poets.set_text(nm_poet)
                self.parent.organiz.sel_poet.select_path((0,))
                self.parent.organiz.ok_poet()
                self.parent.entry_search.set_text(nm_poem)
                self.parent.organiz.sel_poem.select_path((0,))
                self.parent.organiz.ok_poem()
                self.parent.organiz.nbk1.set_current_page(0)
                self.parent.entry_search.set_text('')
        
    def show_poem_cb(self, *a):
        model, i = self.tree_assemble.get_selection().get_selected()
        if i:
            id_poem = model.get_value(i,0)
            text = model.get_value(i,2)
            self.parent.poems_tgl.set_sensitive(True)
            n = self.parent.viewerpoem.get_n_pages()
            for s in range(n):
                ch = self.parent.viewerpoem.get_nth_page(s)
                if self.parent.viewerpoem.get_tab_label(ch).nm == text:
                    self.parent.viewerpoem.set_current_page(s)
                    self.parent.main_notebook.set_current_page(3)
                    return
            sr = ShowPoem(self.parent)
            sr.loading(id_poem, self.parent.theme.fontmp)
            self.parent.viewerpoem.append_page(sr,TabLabel(sr, text))
            self.parent.main_notebook.set_current_page(3) 
            self.parent.viewerpoem.show_all()
            self.parent.viewerpoem.set_current_page(-1)   
    
    def ok_assemble(self, *a):
        model, i = self.sel_assemble.get_selected()
        if i: 
            id_assemble = model.get_value(i, 0)
            self.view_info_bfr.set_text(model.get_value(i, 2))
            poems_id = self.parent.db.get_poems_assemble(id_assemble)
            self.poems_store.clear()
            self.names_list = []
            self.modelfilter = self.poems_store.filter_new()
            v = 0
            for a in range(len(poems_id)):
                v += 1
                if v%500 == 499: 
                    while (Gtk.events_pending()): Gtk.main_iteration()
                i = poems_id[a]
                ls = self.parent.db.poem_info(i)
                name = ls[1]
                if ls[2] != 0: n_poet, l_poet = self.parent.db.name_poet(ls[2])
                else: l_poet = 'أحدهم'
                abiat = ls[6]
                if ls[7] != 0: baher = d_tools.get_name(d_tools.elbehor, ls[7])
                else: baher = '____'
                if ls[8] != 0: rawi = d_tools.get_name(d_tools.elrawi, ls[8])
                else: rawi = '____'
                if ls[11] != 0: gharadh = d_tools.get_name(d_tools.elgharadh, ls[11])
                else: gharadh = '____'
                if ls[12] != 0: naw3 = d_tools.get_name(d_tools.elnaw3, ls[12])
                else: naw3 = '____'
                self.poems_store.append([i, v, name, l_poet, naw3, baher, gharadh, rawi, abiat])
                self.names_list.append(name)
            self.theword = self.names_list[:]
            self.modelfilter.set_visible_func(self.visible_cb, self.theword) 
            self.tree_assemble.set_model(self.modelfilter)
    
    def add_assemble(self, *a):
        dlg = Gtk.Dialog(parent=self.parent)
        dlg.set_title('أضف مجموعًا')
        dlg.set_default_size(400, 250)
        vbox = dlg.vbox
        nb = Gtk.Notebook()
        vb1 = Gtk.Box(spacing=3, orientation=Gtk.Orientation.VERTICAL)
        nm = Gtk.Entry()
        vb1.pack_start(nm, False, False, 0)
        info = d_customs.ViewEdit()
        info_bfr = info.get_buffer()
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(info)
        vb1.pack_start(scroll, True, True, 0)
        nb.append_page(vb1, Gtk.Label('اسم ووصف'))
        grid = Gtk.Grid()
        grid.set_border_width(10)
        check = Gtk.CheckButton('أضف نوعا مخصصا من القصائد')
        grid.attach(check, 0, 0, 2, 1)
        ages = d_customs.combo_all(d_tools.age_poet, 'كلّ العصور')
        grid.attach(ages, 0, 1, 1, 1)
        lands = d_customs.combo_all(d_tools.elbalad, 'كلّ البلدان')
        grid.attach(lands, 1, 1, 1, 1)
        sexs = d_customs.combo_all(d_tools.sex_poet, 'كلا الجنسين')
        grid.attach(sexs, 0, 2, 1, 1)
        baher = d_customs.combo_all(d_tools.elbehor, 'كلّ البحور')
        grid.attach(baher, 1, 2, 1, 1)
        rawi = d_customs.combo_all(d_tools.elrawi, 'كلّ الرويّات')
        grid.attach(rawi, 0, 3, 1, 1)
        naw3 = d_customs.combo_all(d_tools.elnaw3, 'كلّ الأنواع')
        grid.attach(naw3, 1, 3, 1, 1)
        gharadh = d_customs.combo_all(d_tools.elgharadh, 'كلّ الأغراض')
        grid.attach(gharadh, 0, 4, 1, 1)
        nb.append_page(grid, Gtk.Label('أضف قصائد'))
        vbox.pack_start(nb, True, True, 0)
        hb = Gtk.Box(spacing=0, orientation=Gtk.Orientation.HORIZONTAL)
        add_btn = Gtk.Button("أضف")
        def add_assemble(w, *a):
            name = nm.get_text()
            info_text = info_bfr.get_text(info_bfr.get_start_iter(), info_bfr.get_end_iter(), False)
            id_assemble = self.parent.db.add_assemble(name, info_text)
            if check.get_active():
                age0 = d_customs.value_active(ages)
                balad0 = d_customs.value_active(lands)
                sex0 = d_customs.value_active(sexs)
                baher0 = d_customs.value_active(baher)
                rawi0 = d_customs.value_active(rawi)
                naw30 = d_customs.value_active(naw3)
                gharadh0 = d_customs.value_active(gharadh)
                poems_id = self.parent.db.filter_poem(sex0, balad0, age0, baher0, rawi0, 0, 0, gharadh0, naw30)
                self.parent.db.to_assemble(poems_id, id_assemble)
            dlg.destroy()
            d_customs.info(self.parent, 'تم إضافة المجموع')
            self.load_assemble()
        add_btn.connect('clicked', add_assemble)
        add_btn.set_size_request(80, -1)
        hb.pack_start(add_btn, False, False, 0)
        clo_btn = Gtk.Button("أغلق")
        clo_btn.set_size_request(80, -1)
        clo_btn.connect('clicked', lambda *a: dlg.destroy())
        hb.pack_end(clo_btn, False, False, 0)
        vbox.pack_end(hb, False, False, 0)
        dlg.show_all()
    
    def edit_assemble(self, *a):
        model, i = self.sel_assemble.get_selected()
        if i: 
            id_assemble = model.get_value(i, 0)
            assemble = self.parent.db.get_assemble(id_assemble)
            dlg = Gtk.Dialog(parent=self.parent)
            dlg.set_title('عدّل مجموعًا')
            dlg.set_default_size(400, 250)
            vbox = dlg.vbox
            nb = Gtk.Notebook()
            vb1 = Gtk.Box(spacing=3, orientation=Gtk.Orientation.VERTICAL)
            nm = Gtk.Entry()
            nm.set_text(assemble[0])
            vb1.pack_start(nm, False, False, 0)
            info = d_customs.ViewEdit()
            info_bfr = info.get_buffer()
            info_bfr.set_text(assemble[1])
            scroll = Gtk.ScrolledWindow()
            scroll.set_shadow_type(Gtk.ShadowType.IN)
            scroll.add(info)
            vb1.pack_start(scroll, True, True, 0)
            nb.append_page(vb1, Gtk.Label('اسم ووصف'))
            grid = Gtk.Grid()
            grid.set_border_width(10)
            check = Gtk.CheckButton('أضف نوعا مخصصا من القصائد')
            grid.attach(check, 0, 0, 2, 1)
            ages = d_customs.combo_all(d_tools.age_poet, 'كلّ العصور')
            grid.attach(ages, 0, 1, 1, 1)
            lands = d_customs.combo_all(d_tools.elbalad, 'كلّ البلدان')
            grid.attach(lands, 1, 1, 1, 1)
            sexs = d_customs.combo_all(d_tools.sex_poet, 'كلا الجنسين')
            grid.attach(sexs, 0, 2, 1, 1)
            baher = d_customs.combo_all(d_tools.elbehor, 'كلّ البحور')
            grid.attach(baher, 1, 2, 1, 1)
            rawi = d_customs.combo_all(d_tools.elrawi, 'كلّ الرويّات')
            grid.attach(rawi, 0, 3, 1, 1)
            naw3 = d_customs.combo_all(d_tools.elnaw3, 'كلّ الأنواع')
            grid.attach(naw3, 1, 3, 1, 1)
            gharadh = d_customs.combo_all(d_tools.elgharadh, 'كلّ الأغراض')
            grid.attach(gharadh, 0, 4, 1, 1)
            nb.append_page(grid, Gtk.Label('أضف قصائد'))
            
            grid = Gtk.Grid()
            grid.set_border_width(10)
            check1 = Gtk.CheckButton('احذف نوعا مخصصا من القصائد')
            grid.attach(check1, 0, 0, 2, 1)
            ages1 = d_customs.combo_all(d_tools.age_poet, 'كلّ العصور')
            grid.attach(ages1, 0, 1, 1, 1)
            lands1 = d_customs.combo_all(d_tools.elbalad, 'كلّ البلدان')
            grid.attach(lands1, 1, 1, 1, 1)
            sexs1 = d_customs.combo_all(d_tools.sex_poet, 'كلا الجنسين')
            grid.attach(sexs1, 0, 2, 1, 1)
            baher1 = d_customs.combo_all(d_tools.elbehor, 'كلّ البحور')
            grid.attach(baher1, 1, 2, 1, 1)
            rawi1 = d_customs.combo_all(d_tools.elrawi, 'كلّ الرويّات')
            grid.attach(rawi1, 0, 3, 1, 1)
            naw31 = d_customs.combo_all(d_tools.elnaw3, 'كلّ الأنواع')
            grid.attach(naw31, 1, 3, 1, 1)
            gharadh1 = d_customs.combo_all(d_tools.elgharadh, 'كلّ الأغراض')
            grid.attach(gharadh1, 0, 4, 1, 1)
            nb.append_page(grid, Gtk.Label('احذف قصائد'))
            vbox.pack_start(nb, True, True, 0)
            hb = Gtk.Box(spacing=0, orientation=Gtk.Orientation.HORIZONTAL)
            edit_btn = Gtk.Button("عدّل")
            def edit_assemble(w, *a):
                name = nm.get_text()
                info_text = info_bfr.get_text(info_bfr.get_start_iter(), info_bfr.get_end_iter(), False)
                self.parent.db.update_assemble(id_assemble, name, info_text)
                if check.get_active():
                    age0 = d_customs.value_active(ages)
                    balad0 = d_customs.value_active(lands)
                    sex0 = d_customs.value_active(sexs)
                    baher0 = d_customs.value_active(baher)
                    rawi0 = d_customs.value_active(rawi)
                    naw30 = d_customs.value_active(naw3)
                    gharadh0 = d_customs.value_active(gharadh)
                    poems_id = self.parent.db.filter_poem(sex0, balad0, age0, baher0, rawi0, 0, 0, gharadh0, naw30)
                    self.parent.db.to_assemble(poems_id, id_assemble)
                if check1.get_active():
                    age01 = d_customs.value_active(ages1)
                    balad01 = d_customs.value_active(lands1)
                    sex01 = d_customs.value_active(sexs1)
                    baher01 = d_customs.value_active(baher1)
                    rawi01 = d_customs.value_active(rawi1)
                    naw301 = d_customs.value_active(naw31)
                    gharadh01 = d_customs.value_active(gharadh1)
                    poems_id = self.parent.db.filter_poem(sex01, balad01, age01, baher01, rawi01, 0, 0, gharadh01, naw301)
                    self.parent.db.out_assemble(poems_id, id_assemble)
                dlg.destroy()
                d_customs.info(self.parent, 'تم تعديل المجموع')
                self.load_assemble()
            edit_btn.connect('clicked', edit_assemble)
            edit_btn.set_size_request(80, -1)
            hb.pack_start(edit_btn, False, False, 0)
            clo_btn = Gtk.Button("أغلق")
            clo_btn.set_size_request(80, -1)
            clo_btn.connect('clicked', lambda *a: dlg.destroy())
            hb.pack_end(clo_btn, False, False, 0)
            vbox.pack_end(hb, False, False, 0)
            dlg.show_all()
    
    def del_assemble(self, *a):
        model, i = self.sel_assemble.get_selected()
        if i: 
            id_assemble = model.get_value(i, 0)
            res = d_customs.sure(self.parent, 'هل تريد حذف المجموع المحدد')
            if res == -8:
                self.parent.db.remove_assemble(id_assemble)
            self.load_assemble()
    
    def __init__(self, parent):
        self.parent = parent
        self.size_font_dawawin = int(self.parent.theme.fonttp[-2:])
        Gtk.Box.__init__(self, spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        self.vbox_side = Gtk.Box(spacing=3, orientation=Gtk.Orientation.VERTICAL)
        
        # a قائمة المجاميع------------------------------
        self.tree_assemble = d_customs.TreeClass()
        self.tree_assemble.set_size_request(250, -1)
        self.sel_assemble = self.tree_assemble.get_selection()
        cell = Gtk.CellRendererText()
        kal = Gtk.TreeViewColumn('المجاميع', cell, text=1)
        self.tree_assemble.append_column(kal)
        self.store_assemble = Gtk.TreeStore(int, str, str)
        self.load_assemble()
        self.tree_assemble.set_model(self.store_assemble)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_assemble)
        self.tree_assemble.connect("cursor-changed", self.ok_assemble)
        self.vbox_side.pack_start(scroll, True, True, 0)
  
        # a بطاقة المجموع--------------------------------
        self.view_info = d_customs.ViewClass()
        self.view_info_bfr = self.view_info.get_buffer()
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.view_info)
        scroll.set_size_request(250, 200)
        self.vbox_side.pack_start(scroll, False, False, 0)
        
        expander = Gtk.Expander.new('خيرات التعديل')
        self.vbox_side.pack_start(expander, False, False, 0)
        hb = Gtk.Box(spacing=0, orientation=Gtk.Orientation.HORIZONTAL)
        Gtk.StyleContext.add_class(hb.get_style_context(), "linked")
        add_btn = Gtk.Button("أضف")
        add_btn.set_size_request(80, -1)
        add_btn.connect('clicked', self.add_assemble)
        hb.pack_start(add_btn, False, False, 0)
        edit_btn = Gtk.Button("حرّر")
        edit_btn.set_size_request(80, -1)
        edit_btn.connect('clicked', self.edit_assemble)
        hb.pack_start(edit_btn, False, False, 0)
        del_btn = Gtk.Button("احذف")
        del_btn.set_size_request(80, -1)
        del_btn.connect('clicked', self.del_assemble)
        hb.pack_start(del_btn, False, False, 0)
        expander.add(hb)
        
        #--------------------------------------------------------------
        
        self.poems_store = Gtk.ListStore(int,int,str,str,str,str,str,str,int)
        self.tree_assemble = d_customs.TreePoem()
        self.tree_assemble.set_grid_lines(Gtk.TreeViewGridLines.HORIZONTAL)
        self.tree_assemble.connect("button-press-event", self.on_button_press)
        nb = Gtk.TreeViewColumn('#', Gtk.CellRendererText(), text=1)
        self.tree_assemble.append_column(nb)
        assemble = Gtk.TreeViewColumn('القصيدة', Gtk.CellRendererText(), text=2)
        self.tree_assemble.append_column(assemble)
        poets = Gtk.TreeViewColumn('الشاعر', Gtk.CellRendererText(), text=3)
        self.tree_assemble.append_column(poets)
        elnaw3 = Gtk.TreeViewColumn('النوع', Gtk.CellRendererText(), text=4)
        self.tree_assemble.append_column(elnaw3)
        elbaher = Gtk.TreeViewColumn('البحر', Gtk.CellRendererText(), text=5)
        self.tree_assemble.append_column(elbaher)
        elgharadh = Gtk.TreeViewColumn('الغرض', Gtk.CellRendererText(), text=6)
        self.tree_assemble.append_column(elgharadh)
        elrawi = Gtk.TreeViewColumn('الروي', Gtk.CellRendererText(), text=7)
        self.tree_assemble.append_column(elrawi)
        verses = Gtk.TreeViewColumn('عدد الأبيات', Gtk.CellRendererText(), text=8)
        verses.set_expand(True)
        self.tree_assemble.append_column(verses)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_assemble)
        
        self.pack_start(self.vbox_side, False, False, 0)
        self.pack_start(scroll, True, True, 0)
        self.show_all()
        
        #--- Popup menu
        self.popup = Gtk.Menu()
        show_poem = Gtk.ImageMenuItem('اعرض القصيدة')
        show_poem.connect('activate', self.show_poem_cb)
        self.popup.append(show_poem)
        
        show_poet = Gtk.ImageMenuItem('اعرض الشاعر')
        show_poet.connect('activate', self.to_poet_cb)
        self.popup.append(show_poet)
        
        modify_poem = Gtk.ImageMenuItem('عدّل القصيدة')
        modify_poem.connect('activate', self.modify_poem_cb)
        self.popup.append(modify_poem)
        self.popup.show_all()
        