# -*- coding: utf-8 -*-

#a############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
#a############################################################################

from gi.repository import Gtk, Gdk, Pango
import d_araby, d_customs, d_stemming
from d_contacts import Books
import os, re
from os.path import join
import d_config, d_tools
from d_search import ShowResultBooks


# class نافذة الكتب الادبية---------------------------------------------------------   

class BooksViewer  (Gtk.HPaned):
    
    def near_page(self, v):
        self.size_font += v
        self.view_nasse.override_font(Pango.FontDescription("{}".format(self.size_font,))) 
    
    def change_font(self, *a):
        self.view_title_tag.set_property('foreground', self.parent.theme.coloran)
        self.search_tag.set_property('background', self.parent.theme.colorss)
    
    def load_books(self, *a):
        self.store_books.clear()
        list_n = os.listdir(d_customs.BOOKS_DIR)
        for v in list_n:
            if v[-4:] == '.asm': self.store_books.append([v[:-4]])

    # a التصفح--------------------------------------------

    def index_highlight(self, model, path, i, page_id):
        pid = model.get(i,0)[0]
        if pid == page_id: 
            self.tree_index.expand_to_path(path)
            self.tree_index.scroll_to_cell(path)
            self.sel_index.select_path(path)
            return True 
        else:
            return False

    
    def move_in_page(self, v):
        if v == -1:
            if self.db.previous_page(self.current_id) == self.all_in_page[1]: return
            self.show_page(self.db.previous_page(self.current_id))
            id_page = self.all_in_page[1]
            try: self.store_index.foreach(self.index_highlight, id_page)
            except: pass
        else:
            if self.db.next_page(self.current_id) == self.all_in_page[1]: return
            self.show_page(self.db.next_page(self.current_id))
            id_page = self.all_in_page[1]
            try: self.store_index.foreach(self.index_highlight, id_page)
            except: pass
        
    def set_index(self, *a):
        self.store_index.clear()
        model, i = self.sel_books.get_selected()
        if i: book = model.get_value(i, 0)
        else: return
        self.nm_book  = book
        self.lab_nm_book.set_label('كتاب : '+book)
        d_config.setv('book', book)
        self.db = Books(join(d_customs.BOOKS_DIR, book+'.asm'))
        self.list_index = self.db.index_book()
        iters = [None]
        last_iter = None
        last_level = 0
        self.show_page(self.db.first_page())
        #-----------------------------------
        v = 0
        for i in self.list_index:
            v += 1
            if v%1000 == 999: 
                while (Gtk.events_pending()): Gtk.main_iteration()
            level = i[3]
            if level > last_level: iters.append(last_iter)
            elif level < last_level:
                for j in range(last_level-level): iters.pop()
            try :
                last_iter = self.store_index.append(iters[-1], [i[1], i[2]])
            except :
                pass
            last_level = level
        self.stack.set_visible_child_name("n2")
    
    def ok_index(self, *a):  
        model, i = self.sel_index.get_selected()
        if i:
            p = model.get_path(i)
            if model.iter_has_child(i) :
                if self.tree_index.row_expanded(p):
                    self.tree_index.collapse_row(p)
                else: 
                    self.tree_index.expand_row(p, False)
            id_page = model.get_value(i, 0)
            tit = model.get_value(i, 1)
            self.show_page(id_page)
            d_customs.with_tag(self.view_nasse_bfr, self.view_title_tag, [tit,])
            
    def show_page(self, id_page):
        d_config.setv('page', id_page)
        self.all_in_page = self.db.get_text_body(id_page)#rowid, id, text, part, page, hno, sora, aya, na
        if d_config.getn('tashkil') == 0: now_text = d_araby.stripHarakat(self.all_in_page[2])
        else: now_text = self.all_in_page[2]
        titles = self.db.titles_page(self.all_in_page[1])
        self.view_nasse_bfr.set_text(now_text)
        self.view_nasse_bfr.insert(self.view_nasse_bfr.get_end_iter(), " \n")
        try: d_customs.with_tag(self.view_nasse_bfr, self.view_title_tag, titles)
        except: pass 
        self.current_id = self.all_in_page[0]
        self.ent_page.set_text(str(self.all_in_page[4]))
        self.ent_part.set_text(str(self.all_in_page[3]))
        text = self.parent.entry_search.get_text()
        if len(text) >= 2 and text != "ال": 
            self.search_now(text)
        self.scroll_view.get_vadjustment().set_value(0.0)
    
    #aمؤقت-------------------------------
    def dialog_move_to_page(self, *a):
        dlg = Gtk.Dialog(parent=self.parent)
        dlg.set_icon_name("asmaa")
        dlg.set_position(Gtk.WindowPosition.MOUSE)
        dlg.set_title('انتقل إلى صفحة محدّدة')
        parts_all, pages_all = self.db.parts_pages(self.all_in_page[3])
        ent_page = Gtk.Entry()
        lab_page = Gtk.Label(u"عدد الصفحات "+str(pages_all))
        ent_page.set_text(str(self.all_in_page[4]))
        ent_part = Gtk.Entry()
        lab_part = Gtk.Label(u"عدد الأجزاء "+str(parts_all))
        ent_part.set_text(str(self.all_in_page[3]))
        clo = Gtk.Button("ألغ")
        clo.connect('clicked',lambda *a: dlg.destroy())
        move = Gtk.Button("انتقل")
        def replace_cb(widget):
            n_page = int(ent_page.get_text())
            n_part = int(ent_part.get_text())
            id_page = self.db.go_to_page(n_part, n_page)
            if id_page == None: 
                for n in range(20):
                    id_page = self.db.go_to_nearer_page(n_part, n_page, n+1)
                    if id_page != None: break
            if id_page == None: 
                d_customs.erro(self.parent, "لا يمكن الذهاب إلى الصفحة المحددة")
                return
            self.show_page(id_page[0])
            dlg.destroy()
        move.connect('clicked', replace_cb)
        ent_page.connect('activate', replace_cb)
        ent_part.connect('activate', replace_cb)
        box = dlg.vbox
        box.set_border_width(5)
        hb = Gtk.Box(spacing=5,orientation=Gtk.Orientation.HORIZONTAL)
        hb.pack_start(ent_page, False, False, 3)
        hb.pack_start(lab_page, False, False, 3)
        box.pack_start(hb, False, False, 3)
        hb = Gtk.Box(spacing=5,orientation=Gtk.Orientation.HORIZONTAL)
        hb.pack_start(ent_part, False, False, 3)
        hb.pack_start(lab_part, False, False, 3)
        box.pack_start(hb, False, False, 3)
        hb = Gtk.Box(spacing=5,orientation=Gtk.Orientation.HORIZONTAL)
        hb.pack_start(move, False, False, 0)
        hb.pack_end(clo, False, False, 0)
        box.pack_end(hb, False, False, 0)
        dlg.show_all()
   
    def search_on_page(self, text):
        self.show_page(self.all_in_page[1])
        self.search_now(text)
    
    def search_on_active(self, text):    
        sea = ShowResultBooks(self.parent)
        sea.search_in_book([self.nm_book,], text, {'cursive': False, 'one_term': False, 'with_tachkil': False, 'identical': False})
        self.vbox_search.pack_start(sea, False, False, 0)
        self.vbox_side.hide()
        
    def search_now(self, text):
        search_tokens = []
        star_iter = self.view_nasse_bfr.get_start_iter()
        end_iter = self.view_nasse_bfr.get_end_iter()
        self.view_nasse_bfr.remove_tag_by_name("search", star_iter, end_iter)
        nasse = self.view_nasse_bfr.get_text(star_iter, end_iter, True)
        if text == '': 
            return
        else:
            text = text.strip()
            ls_term = d_araby.fuzzy(text).split(' ')
        for text in ls_term:
            if len(text) == 1 or text == "ال": continue
            new_term = ''
            for l in text:
                new_term += '({}(\u0651)?([\u064b\u064c\u064d\u064e\u064f\u0650\u0652])?)'.format(l, )
            new_term = new_term.replace('ا', '[اأإؤءئى]')
            new_term = new_term.replace('ه', '[هة]')
            re_term = re.compile('({})'.format(new_term,))
            r_findall = re_term.findall(nasse)
            for r in r_findall:
                if r[0] not in search_tokens: search_tokens.append(r[0])
        d_customs.with_tag(self.view_nasse_bfr, self.search_tag, search_tokens)
    
    def show_bitaka(self, *a):
        box = Gtk.Box(spacing=5,orientation=Gtk.Orientation.VERTICAL)
        bitaka_book = self.db.info_book()[3]
        info_book = self.db.info_book()[4]
        dlg = Gtk.Dialog(parent=self.parent)
        dlg.set_icon_name("asmaa")
        dlg.set_default_size(450, 300)
        area = dlg.get_content_area()
        area.set_spacing(6)
        
        hb_bar = Gtk.HeaderBar()
        hb_bar.set_show_close_button(True)
        dlg.set_titlebar(hb_bar)
        stack = Gtk.Stack()
        stack.set_transition_type(Gtk.StackTransitionType.SLIDE_LEFT_RIGHT)
        stack.set_transition_duration(1000)
        stack_switcher = Gtk.StackSwitcher()
        stack_switcher.set_stack(stack)
        hb_bar.set_custom_title(stack_switcher)

        view_info = d_customs.ViewClass()
        view_info_bfr = view_info.get_buffer()
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(view_info)
        stack.add_titled(scroll, 'n1',' بطاقة')
        view_info_bfr.set_text(bitaka_book)
        
        view_info1 = d_customs.ViewClass()
        view_info_bfr1 = view_info1.get_buffer()
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(view_info1)
        stack.add_titled(scroll, 'n2', 'نبذة')
        view_info_bfr1.set_text(info_book)
        
        box.pack_start(stack, True, True, 0)
        area.pack_start(box, True, True, 0)
        dlg.show_all()
    
    def explain_term(self, *a):
        if self.view_nasse_bfr.get_has_selection():
            sel = self.view_nasse_bfr.get_selection_bounds()
            sel_text = self.view_nasse_bfr.get_text(sel[0], sel[1],True)
            text = d_araby.stripTatweel(sel_text)
            text = d_tools.first_term(text)
            if len(text) >= 3:
                all_root, all_term = d_stemming.get_root(''+text)
                if len(all_root['lisan'])+len(all_root['mekhtar']) == 0:
                    d_customs.erro(self.parent, 'لا يوجد نتيجة'); return
                self.parent.my_dict.tree_dict.collapse_all()
                self.parent.my_dict.store_dict.clear()
                self.parent.my_dict.view_dict_bfr.set_text('')
                if len(all_root['lisan']) != 0: 
                    a1 = self.parent.my_dict.store_dict.append(None, ['لسان العرب', 'lisan'])
                    for text in all_root['lisan']:
                        self.parent.my_dict.store_dict.append(a1, [text, 'lisan'])
                if len(all_root['mekhtar']) != 0: 
                    a4 = self.parent.my_dict.store_dict.append(None, ['مختار الصحاح', 'mekhtar'])
                    for text in all_root['mekhtar']:
                        self.parent.my_dict.store_dict.append(a4, [text, 'mekhtar'])
                self.parent.my_dict.all_term = all_term
                self.parent.my_dict.tree_dict.expand_all()
                self.parent.my_dict.sel_dict.select_path((0,0))
                self.parent.my_dict.search_on_page("")
                for a in self.parent.my_face.list_btn:
                    if a.get_name() == '6':
                        a.set_active(True)
                self.parent.main_notebook.set_current_page(0)
    
    def copy_sel(self, *a):
        sel = self.view_nasse_bfr.get_selection_bounds()
        sel_text = self.view_nasse_bfr.get_text(sel[0], sel[1],True)
        self.clipboard.set_text(sel_text, -1) 
    
    def save_ta3lim(self, *a):
        list_marks = eval(d_config.getv('marks'))
        list_marks.append([self.all_in_page[1], self.nm_book, 1])
        marks = repr(list_marks)
        d_config.setv('marks', marks)
        d_customs.info(self.parent, u'تم تعليم هذا الموضع')
#        list_marks = eval(d_config.getv('marks'))
#        list_marks.append([self.id_p, book])
#        marks = repr(list_marks)
#        d_config.setv('marks', marks)
#        d_customs.info(self.parent, 'تم تعليم الصفحة')
    
    def populate_popup(self, view, menu):
        for a in menu.get_children():
            a.destroy()
        buff = view.get_buffer()
        f1 = Gtk.MenuItem('شرح المفردة في القواميس')
        menu.append(f1)
        f1.set_sensitive(False)
        f1.show()
        c1 = Gtk.SeparatorMenuItem.new()
        menu.append(c1)
        c1.show()
        f2 = Gtk.MenuItem('نسخ')
        menu.append(f2)
        f2.set_sensitive(False)
        f2.show()
        f3 = Gtk.MenuItem('تعليم الصفحة للرجوع إليها')
        menu.append(f3)
        f3.show()
        c2 = Gtk.SeparatorMenuItem.new()
        menu.append(c2)
        c2.show()
        f4 = Gtk.MenuItem('الصفحة السابقة')
        menu.append(f4)
        f4.show()
        f5 = Gtk.MenuItem('الصفحة التالية')
        menu.append(f5)
        f5.show()
        if buff.get_has_selection():
            f1.set_sensitive(True)
            f2.set_sensitive(True)
        f1.connect("activate", self.explain_term)
        f2.connect("activate", self.copy_sel)
        f3.connect("activate", self.save_ta3lim)
        f4.connect("activate", lambda *a: self.move_in_page(-1))
        f5.connect("activate", lambda *a: self.move_in_page(1))
     
    def select_book(self, model, path, i, book):
        b = model.get(i,0)[0]
        if b == book: 
            self.sel_books.select_path(path)
            return True 
        else:
            return False
        
    def set_pos(self, book, page):
        try: self.store_books.foreach(self.select_book, book)
        except: pass
        self.set_index()
        self.show_page(page)
    
    def __init__(self, parent):
        self.parent = parent
        self.size_font = int(self.parent.theme.fontch[-2:])
        self.all_term = []
        Gtk.HPaned.__init__(self)
        self.vbox_side = Gtk.Box(spacing=0,orientation=Gtk.Orientation.VERTICAL)
        self.clipboard = Gtk.Clipboard.get(Gdk.SELECTION_CLIPBOARD)
        
        self.vbox_text = Gtk.Box(spacing=2,orientation=Gtk.Orientation.VERTICAL)
        self.view_nasse = d_customs.ViewClass()
        self.view_nasse_bfr = self.view_nasse.get_buffer()
        self.view_nasse.connect_after("populate-popup", self.populate_popup)
        self.search_tag = self.view_nasse_bfr.create_tag("search")
        self.view_title_tag = self.view_nasse_bfr.create_tag("title")
        self.scroll_view = Gtk.ScrolledWindow()
        self.scroll_view.set_shadow_type(Gtk.ShadowType.IN)
        self.scroll_view.add(self.view_nasse)
        self.pack1(self.vbox_side, False, True)
        self.pack2(self.vbox_text, True, True)  
        self.vbox_text.pack_start(self.scroll_view, True, True, 0) 
        
        #----------------------------------------
        hbox = Gtk.HBox(False, 0)   
        self.vbox_text.pack_start(hbox, False, False, 0)
        hbox.set_border_width(3)
        hbox.pack_start(Gtk.Label('('), False, False, 0) 
        self.ent_page = Gtk.Label()
        hbox.pack_start(self.ent_page, False, False, 0)
        hbox.pack_start(Gtk.Label('/'), False, False, 0) 
        self.ent_part = Gtk.Label()
        hbox.pack_start(self.ent_part, False, False, 0) 
        hbox.pack_start(Gtk.Label(')'), False, False, 0)
        try:
            move_btn = Gtk.MenuButton()
            img = Gtk.Image()
            img.set_from_stock(Gtk.STOCK_JUMP_TO, Gtk.IconSize.BUTTON)
            move_btn.set_image(img)
            self.popover = Gtk.Popover()
            move_btn.set_popover(self.popover)
            self.ent_page_move = Gtk.Entry()
            self.ent_part_move = Gtk.Entry()
            self.lab_page_move = Gtk.Label("عدد الصفحات ")
            self.lab_part_move = Gtk.Label("عدد الأجزاء ")
            move = Gtk.Button("انتقل")
            def replace_cb(widget):
                n_page = int(self.ent_page_move.get_text())
                n_part = int(self.ent_part_move.get_text())
                id_page = self.db.go_to_page(n_part, n_page)
                if id_page == None: 
                    for n in range(20):
                        id_page = self.db.go_to_nearer_page(n_part, n_page, n+1)
                        if id_page != None: break
                if id_page == None: 
                    d_customs.erro(self.parent, "لا يمكن الذهاب إلى الصفحة المحددة")
                    return
                self.show_page(id_page[0])
                self.popover.hide()
            move.connect('clicked', replace_cb)
            self.ent_page_move.connect('activate', replace_cb)
            self.ent_part_move.connect('activate', replace_cb)
            box = Gtk.Box(spacing=5,orientation=Gtk.Orientation.VERTICAL)
            box.set_border_width(5)
            hb = Gtk.Box(spacing=5,orientation=Gtk.Orientation.HORIZONTAL)
            hb.pack_start(self.ent_page_move, False, False, 3)
            hb.pack_start(self.lab_page_move, False, False, 3)
            box.pack_start(hb, False, False, 3)
            hb = Gtk.Box(spacing=5,orientation=Gtk.Orientation.HORIZONTAL)
            hb.pack_start(self.ent_part_move, False, False, 3)
            hb.pack_start(self.lab_part_move, False, False, 3)
            box.pack_start(hb, False, False, 3)
            hb = Gtk.Box(spacing=5,orientation=Gtk.Orientation.HORIZONTAL)
            hb.pack_start(move, False, False, 0)
            box.pack_end(hb, False, False, 0)
            move_btn.connect("clicked", self.move_to_page)
            box.show_all()
            self.popover.add(box)
            move_btn.set_tooltip_text('الانتقال إلى الصفحة المحددة')
            hbox.pack_start(move_btn,False,False,10)
        except:
            move_btn = Gtk.Button()
            move_btn.set_tooltip_text('الانتقال إلى الصفحة المحددة')
            img = Gtk.Image()
            move_btn.connect("clicked", self.dialog_move_to_page)
            img.set_from_stock(Gtk.STOCK_JUMP_TO, Gtk.IconSize.LARGE_TOOLBAR)
            move_btn.set_image(img)
            hbox.pack_start(move_btn,False,False,10)
            
        self.lab_nm_book = Gtk.Label()
        hbox.pack_start(self.lab_nm_book, False, False, 0)

        bitaka = Gtk.Button()
        bitaka.set_tooltip_text("بطاقة عن الكتاب")
        bitaka.connect('clicked', self.show_bitaka)
        img = Gtk.Image()
        img.set_from_stock(Gtk.STOCK_INFO, Gtk.IconSize.BUTTON)
        bitaka.set_image(img)
        
        add_del = Gtk.Button()
        add_del.set_tooltip_text("إضافة وحذف الكتب")
        add_del.connect('clicked', lambda *a: d_customs.info(self.parent, 'الكتب\
 المدعومة هي كتب مكتبة أسماء ذات الامتداد .asm\nيمكن إضافة وحذف الكتب من خلال لصقها أو حذفها من\
 الدليل : \n{} \n\n يمكن نتزيل الكتب من هذا الرابط :\n http://sourceforge.net/projects/dawawin/files/AdabBooks.7z/download'.format(d_customs.BOOKS_DIR)))
        img = Gtk.Image()
        img.set_from_stock(Gtk.STOCK_NEW, Gtk.IconSize.BUTTON)
        add_del.set_image(img)
        hbox.pack_end(add_del, False, False, 0 )      
        hbox.pack_end(bitaka, False, False, 0 )        
        self.vbox_search = Gtk.Box(spacing=0,orientation=Gtk.Orientation.VERTICAL)
        self.vbox_text.pack_start(self.vbox_search, False, False, 0)
                     
        # a ------------------------------------------ 
        self.stack = Gtk.Stack()
        self.stack.set_transition_type(Gtk.StackTransitionType.SLIDE_LEFT_RIGHT)
        self.stack.set_transition_duration(500)
        
        # a الكتب-----------------------------------
        vbox = Gtk.Box(spacing=2,orientation=Gtk.Orientation.VERTICAL)
        self.tree_books = d_customs.TreeClass()
        self.tree_books.set_headers_visible(False)
        self.tree_books.set_size_request(250, -1)
        self.sel_books = self.tree_books.get_selection()
        cell = Gtk.CellRendererText()
        kal = Gtk.TreeViewColumn('الكتب', cell, text=0)
        self.tree_books.append_column(kal)
        self.store_books = Gtk.ListStore(str)
        self.tree_books.set_model(self.store_books)
        self.tree_books.connect("cursor-changed", self.set_index)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_books)
        self.load_books()
        vbox.pack_start(scroll, True, True, 0)
        self.stack.add_titled(vbox, 'n1', 'الكتب')
        
        # a الفهرس------------------------------
        vbox = Gtk.Box(spacing=0,orientation=Gtk.Orientation.VERTICAL)
        self.tree_index = d_customs.TreeClass()
        self.tree_index.set_headers_visible(False)
        self.tree_index.set_size_request(250, -1)
        self.sel_index = self.tree_index.get_selection()
        self.tree_index.connect("cursor-changed", self.ok_index)
        cell = Gtk.CellRendererText()
        kal = Gtk.TreeViewColumn('الفهرس', cell, text=1)
        self.tree_index.append_column(kal)
        self.store_index = Gtk.TreeStore(int, str)
        self.tree_index.set_model(self.store_index)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_index)
        vbox.pack_start(scroll, True, True, 0)
        self.stack.add_titled(vbox, 'n2', 'الفهرس')
        
        hbox = Gtk.Box(spacing=2,orientation=Gtk.Orientation.HORIZONTAL)
        stack_switcher = Gtk.StackSwitcher()
        stack_switcher.set_stack(self.stack)
        hbox.pack_start(stack_switcher, True, False, 0)
        self.vbox_side.pack_start(hbox, False, False, 3)
        self.vbox_side.pack_start(self.stack, True, True, 0)
        self.change_font()
        try:
            book, page = d_config.getv('book'), d_config.getn('page')
            self.set_pos(book, page)
        except: pass
        self.show_all()