# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
##############################################################################

import sqlite3
from gi.repository import Gtk
import d_araby, d_customs
import random

# a قاعدة بيانات الدواوين----------------------------------
class MyDB(object):
    
    def __init__(self, *a):
        self.con = sqlite3.connect(d_customs.MY_DATA)
        self.con.create_function('fuzzy', 1, d_araby.fuzzy_plus)
        self.cur = self.con.cursor()
        try:
            self.cur.execute('ALTER TABLE infopoem ADD assemble INTEGER DEFAULT 0 NOT NULL')
            self.con.commit()
        except: pass
        try: 
            self.cur.execute('CREATE TABLE IF NOT EXISTS assembles (id_assemble integer primary key, \
            name varchar(255), info varchar(255), poems longtext(20000), tartib int)')          
        except: pass

    # a جميع الشعراء---------------------------------------
    
    def all_poets(self, *a):
        self.cur.execute('SELECT id_poet, lakab, sex, balad, age FROM poets ORDER BY lakab')
        poets = self.cur.fetchall()
        return poets
    
    # a إعادة أطول شطر في قصيدة---------------------------------------
    
    def length_poem(self, id_poem):
        self.cur.execute('SELECT length FROM infopoem WHERE id_poem=?',(id_poem,))
        length = self.cur.fetchall()
        return length[0][0]
    
    # a إعادة نوع قصيدة---------------------------------------
    
    def naw3_poem(self, id_poem):
        self.cur.execute('SELECT naw3 FROM infopoem WHERE id_poem=?',(id_poem,))
        naw3 = self.cur.fetchall()
        return naw3[0][0]
    
    # a إعادة عروض قصيدة---------------------------------------
    
    def arodh_poem(self, id_poem):
        self.cur.execute('SELECT arodh FROM infopoem WHERE id_poem=?',(id_poem,))
        arodh = self.cur.fetchall()
        return arodh[0][0]
    
    # a إعادة قافية قصيدة---------------------------------------
    
    def kafia_poem(self, id_poem):
        self.cur.execute('SELECT kafia FROM infopoem WHERE id_poem=?',(id_poem,))
        kafia = self.cur.fetchall()
        return kafia[0][0]
    
    # a إعادة عدد الأبيات---------------------------------------
    
    def abiat_poem(self, id_poem):
        self.cur.execute('SELECT abiat FROM infopoem WHERE id_poem=?',(id_poem,))
        abiat = self.cur.fetchall()
        return abiat[0][0]
    
    # a إعادة غرض القصيدة---------------------------------------
    
    def gharadh_poem(self, id_poem):
        self.cur.execute('SELECT gharadh FROM infopoem WHERE id_poem=?',(id_poem,))
        gharadh = self.cur.fetchall()
        return gharadh[0][0]
    
    # a إعادة روي القصيدة---------------------------------------
    
    def rawi_poem(self, id_poem):
        self.cur.execute('SELECT rawi FROM infopoem WHERE id_poem=?',(id_poem,))
        rawi = self.cur.fetchall()
        return rawi[0][0]
    
    # a إعادة القصائد غير المعروف رويها---------------------------------------
    
    def poems_no_rawi(self, *a):
        self.cur.execute('SELECT id_poem FROM infopoem WHERE rawi=0 AND naw3=1')
        poems = self.cur.fetchall()
        return poems
    
    # a إصلاح روي قصيدة محددة---------------------------------------
    
    def repair_rawi(self, id_poem, rawi):
        self.cur.execute('UPDATE infopoem SET rawi=? WHERE id_poem=?', (rawi, id_poem))
        check = self.con.commit()
        return check
    
    # a إعادة القصائد غير المعروف أطول شطر فيها----------------------------
    
    def poems_0_langer(self, *a):
        self.cur.execute('SELECT id_poem FROM infopoem WHERE length=0 AND naw3!=5')
        poems = self.cur.fetchall()
        return poems
    
    # a إصلاح القصائد غير المعروف أطول شطر فيها-----------------------------------------------
    
    def repair_langer(self, id_poem, langer):
        self.cur.execute('UPDATE infopoem SET length=? WHERE id_poem=?', (langer, id_poem))
        check = self.con.commit()
        return check
    
    # a إعادة القصائد غير المعروف رويها------------------------------------
    
    def poems_no_kafia(self, *a):
        self.cur.execute('SELECT id_poem FROM infopoem WHERE kafia=0 AND naw3=1')
        poems = self.cur.fetchall()
        return poems
    
    # a إصلاح روي قصيدة محددة-----------------------------------------------
    
    def repair_kafia(self, id_poem, kafia):
        self.cur.execute('UPDATE infopoem SET kafia=? WHERE id_poem=?', (kafia, id_poem))
        check = self.con.commit()
        return check
    
    # a إعادة القصائد غير المعروف عدد أبياتها------------------------------
    
    def poems_0_abiat(self, *a):
        self.cur.execute('SELECT id_poem FROM infopoem WHERE abiat=0')
        poems = self.cur.fetchall()
        return poems
    
    # a إصلاح عدد أبيات قصيدة محددة---------------------------------------
    
    def repair_abiat(self, id_poem, abiat):
        self.cur.execute('UPDATE infopoem SET abiat=? WHERE id_poem=?', (abiat, id_poem))
        check = self.con.commit()
        return check
    
    # a إعادة نص قصيدة وسبب نظمها وشرحها والتعليق عليها---------------------------------------
    
    def get_poem(self, id_poem):
        self.cur.execute('SELECT nasse, sabab, charh, ta3lik FROM kassaid WHERE id_poem=?',(id_poem,))
        poem = self.cur.fetchall()
        return poem[0][0], poem[0][1], poem[0][2], poem[0][3]
    
    # a أعادة معلومات القصيدة كاملة---------------------------------------
    
    def poem_info(self, id_poem):
        self.cur.execute('SELECT * FROM infopoem WHERE id_poem=?',(id_poem,))
        poems = self.cur.fetchall()
        return poems[0]
    
    # a إعادة اسم شاعر---------------------------------------
    
    def name_poet(self, id_poet):
        if id_poet == 0: return 'أحدهم', 'أحدهم'
        self.cur.execute('SELECT name, lakab FROM poets WHERE id_poet=?',(id_poet,))
        poet = self.cur.fetchall()
        return poet[0][0], poet[0][1]
    
    # a إعادة معرف شاعر مسمى---------------------------------------
    
    def id_name_poet(self, name):
        self.cur.execute('SELECT id_poet, sex, balad, age FROM poets WHERE lakab=?',(name,))
        poets = self.cur.fetchall()
        if len(poets) > 0: id_poet, sex, balad, age = poets[0][0], poets[0][1], poets[0][2], poets[0][3]
        elif name == "ما لا يعرف قائله": id_poet, sex, balad, age = 0, 0, 0, 0
        else: id_poet, sex, balad, age = None, None, None, None
        return id_poet, sex, balad, age
   
    # a إعادة معرف شاعر من القصيدة---------------------------------------
    
    def id_poet(self, id_poem):
        self.cur.execute('SELECT id_poet FROM infopoem WHERE id_poem=?',(id_poem,))
        id_poet = self.cur.fetchall()
        return id_poet[0][0]
    
    # a إعادة وفاة الشاعر---------------------------------------
    
    def death_poet(self, id_poet):
        self.cur.execute('SELECT death FROM poets WHERE id_poet=?',(id_poet,))
        death = self.cur.fetchall()
        return death[0][0]
    
    # a إعادة عصر الشاعر---------------------------------------
    
    def age_poet(self, id_poet):
        self.cur.execute('SELECT age FROM poets WHERE id_poet=?',(id_poet,))
        age = self.cur.fetchall()
        return age[0][0]
    
    # a إعادة بلد الشاعر---------------------------------------
    
    def balad_poet(self, id_poet):
        self.cur.execute('SELECT balad FROM poets WHERE id_poet=?',(id_poet,))
        balad = self.cur.fetchall()
        return balad[0][0]
    
    # a إعادة جنس الشاعر---------------------------------------
    
    def sex_poet(self, id_poet):
        self.cur.execute('SELECT sex FROM poets WHERE id_poet=?',(id_poet,))
        sex = self.cur.fetchall()
        return sex[0][0]
    
    # a إضافة شاعر---------------------------------------
    
    def add_poet(self, nm, lak, tarjama, die, sex, balad, age):
        self.cur.execute('SELECT id_poet FROM poets ORDER BY id_poet')
        poets = self.cur.fetchall()
        if len(poets) == 0: id_poet = 1
        else: id_poet = poets[-1][0]+1
        self.cur.execute('INSERT INTO poets VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)', 
                         (id_poet, nm, lak, tarjama, die, sex, balad, age, 0))
        check = self.con.commit()
        if check == None:
            return id_poet, sex, balad, age
        
    # a تعديل شاعر---------------------------------------
    
    def modify_poet(self, id_poet, nm, lak, tarjama, die, sex, balad, age):
        self.cur.execute('UPDATE poets SET name=?, lakab=?, tarjama=?, \
            death=?, sex=?, balad=?, age=? WHERE id_poet=?', 
                         (nm, lak, tarjama, die, sex, balad, age, id_poet))
        self.con.commit()
        self.cur.execute('UPDATE infopoem SET sex=?, balad=?, age=? WHERE id_poet=?', 
                         (sex, balad, age, id_poet))
        check = self.con.commit()
        return check
            
    
    # a إضافة قصيدة---------------------------------------
    
    def add_poem(self, nam, text, sabab, charh, poet, sex, balad, age, abiat, baher, 
                 rawi, kafia, arodh, gharadh, naw3, longer_half):
        self.cur.execute('SELECT id_poem FROM infopoem ORDER BY id_poem')
        poem = self.cur.fetchall()
        if len(poem) == 0: id_poem = 1
        else: id_poem = poem[-1][0]+1
        self.cur.execute('SELECT tartib FROM infopoem ORDER BY tartib')
        tar = self.cur.fetchall()
        if len(tar) == 0: tartib = 1
        else: tartib = tar[-1][0]+1
        self.cur.execute('INSERT INTO infopoem VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)', 
                         (id_poem, nam, poet, sex, balad, age, abiat, baher, rawi, 
                          kafia, arodh, gharadh, naw3, tartib, longer_half, 0, 0, '', '', ''))
        check = self.con.commit()
        if check == None:
            self.cur.execute('INSERT INTO kassaid VALUES (?, ?, ?, ?, ?)', (id_poem, text, sabab, charh, ''))
            check0 = self.con.commit()
        return check0
    
    # a تعديل قصيدة---------------------------------------
    
    def modify_poem(self, id_poem, nam, text, sabab, charh, abiat, 
                    baher, rawi, kafia, arodh, gharadh, naw3, longer_half):
        self.cur.execute('UPDATE infopoem SET name=?, abiat=?, \
        id_baher=?, rawi=?, kafia=?, arodh=?, gharadh=?, naw3=?, length=? WHERE id_poem=?', 
                         (nam, abiat, baher, rawi, kafia, arodh,  
                          gharadh, naw3, longer_half, id_poem))
        check = self.con.commit()
        if check == None:
            self.cur.execute('UPDATE kassaid SET nasse=?, sabab=?, charh=? WHERE id_poem=?', 
                             (text, sabab, charh, id_poem))
            check0 = self.con.commit()
        return check0
    
    # a تغيير شاعر قصيدة---------------------------------------
    
    def change_poet(self, id_poem, poet, sex, balad, age):
        self.cur.execute('UPDATE infopoem SET id_poet=?, sex=?, balad=?, age=? WHERE id_poem=?', 
                         (poet, sex, balad, age, id_poem))
        check = self.con.commit()
        return check
    
    # a دمج شاعرين معا---------------------------------------
    
    def merge_poet(self, id_poet, poet, sex, balad, age):
        self.cur.execute('UPDATE infopoem SET id_poet=?, sex=?, balad=?, age=? WHERE id_poet=?', 
                         (poet, sex, balad, age, id_poet))
        check0 = self.con.commit()
        if check0 == None:
            check = self.remove_poet(id_poet)
            return check

    # a حذف قصيدة---------------------------------------
    
    def remove_poem(self, id_poem):
        self.cur.execute('DELETE FROM infopoem WHERE id_poem=?', (id_poem,))
        check1 = self.con.commit()
        if check1 == None:
            self.cur.execute('DELETE FROM kassaid WHERE id_poem=?', (id_poem,))
            check = self.con.commit()
        return check
    
    # a حذف الأبيات المفضلة---------------------------------------
    
    def remove_abiaty(self, *a):
        self.cur.execute('DELETE FROM abiat')
        check = self.con.commit()
        return check
    
    # a حذف القصائد المسجلة---------------------------------------
    
    def remove_recite_all(self, *a):
        self.cur.execute('UPDATE infopoem SET recite = 0, file_recite=? WHERE recite = 1', ('',))
        check = self.con.commit()
        return check
    
    def remove_recite_one(self, id_poem):
        self.cur.execute('UPDATE infopoem SET recite = 0, file_recite=? WHERE id_poem=?', (id_poem, ''))
        check = self.con.commit()
        return check
    
    # a حذف شاعر مع جميع قصائده---------------------------------------
    
    def remove_poet(self, id_poet):
        ls = self.poems_id(id_poet)
        for a in ls:
            self.remove_poem(a)
        if id_poet == 0:
            return None
        self.cur.execute('DELETE FROM poets WHERE id_poet=?', (id_poet,))
        check = self.con.commit()
        return check
    
    
    # a حذف جميع دواوين عصر ما---------------------------------------
    
    def remove_age(self, age):
        self.cur.execute('SELECT id_poem FROM infopoem WHERE age=?',(age,))
        poems = self.cur.fetchall()
        self.cur.execute('BEGIN;')
        for a in poems:
            self.cur.execute('DELETE FROM infopoem WHERE id_poem=?', (a[0],))
            self.cur.execute('DELETE FROM kassaid WHERE id_poem=?', (a[0],))
        self.con.commit()
        self.cur.execute('DELETE FROM poets WHERE age=?', (age,))
        check = self.con.commit()
        return check
    
    # a قصائد شاعر مع ترجمته---------------------------------------
    
    def poems_of_poet(self, id_poet):
        self.cur.execute('SELECT id_poem, name, abiat, id_baher, rawi, \
        kafia, gharadh, naw3 FROM infopoem WHERE id_poet=?',(id_poet,))
        poems = self.cur.fetchall()
        if id_poet == 0: return poems, 'قسم القصائد غير معروفة النسبة  '
        self.cur.execute('SELECT tarjama FROM poets WHERE id_poet=?',(id_poet,))
        poet = self.cur.fetchall()
        return poems, poet[0][0]
    
    # a معرفات  قصائد شاعر---------------------------------------
    
    def poems_id(self, id_poet):
        self.cur.execute('SELECT id_poem FROM infopoem WHERE id_poet=?',(id_poet,))
        poems = self.cur.fetchall()
        ls = []
        for a in poems:
            ls.append(a[0])
        return ls
    
    # a  معرف بحر قصيدة محددة---------------------------------------
    
    def get_id_baher(self, id_poem):
        self.cur.execute('SELECT id_baher FROM infopoem WHERE id_poem=?',(id_poem,))
        baher = self.cur.fetchall()
        return baher[0][0]
    
    # a  القصائد المقروءة---------------------------------------
    
    def recited_poems(self, *a):
        all_recited = []
        self.cur.execute('SELECT id_poem, name, file_recite, reciter FROM infopoem WHERE recite=1')
        recited = self.cur.fetchall()
        for a in recited:
            list1 = []
            list1.append(a[0])
            list1.append(a[1])
            list1.append(a[2])
            list1.append(a[3])
            all_recited.append(list1)
        return all_recited
    
    def is_recited(self, id_poem):
        self.cur.execute('SELECT id_poem, name, file_recite, reciter, recite FROM infopoem WHERE id_poem=?', (id_poem,))
        recited = self.cur.fetchone()
        return recited
    
    # a  إضافة قصيدة مقروءة---------------------------------------
    
    def set_recite(self, id_poem, file_recite, reciter):
        self.cur.execute('UPDATE infopoem SET recite=1, file_recite=?, reciter=? WHERE id_poem=?',(file_recite, reciter, id_poem))
        check = self.con.commit()
        return check
    
    # a  القصائد المفضلة---------------------------------------
    
    def favorite_poems(self, *a):
        all_favorite = []
        self.cur.execute('SELECT id_poem, name FROM infopoem WHERE fav=1')
        recited = self.cur.fetchall()
        for a in recited:
            list1 = []
            list1.append(a[0])
            list1.append(a[1])
            all_favorite.append(list1)
        return all_favorite
    
    # a  الدواوين المفضلة---------------------------------------
    
    def favorite_poets(self, *a):
        all_favorite = []
        self.cur.execute('SELECT id_poet, name FROM poets WHERE fav=1')
        recited = self.cur.fetchall()
        for a in recited:
            list1 = []
            list1.append(a[0])
            list1.append(a[1])
            all_favorite.append(list1)
        return all_favorite
    
    # a  اسم القصيدة---------------------------------------
    
    def name_poem(self, id_poem):
        self.cur.execute('SELECT name FROM infopoem WHERE id_poem=?',(id_poem,))
        name = self.cur.fetchall()
        return name[0][0]
    
    # a  وضع تعليق---------------------------------------
    
    def set_ta3lik(self, id_poem, text):
        self.cur.execute('UPDATE kassaid SET ta3lik = ? WHERE id_poem=?',(text, id_poem))
        check = self.con.commit()
        return check
    
    # a  إضافة قصيدة للمفضلة---------------------------------------
    
    def to_favorite(self, id_poem):
        self.cur.execute('UPDATE infopoem SET fav = 1 WHERE id_poem=?',(id_poem,))
        check = self.con.commit()
        return check
    
    # a  إخراج قصيدة من المفضلة---------------------------------------
    
    def out_favorite_one(self, id_poem):
        self.cur.execute('UPDATE infopoem SET fav = 0 WHERE id_poem=?',(id_poem,))
        check = self.con.commit()
        return check
    
    def out_favorite_all(self, *a):
        self.cur.execute('UPDATE infopoem SET fav = 0 WHERE fav=1')
        check = self.con.commit()
        return check
    
    # a إعادة  المجاميع---------------------------------------
    
    def get_assembles(self, *a):
        self.cur.execute('SELECT id_assemble, name, info FROM assembles')
        assembles = self.cur.fetchall()
        return assembles
    
    # a إعادة  معلومات مجموع معين---------------------------------------
    
    def get_assemble(self, id_assemble):
        self.cur.execute('SELECT name, info FROM assembles WHERE id_assemble=?',(id_assemble,))
        assemble = self.cur.fetchone()
        return assemble
    
    # a إعادة  قصائد مجموع---------------------------------------
    
    def get_poems_assemble(self, id_assemble):
        self.cur.execute('SELECT poems FROM assembles WHERE id_assemble=?',(id_assemble,))
        id_poems = self.cur.fetchone()
        return eval(id_poems[0])
    
    # a إضافة مجموع---------------------------------------
    
    def add_assemble(self, nm, info):
        self.cur.execute('SELECT id_assemble FROM assembles ORDER BY id_assemble')
        assembles = self.cur.fetchall()
        if len(assembles) == 0: id_assemble = 1
        else: id_assemble = assembles[-1][0]+1
        self.cur.execute('INSERT INTO assembles VALUES (?, ?, ?, ?, ?)', (id_assemble, nm, info,'[]', id_assemble))
        check = self.con.commit()
        if check == None:
            return id_assemble
    
    # a  تعديل مجموع---------------------------------------
    
    def update_assemble(self, id_assemble, nm, info):
        self.cur.execute('UPDATE assembles SET id_assemble=?, name=?, info=? WHERE id_assemble=?',(id_assemble, nm, info, id_assemble))
        check = self.con.commit()
        return check
    
    # a حذف مجموع---------------------------------------
    
    def remove_assemble(self, id_assemble):
        self.cur.execute('DELETE FROM assembles WHERE id_assemble=?', (id_assemble,))
        check = self.con.commit()
        return check
    
    # a  إضافة قصائد لمجموع---------------------------------------
    
    def to_assemble(self, id_poems, id_assemble):
        list_poems = self.get_poems_assemble(id_assemble)
        for a in id_poems:
            if a not in list_poems:
                list_poems.append(a)
        self.cur.execute('UPDATE assembles SET poems = ? WHERE id_assemble=?',(repr(list_poems), id_assemble))
        check = self.con.commit()
        return check
    
    # a  إخراج قصائد من مجموع---------------------------------------
    
    def out_assemble(self, id_poems, id_assemble):
        list_poems = self.get_poems_assemble(id_assemble)
        for a in id_poems:
            try: list_poems.remove(a)
            except: pass
        self.cur.execute('UPDATE assembles SET poems = ? WHERE id_assemble=?',(repr(list_poems), id_assemble))
        check = self.con.commit()
        return check
    
    # a  إضافة  ديوان للمفضلة---------------------------------------
    
    def to_fav_poet(self, id_poet):
        self.cur.execute('UPDATE poets SET fav = 1 WHERE id_poet=?',(id_poet,))
        check = self.con.commit()
        return check
    
    # a  إخراج ديوان من المفضلة---------------------------------------
    
    def out_fav_poet_one(self, id_poet):
        self.cur.execute('UPDATE poets SET fav = 0 WHERE id_poet=?',(id_poet,))
        check = self.con.commit()
        return check
    
    def out_fav_poet_all(self, *a):
        self.cur.execute('UPDATE poets SET fav = 0 WHERE fav=1')
        check = self.con.commit()
        return check
    
    # a  صفحات الأبيات المفضلة---------------------------------------
    
    def abiaty_pages(self, *a):
        self.cur.execute('SELECT id_verse FROM abiat')
        abiat = self.cur.fetchall()
        return abiat
    
    # a  صفحات الأبيات المفضلة---------------------------------------
    
    def abiaty_search(self, text):
        ls_term = []
        for a in text.split(u' '):
            ls_term.append('%'+a+'%')
        condition = ' AND '.join(['fuzzy(abiat) LIKE ?']*len(ls_term))
        self.cur.execute('''SELECT id_verse FROM abiat WHERE {}'''.format(condition, ), ls_term)
        abiat = self.cur.fetchall()
        return abiat
     
    # a  إضافة الأبيات المفضلة---------------------------------------
    
    def to_abiaty(self, id_poem, text):
        self.cur.execute('SELECT id_verse FROM abiat')
        verse = self.cur.fetchall()
        if len(verse) == 0: id_verse = 1
        else: id_verse = verse[-1][0]+1
        self.cur.execute('INSERT INTO abiat VALUES (?, ?, ?)', (id_verse, id_poem, text))
        check = self.con.commit()  
        if check == None:
            return id_verse 
    
    # a إعادة شاعرين لا على لتعيين---------------------------------------
    
    def two_poet(self, id_poet):
        self.cur.execute('SELECT id_poet FROM poets WHERE id_poet != ?', (id_poet,))
        poets = self.cur.fetchall()
        if len(poets) > 2:
            random.shuffle(poets)
            return poets[0][0], poets[1][0]
        else:
            return 0, 0
    
    # a  تأكد من وجود بيت---------------------------------------
     
    def is_verse(self, verse):
        self.cur.execute('SELECT id_poem FROM kassaid WHERE fuzzy(nasse) LIKE ? OR fuzzy(nasse) LIKE ? LIMIT 1', 
                         (d_araby.fuzzy_plus('%\n'+verse+'\n%'), d_araby.fuzzy_plus(verse+'\n%')))
        verses = self.cur.fetchall()
        if len(verses) > 0: return True
        else: return False
    
    # a  إعادة جميع القصائد التي تحوي بيتا يبدأ بحرف معين---------
     
    def first_in_verse(self, letter):
        self.cur.execute('SELECT id_poem FROM kassaid WHERE nasse LIKE ? OR nasse LIKE ?', 
                         ('%\n'+letter+'%', letter+'%'))
        poems = self.cur.fetchall()
        return poems
    
            
    # a  أبيات المفضلة---------------------------------------
    
    def get_abiat(self, id_verse):
        self.cur.execute('SELECT id_poem, abiat FROM abiat WHERE id_verse=?', (id_verse,))
        verses = self.cur.fetchall() 
        return verses[0][0], verses[0][1]     

    # a  حذف أبيات من المفضلة---------------------------------------
    
    def del_abiat(self, id_verse):
        self.cur.execute('DELETE FROM abiat WHERE id_verse=?', (id_verse,))
        check = self.con.commit()
        return check
    
    # a  البحث عن نص في قصيدة---------------------------------------
    
    def search(self, id_poem, phrase, ls):
        self.cur.execute('SELECT nasse FROM kassaid WHERE id_poem={} AND {}'.format(id_poem, phrase), ls)
        result = self.cur.fetchall()
        if len(result) > 0: return True
        else: return False
                        
    # a تصفية القصائد---------------------------------------
    
    def filter_poem(self, sex, balad, age, baher, rawi, kafia, arodh, gharadh, naw3):
        condition = []
        data = []
        if sex != 0:
            condition.append(' sex=?')
            data.append(sex)
        if balad != 0:
            condition.append(' balad=?')
            data.append(balad)
        if age != 0:
            condition.append(' age=?')
            data.append(age)
        if baher != 0:
            condition.append(' id_baher=?')
            data.append(baher)
        if rawi != 0:
            condition.append(' rawi=?')
            data.append(rawi)      
        if kafia != 0:
            condition.append(' kafia=?')
            data.append(kafia)
        if arodh != 0:
            condition.append(' arodh=?')
            data.append(arodh)
        if gharadh != 0:
            condition.append(' gharadh=?')
            data.append(gharadh)
        if naw3 != 0:
            condition.append(' naw3=?')
            data.append(naw3)
        if condition == []: self.cur.execute('SELECT id_poem FROM infopoem')
        else: 
            txt_cond = ' AND '.join(condition)
            self.cur.execute('SELECT id_poem FROM infopoem WHERE{}'.format(txt_cond,), data)
        poems = self.cur.fetchall()
        poems_id = []
        for a in poems:
            poems_id.append(a[0])
        return poems_id
    
    # a معرفات جميع القصائد---------------------------------------
    
    def all_poems_id(self, *a):
        poems_id = []
        self.cur.execute('SELECT id_poem FROM infopoem')
        poems = self.cur.fetchall()
        for a in poems:
            poems_id.append(a[0])
        return poems_id

    #a استيراد ملف---------------------------------------------
    
    def import_file(self, filename):
        self.cur.execute('SELECT id_poet FROM poets ORDER BY id_poet')
        poets = self.cur.fetchall()
        if len(poets) == 0: id_poet = 1
        else: id_poet = poets[-1][0]+1
        self.cur.execute('SELECT id_poem FROM infopoem ORDER BY id_poem')
        poem = self.cur.fetchall()
        if len(poem) == 0: id_poem = 1
        else: id_poem = poem[-1][0]+1
        
        con = sqlite3.connect(filename)
        cur = con.cursor()
        cur.execute('SELECT * FROM poets')
        poet_info = cur.fetchall()
        self.cur.execute('BEGIN;')
        for a in poet_info:
            self.cur.execute('INSERT INTO poets VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)', 
                         (id_poet, a[1], a[2], a[3], a[4], a[5], a[6], a[7], a[8]))
            cur.execute('SELECT * FROM infopoem WHERE id_poet=?', (a[0],))
            poem_info = cur.fetchall()
            for b in poem_info:
                self.cur.execute('INSERT INTO infopoem VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)', 
                             (id_poem, b[1], id_poet, b[3], b[4], b[5], b[6], b[7], 
                              b[8], b[9], b[10], b[11], b[12], b[13], b[14], 0, 0, '', '', ''))
                cur.execute('SELECT * FROM kassaid WHERE id_poem=?', (b[0],))
                poem_text = cur.fetchall()
                self.cur.execute('INSERT INTO kassaid VALUES (?, ?, ?, ?, ?)', 
                                 (id_poem, poem_text[0][1], poem_text[0][2], poem_text[0][3], ''))
                id_poem += 1
            id_poet += 1
        cur.execute('SELECT * FROM infopoem WHERE id_poet=0')
        poem_info = cur.fetchall()
        for b in poem_info:
            self.cur.execute('INSERT INTO infopoem VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)', 
                         (id_poem, b[1], 0, b[3], b[4], b[5], b[6], b[7], 
                          b[8], b[9], b[10], b[11], b[12], b[13], b[14], 0, 0, '', '', ''))
            cur.execute('SELECT * FROM kassaid WHERE id_poem=?', (b[0],))
            poem_text = cur.fetchall()
            self.cur.execute('INSERT INTO kassaid VALUES (?, ?, ?, ?, ?)', 
                             (id_poem, poem_text[0][1], poem_text[0][2], poem_text[0][3], ''))
            id_poem += 1
        check = self.con.commit()
        return check
    
    #a استيراد القصائد---------------------------------------------
    
    def is_poem_exists(self, name, sex, balad, age, abiat, baher, rawi, 
                      kafia, arodh, gharadh, naw3, longer_half):
        self.cur.execute('SELECT id_poem FROM infopoem WHERE fuzzy(name)=? AND sex=? AND balad=? AND \
         age=? AND abiat=? AND id_baher=? AND rawi=? AND kafia=? AND arodh=? AND gharadh=? AND naw3=? AND length=?', 
         (d_araby.fuzzy(name), sex, balad, age, abiat, baher, rawi, kafia, arodh, gharadh, naw3, longer_half))
        poems = self.cur.fetchall()
        return poems
    
    def is_poet_exists(self, lakab_poet, age, balad):
        self.cur.execute('SELECT id_poet FROM poets WHERE fuzzy(lakab)=? AND balad=? AND age=?', 
                         (d_araby.fuzzy(lakab_poet), balad, age))
        poet = self.cur.fetchall()
        return poet
    
    def add_file_db(self, filename):
        con = sqlite3.connect(filename)
        cur = con.cursor()
        cur.execute('SELECT * FROM infopoem')
        poems = cur.fetchall()
        return poems
        
    def add_poem_from_fileDB(self, id_poem, filename, v=False):
        con = sqlite3.connect(filename)
        cur = con.cursor()
        cur.execute('SELECT * FROM infopoem WHERE id_poem=?', (id_poem,) )
        poem_info = cur.fetchall()
        cur.execute('SELECT * FROM kassaid WHERE id_poem=?', (id_poem,) )
        poem_text = cur.fetchall()
        poet = poem_info[0][2] 
        cur.execute('SELECT * FROM poets WHERE id_poet=?', (poet,) )
        poet_info = cur.fetchall()
        sex = poem_info[0][3] 
        balad = poem_info[0][4] 
        age = poem_info[0][5] 
        nam = poem_info[0][1] 
        text = poem_text[0][1] 
        sabab = poem_text[0][2] 
        charh = poem_text[0][3] 
        abiat = poem_info[0][6] 
        baher = poem_info[0][7] 
        rawi = poem_info[0][8] 
        kafia = poem_info[0][9] 
        arodh = poem_info[0][10] 
        gharadh = poem_info[0][11] 
        naw3 = poem_info[0][12] 
        longer_half = poem_info[0][14]
        if len(poet_info) == 0:
            id_poet = 0
        else:
            name_poet = poet_info[0][1] 
            lakab_poet = poet_info[0][2]
            tardjama = poet_info[0][3] 
            death = poet_info[0][4]
            poet0 = self.is_poet_exists(d_araby.fuzzy(lakab_poet), age, balad)
            if len(poet0) == 0:
                id_poet, sex, balad, age = self.add_poet(name_poet, lakab_poet, tardjama, death, sex, balad, age)
            else:
                id_poet = poet0[0][0]
        poem = self.is_poem_exists(d_araby.fuzzy(nam), sex, balad, age, abiat, baher, rawi, kafia, arodh, gharadh, naw3, longer_half)
        if len(poem) > 0:
            if v:
                id_poem = poem[0][0]
                self.modify_poem(id_poem, nam, text, sabab, charh, id_poet, sex, balad, 
                                 age, abiat, baher, rawi, kafia, arodh, gharadh, naw3, longer_half)
            return True
        self.add_poem(nam, text, sabab, charh, id_poet, sex, balad, age, abiat, baher, rawi, 
                      kafia, arodh, gharadh, naw3, longer_half)
        return True
    
    # a دواوين عصر محدد--------------------------------------
    
    def poet_of_age(self, age):
        if age == 0: return [[0,],]
        self.cur.execute('SELECT id_poet, lakab FROM poets WHERE age=?', (age,))
        poets = self.cur.fetchall()
        return poets
    
    # a تصدير قصائد-----------------------------------------
    
    def export_poems(self, new_file, id_v, n):
        con = sqlite3.connect(new_file)
        cur = con.cursor()
        if n == 0:
            cond = 'age=?'
        elif n == 1:
            cond = 'id_poet=?'
        elif n == 2:
            cond = 'id_poem=?'
        self.cur.execute('SELECT * FROM infopoem WHERE {}'.format(cond,), (id_v,))
        poems = self.cur.fetchall()
        cur.execute('BEGIN;')
        for a in poems:
            while (Gtk.events_pending()): Gtk.main_iteration()
            cur.execute('INSERT INTO infopoem VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)', 
                             (a[0], a[1], a[2], a[3], a[4], a[5], a[6], a[7], a[8], 
                              a[9], a[10], a[11], a[12], a[13], a[14], a[15], 0, '', '', ''))
            self.cur.execute('SELECT * FROM kassaid WHERE id_poem=?', (a[0],))
            poem = self.cur.fetchall()
            b = poem[0]
            cur.execute('INSERT INTO kassaid VALUES (?, ?, ?, ?, ?)', (b[0], b[1], b[2], b[3], ''))
            if n == 2:
                if a[2] != 0:
                    self.cur.execute('SELECT * FROM poets WHERE id_poet=?', (a[2],))
                    poet = self.cur.fetchall()
                    d = poet[0]
                    cur.execute('INSERT INTO poets VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)', 
                             (d[0], d[1], d[2], d[3], d[4], d[5], d[6], d[7], d[8]))
        con.commit()
        if n != 2:
            self.cur.execute('SELECT * FROM poets WHERE {}'.format(cond,), (id_v,))
            poets = self.cur.fetchall()
            cur.execute('BEGIN;')
            for c in poets:
                cur.execute('INSERT INTO poets VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?)', 
                             (c[0], c[1], c[2], c[3], c[4], c[5], c[6], c[7], c[8]))
            con.commit()
        return True
    
    def name_poet_newfile(self, id_poet, filename):
        con = sqlite3.connect(filename)
        cur = con.cursor()
        if id_poet == 0: return 'أحدهم', 'أحدهم'
        cur.execute('SELECT name, lakab FROM poets WHERE id_poet=?',(id_poet,))
        poet = cur.fetchall()
        return poet[0][0], poet[0][1]
    
    # a إحصاءات------------------------------------------------
    
    def n_poems_poet(self, id_poet):
        self.cur.execute('SELECT id_poem FROM infopoem WHERE id_poet=?', (id_poet,))
        poems = self.cur.fetchall()
        return str(len(poems))
    
    def n_verses_poet(self, id_poet):
        self.cur.execute('SELECT sum(abiat) FROM infopoem WHERE id_poet=?', (id_poet,))
        abiats = self.cur.fetchall()
        if abiats[0][0] == None: return "  "
        return str(abiats[0][0]) 
    
    def n_dawawin(self, *a):
        self.cur.execute('SELECT id_poet FROM poets')
        poets = self.cur.fetchall()
        return str(len(poets))
    
    def n_poems(self, *a):
        self.cur.execute('SELECT id_poem FROM infopoem')
        poems = self.cur.fetchall()
        return str(len(poems))
    
    def n_verses(self, *a):
        self.cur.execute('SELECT sum(abiat) FROM infopoem')
        abiats = self.cur.fetchall()
        return str(abiats[0][0])
    
    # a انشاء قاعدة بيانات فارغة-------------------------------
    
    def create_db(self, filename):
        con = sqlite3.connect(filename)
        cur = con.cursor()
        cur.execute('CREATE TABLE abiat (id_verse integer primary key, id_poem int, abiat longtext(2000))') 
        cur.execute('CREATE TABLE poets (id_poet integer primary key, \
        name varchar(255), lakab varchar(255), tarjama longtext(20000), \
        death int, sex int, balad int, age int,fav int)')
        cur.execute('CREATE TABLE infopoem (id_poem integer primary key, \
        name varchar(255), id_poet int, sex int, balad int, age int, \
        abiat int, id_baher int, rawi int, kafia int, arodh int, gharadh int, \
        naw3 int, tartib int, length int, fav int, recite int, reciter varchar(255), file_recite varchar(255), assemble int)')
        cur.execute('CREATE TABLE kassaid (id_poem integer primary key, \
        nasse longtext(20000), sabab longtext(20000), charh longtext(20000), ta3lik longtext(20000))')
        cur.execute('CREATE TABLE IF NOT EXISTS assembles (id_assemble integer primary key, \
        name varchar(255), info varchar(255), poems longtext(20000), tartib int)')    

# a قاعدة بيانات الأوزان----------------------------------
        
class AwzanDB(object):
    
    def __init__(self, *a):
        self.con = sqlite3.connect(d_customs.MY_AWZAN)
        self.cur = self.con.cursor()
    
    def meter_verse(self, text):
        self.cur.execute('SELECT * FROM awzan WHERE wazn=?', (text,))
        result = self.cur.fetchall()
        return result

# a قاعدة بيانات المعجم----------------------------------
      
class DictDB(object):
    
    def firstletter(self, term):
        return term[0]
    
    def __init__(self, *a):
        self.con = sqlite3.connect(d_customs.MY_DICT)
        self.con.create_function('firstletter', 1, self.firstletter)
        self.cur = self.con.cursor()
    
    def all_index(self, dicte, f_letter):
        self.cur.execute('SELECT term FROM {} WHERE firstletter(term)=? ORDER BY term'.format(dicte, ), (f_letter,))
        terms = self.cur.fetchall()
        return terms
    
    def show_charh(self, term, dicte):
        self.cur.execute('SELECT charh FROM {} WHERE term=?'.format(dicte, ), (term,))
        charh = self.cur.fetchall()
        return charh

# a قاعدة بيانات المساعدة----------------------------------
  
class HelpDB(object):
    
    def __init__(self, *a):
        self.con = sqlite3.connect(d_customs.MY_METRICS)
        self.cur = self.con.cursor()
    
    def titles_mekadimat(self, *a):
        self.cur.execute('SELECT id, tit FROM mekadimat')
        mekadimat = self.cur.fetchall()
        return mekadimat
        
    def show_page_mekadimat(self, v):
        self.cur.execute('SELECT nasse FROM mekadimat WHERE id=?', (v,))
        txt = self.cur.fetchall() 
        return txt 
        
    def titles_behor(self, *a):
        self.cur.execute('SELECT id, tit FROM behor')
        behor = self.cur.fetchall()
        return behor
        
    def show_page_behor(self, v):
        self.cur.execute('SELECT nasse FROM behor WHERE id=?', (v,))
        txt = self.cur.fetchall()
        return txt 

# a قاعدة بيانات الكتب----------------------------------
        
class Books(object):
    
    altered = [(u'EX', u''), (u'{', u'﴿'), (u'}', u'﴾'), (u'0', u'٠'), (u'1', u'١'), 
                (u'2', u'٢'), (u'3', u'٣'), (u'4', u'٤'), (u'5', u'٥‌'), (u'6', u'٦'), 
                (u'7', u'٧'), (u'8', u'٨'), (u'9', u'٩'), (u'+', u'')]
    
    altered0 = [(u'EX', u''), (u'{', u'﴿'), (u'}', u'﴾'), ( u'٠',u'0'), ( u'١',u'1'), 
                (u'٢', u'2'), (u'٣' ,u'3'), (u'٤' ,u'4'), (u'٥‌' ,u'5'), (u'٦' ,u'6'), 
                (u'٧' ,u'7'), (u'٨' ,u'8'), (u'٩' ,u'9'), (u'+', u'')]
    
    shorts0 = [(u'A', u'صلى الله عليه وسلم'), (u'B', u'رضي الله عن'), (u'C', u'رحمه الله'), 
             (u'D', u'عز وجل'), (u'E', u'عليه الصلاة و السلام'), (u'Y', u':')]
    
    def __init__(self, book):
        self.book = book
        self.con = sqlite3.connect(self.book)
        self.con.create_function('fuzzy', 1, d_araby.fuzzy_plus)
        self.con.create_function('expand_shorts', 1, self.expand_shorts)
        self.cur = self.con.cursor()
        
        self.is_tafseer = 0
        self.is_sharh = 0
        self.shorts = 0
        self.cur.execute("SELECT bk, is_tafseer, is_sharh, islamshort, version FROM main LIMIT 1")
        r = self.cur.fetchone()
        self.book_name = r[0]
        self.n_version = r[4]
        self.is_tafseer, self.is_sharh, self.shorts = r[1], r[2], r[3]
        self.shorts_init()
        self.cur.execute("SELECT rowid FROM pages ORDER BY part AND page")
        self.list_pages = self.cur.fetchall()
        self.len_index = len(self.cur.execute("SELECT rowid FROM pages").fetchall())
        
    def change_version(self, ver):
        self.cur.execute('UPDATE main SET version=?', (ver, ))
        self.con.commit()
    
    def shorts_init(self):
        self.shorts1 = []
        self.shorts2 = []
        if self.shorts & 1: self.shorts1 = self.shorts0
        else: self.shorts1 = []
        if self.shorts<2: self.shorts2 = []; return
        self.cur.execute('SELECT ramz, nass FROM shorts')
        ramz = self.cur.fetchall()
        for a in ramz:
            self.shorts2.append((a[0], a[1]))
            
    def expand_shorts(self, txt):
        #if d_config.getn('nmbrs') == 0: 
        #    for i, j in self.altered: txt = txt.replace(i, j)
        #else: 
        for i, j in self.altered0: txt = txt.replace(i, j)
        for i, j in self.shorts1: txt = txt.replace(i, j)
        for i, j in self.shorts2: txt = txt.replace(i, j)
        return txt
    
    # a فهرس كتاب محدد---------------------------------------
    
    def index_book(self, *a):
        self.cur.execute("SELECT rowid, id, tit, lvl FROM titles ORDER BY id")
        toc_list = self.cur.fetchall()
        en = enumerate(toc_list)
        rv = reversed(list(en))
        h = {}
        for i, j in rv: h[j[1]] = j # i is used to keep the order only
        self.toc_ids = h.keys() 
#        self.toc_ids.sort()
        self.toc_uniq = h.values()
#        self.toc_uniq.sort()
        return toc_list
    
    # a عناوين صفحة ممعينة---------------------------------------
    
    def titles_page(self, page_id):
        self.cur.execute("SELECT tit FROM titles WHERE id=?", (page_id, ))
        t_list = self.cur.fetchall()
        t = []
        for i in t_list:
            t.append(i[0])
        return t
    
    # a نص صفحة معينة----------------------------------------
    
    def get_text_body(self, page_id):
        self.cur.execute("SELECT rowid, id, expand_shorts(nass) as text, part, page, \
        hno, sora, aya, na FROM pages WHERE id=? LIMIT 1" , (page_id, ))
        return self.cur.fetchone()

    # a التصفح--------------------------------------------

    def first_page(self):
        self.cur.execute("SELECT id FROM pages WHERE rowid=?", (1, ))
        return self.cur.fetchone()[0]
    
    def previous_page(self, current_id):
        if current_id == 1: return 1
        self.cur.execute("SELECT id FROM pages WHERE rowid=?", (current_id-1, ))
        return self.cur.fetchone()[0]
    
    def next_page(self, current_id):
        if current_id == len(self.list_pages): return len(self.list_pages)
        self.cur.execute("SELECT id FROM pages WHERE rowid=?", (current_id+1, ))
        return self.cur.fetchone()[0]
    
    def last_page(self):
        self.cur.execute("SELECT id FROM pages WHERE rowid=?", (len(self.list_pages), ))
        return self.cur.fetchone()[0]
    
    # a بطاقة الكتاب----------------------------------------------
    
    def info_book(self):
        self.cur.execute("SELECT * FROM main")
        return self.cur.fetchone()
    
    def go_to_page(self, n_part, n_page):
        self.cur.execute("SELECT id FROM pages WHERE part=? AND page=?" , (n_part, n_page))
        return self.cur.fetchone()
    
    def go_to_nearer_page(self, n_part, n_page, n):
        self.cur.execute("SELECT id FROM pages WHERE part=? AND page=?" , (n_part, n_page-n))
        return self.cur.fetchone()

    def get_title(self, id_page):
        self.cur.execute('SELECT tit FROM titles WHERE id<=?', (id_page,)) 
        try: tit = self.cur.fetchall()[-1][0]
        except: tit = '......'
        return tit
   
    def all_page(self, *a):
        self.cur.execute("SELECT id, part, page FROM pages")
        return self.cur.fetchall()

    #---------------------------------------------------
    def close_db(self, *a):
        self.cur.close()
        self.con.close()
        self.toc_ids = None
        self.toc_uniq = None
        self.list_pages = None
        self.len_index = None
        self.cur = None
        self.con = None
        del self.cur
        del self.con
        del self.toc_ids
        del self.toc_uniq 
        del self.list_pages
        del self.len_index
    
    # a بحث في صفحة معينة-----------------------------------
    
    def search_in_page(self, id_page, text):
        self.cur.execute('SELECT id FROM pages WHERE id=? AND fuzzy(nass) LIKE ?', (id_page, '%'+text+'%'))
        if len(self.cur.fetchall()) > 0: return True
        else: return False
        
    # a عدد الصفحات والأجزاء-----------------------------------
    
    def parts_pages(self, part=1):
        self.cur.execute('SELECT part FROM pages')
        parts = self.cur.fetchall()
        self.cur.execute('SELECT page FROM pages WHERE part=?' , (part, ))
        pages = self.cur.fetchall()
        try: return parts[-1][0], pages[-1][0]
        except: return 0, 0
        
    # a بحث في فهرس كتاب-----------------------------------
    
    def search_index(self, text):
        self.cur.execute('SELECT id, tit FROM titles WHERE fuzzy(tit) LIKE ? LIMIT 100', ('%'+text+'%', ))
        books = self.cur.fetchall()
        return books