# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
##############################################################################

import sqlite3
import d_araby, d_customs, d_tools
from d_contacts import MyDB
from gi.repository import Gtk, Pango


class Count(Gtk.Box):
    
    def __init__(self, parent):
        self.parent = parent
        self.size_font = int(self.parent.theme.fontch[-2:])
        self.con = sqlite3.connect(d_customs.MY_DATA)
        self.db = MyDB()
        self.con.create_function('fuzzy', 1, d_araby.fuzzy)
        self.cur = self.con.cursor()
        Gtk.Box.__init__(self,spacing=7,orientation=Gtk.Orientation.HORIZONTAL)
        self.store_help = Gtk.ListStore(str, int)
        self.store_help.append(['الكلّ', 0])
        for a in d_tools.age_poet:
            self.store_help.append([a[1], a[0]])
        self.tree_count = d_customs.TreeClass()
        self.sel_count = self.tree_count.get_selection()
        cell = Gtk.CellRendererText()
        kal = Gtk.TreeViewColumn('الفهرس', cell, text=0)
        self.tree_count.append_column(kal)
        self.tree_count.set_model(self.store_help)
        scroll = Gtk.ScrolledWindow()
        scroll.set_size_request(200, -1)
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add_with_viewport(self.tree_count)
        self.tree_count.connect("cursor-changed", self.count_age)
        self.pack_start(scroll, False, False, 0)
        self.view_count = d_customs.ViewClass()
        self.view_count_bfr = self.view_count.get_buffer()
        self.view_count_tag = self.view_count_bfr.create_tag("title")
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.view_count)
        self.pack_start(scroll, True, True, 0)
        self.show_all()
   
    def near_page(self, v):
        self.size_font += v
        self.view_count.override_font(Pango.FontDescription("{}".format(self.size_font,))) 
   
    def n_dawawin(self, sex, age):
        self.cur.execute('SELECT id_poet FROM poets WHERE sex=? AND age=?', (sex, age))
        poets = self.cur.fetchall()
        return len(poets)
    
    def n_poems(self, sex, age):
        self.cur.execute('SELECT id_poem FROM infopoem WHERE sex=? AND age=?', (sex, age))
        poems = self.cur.fetchall()
        return len(poems)
    
    def n_verses(self, sex, age):
        self.cur.execute('SELECT sum(abiat) FROM infopoem WHERE sex=? AND age=?', (sex, age))
        abiats = self.cur.fetchall()
        if abiats[0][0] == None: return 0
        return abiats[0][0] 

    def count_age(self, *a):
        model, i = self.sel_count.get_selected()
        if i:
            v = model.get_value(i,1)
            nm = model.get_value(i,0)
            if v == 0:
                new_text = '''
        صفحة إحصاء الدواوين والقصائد والأبيات الملحقة بقاعدة بيانات برنامج دواوين العرب :
        عدد الدواوين الإجمالي : {} ،
        عدد القصائد الإجمالي : {} ،
        عدد الأبيات الإجمالي : {} ،
        '''.format(self.db.n_dawawin(), self.db.n_poems(), self.db.n_verses())
            else:
                new_text = '''
        {} :
        الشعراء :
        عدد الدواوين : {} ،
        عدد القصائد : {} ،
        عدد الأبيات : {} ،
        الشواعر :
        عدد الدواوين : {} ،
        عدد القصائد : {} ،
        عدد الأبيات : {} ،
        الكل :
        عدد الدواوين : {} ،
        عدد القصائد : {} ،
        عدد الأبيات : {} ،
        '''.format(nm, self.n_dawawin(1, v), self.n_poems(1, v), self.n_verses(1, v),
                   self.n_dawawin(2, v), self.n_poems(2, v), self.n_verses(2, v),
                   self.n_dawawin(2, v)+self.n_dawawin(1, v),
                   self.n_poems(2, v)+self.n_poems(1, v), 
                   self.n_verses(2, v)+self.n_verses(1, v)) 
            self.view_count_bfr.set_text(new_text)