# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
##############################################################################

from os.path import join, dirname, realpath, exists, expanduser
from gi.repository import Gtk, Gdk, Pango, GdkPixbuf
import d_config, d_araby
from os import mkdir
import sys
import sqlite3

Gtk.Widget.set_default_direction(Gtk.TextDirection.RTL)

#a------------------------------------------
version = '0.7.0'

#a------------------------------------------
def info(parent, msg):
    dlg = Gtk.MessageDialog(parent, Gtk.DialogFlags.MODAL,
                            Gtk.MessageType.INFO, Gtk.ButtonsType.CLOSE, msg)
    dlg.run()
    dlg.destroy()

#a------------------------------------------
def erro(parent, msg):
    dlg = Gtk.MessageDialog(parent, Gtk.DialogFlags.MODAL,
                            Gtk.MessageType.ERROR, Gtk.ButtonsType.CLOSE, msg)
    dlg.run()
    dlg.destroy()

#a------------------------------------------
def sure(parent, msg):
    dlg = Gtk.MessageDialog(parent, Gtk.DialogFlags.MODAL, Gtk.MessageType.WARNING,
                             Gtk.ButtonsType.YES_NO)
    dlg.set_markup(msg)                         
    r = dlg.run()
    dlg.destroy()
    return r

#a--------------------------------------------------

if getattr(sys, 'frozen', False):
    APP_DIR = dirname(dirname(sys.executable))
else:
    APP_DIR        = dirname(dirname(realpath(__file__)))
HOME_DIR     = expanduser('~/.dawawin')
DATA_DIR      = join(APP_DIR, 'dawawin-data')
DEFAULT_DATA   = join(DATA_DIR, 'Dawawin.db')
ICON_DIR       = join(DATA_DIR, 'Icons')
MY_DICT         = join(DATA_DIR, 'Dict.db')
MY_AWZAN     = join(DATA_DIR, 'Awzan.db')
MY_METRICS   = join(DATA_DIR, 'Metrics.db')
MY_HELP         = join(DATA_DIR, 'Help.txt')

#a------------------------------------------
def sure_start():
    dlg = Gtk.MessageDialog(None, Gtk.DialogFlags.MODAL, Gtk.MessageType.WARNING,
                             Gtk.ButtonsType.NONE)
    dlg.set_markup('''
    لم يتمكن البرنامج من الاتصال بقاعدة البيانات،
    إذا كانت موجودة بالفعل فربما لم تربطها بالبرنامج، 
    أو قد يكون القرص الموجود عليه القاعدة غير مضموم،
    ماذا تريد أن تفعل ؟''')
    db_void = Gtk.LinkButton.new_with_label("http://sourceforge.net/projects/dawawin/files/DawawinArab.7z/download",
                                                'تنزيل قاعدة بيانات للتجربة')
    no_lib = Gtk.Button('خروج')
    dlg.add_action_widget(no_lib, 1)
    sel_lib = Gtk.Button('تحديد المسار')
    dlg.add_action_widget(sel_lib, 2)
    new_lib = Gtk.Button('إنشاء قاعدة بيانات مفرغة')
    dlg.add_action_widget(new_lib, 3)
    if  exists(DEFAULT_DATA): 
        def_lib = Gtk.Button('المسار الافتراضي')
        dlg.add_action_widget(def_lib, 4)
    
    area = dlg.get_content_area()
    area.set_spacing(7)
    hbox = Gtk.HBox(False, 7)
    hbox.pack_end(db_void, False, False, 0)
    area.pack_start(hbox, False, False, 0)
    area.show_all()
    r = dlg.run()
    dlg.destroy()
    return r

#a------------------------------------------
if not exists(d_config.getv('path')): 
    res = sure_start()
    # a تحديد المسار--------------------------
    if res == 2:
        open_dlg = Gtk.FileChooserDialog('تحديد مسار قاعدة البيانات',
                                         None, Gtk.FileChooserAction.OPEN,
                                        (Gtk.STOCK_OK, Gtk.ResponseType.OK,
                                         Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL))
        
        Filter = Gtk.FileFilter()
        Filter.set_name("قاعدة البيانات")
        Filter.add_pattern("Dawawin.db")
        open_dlg.add_filter(Filter)
        res = open_dlg.run()
        if res == Gtk.ResponseType.OK:
            d_config.setv('path', open_dlg.get_filenames()[0])          
            open_dlg.destroy()
        else:
            open_dlg.destroy()
            quit()   
        
    # a إلغاء التحديد-------------------------
    elif res == 1:
        quit()
    # a  قاعدة البيانات المفرغة--------------------------
    elif res == 3:
        save_dlg = Gtk.FileChooserDialog('مسار قاعدة البيانات الجديدة', None,
                                    Gtk.FileChooserAction.SELECT_FOLDER,
                                    (Gtk.STOCK_OK, Gtk.ResponseType.OK,
                                    Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL))
        res = save_dlg.run()
        if res == Gtk.ResponseType.OK:
            new_dir = join(save_dlg.get_filename(), 'دواوين العرب')
            if exists(join(new_dir,'Dawawin.db')):
                erro(None, 'يوجد قاعدة بيانات في هذا الدليل بالفعل')
            else:
                if not exists(new_dir):
                    mkdir(new_dir)
                if not exists(join(new_dir,'Audio')):
                    mkdir(join(new_dir,'Audio'))
                con = sqlite3.connect(join(new_dir, 'Dawawin.db'))
                cur = con.cursor()
                cur.execute('CREATE TABLE abiat (id_verse integer primary key, id_poem int, abiat longtext(2000))') 
                cur.execute('CREATE TABLE poets (id_poet integer primary key, \
                name varchar(255), lakab varchar(255), tarjama longtext(20000), \
                death int, sex int, balad int, age int,fav int)')
                cur.execute('CREATE TABLE infopoem (id_poem integer primary key, \
                name varchar(255), id_poet int, sex int, balad int, age int, \
                abiat int, id_baher int, rawi int, kafia int, arodh int, gharadh int, \
                naw3 int, tartib int, length int, fav int, recite int, reciter varchar(255), file_recite varchar(255))')
                cur.execute('CREATE TABLE kassaid (id_poem integer primary key, \
                nasse longtext(20000), sabab longtext(20000), charh longtext(20000), ta3lik longtext(20000))')
                info(None, 'تم إضافة قاعدة بيانات جديدة')
            d_config.setv('path', join(new_dir,'Dawawin.db'))  
            save_dlg.destroy()
        else:
            quit()
        save_dlg.destroy()
        
    # a المسار الافتراضي--------------------------
    elif res == 4:
        d_config.setv('path', DEFAULT_DATA)
        
    # a إلغاء التحديد----------------------------    
    else:
        quit()
    NEW_DIR  = dirname(d_config.getv('path'))
    MY_DATA   = join(NEW_DIR, 'Dawawin.db')
    AUDIO_DIR = join(NEW_DIR, 'Audio')
    BOOKS_DIR = join(NEW_DIR, 'Books')

else:
    MY_DATA   = d_config.getv('path')
    DATA_DIR  = dirname(MY_DATA)
    AUDIO_DIR = join(DATA_DIR, 'Audio')
    BOOKS_DIR = join(DATA_DIR, 'Books')

try:
    if not exists(AUDIO_DIR):
        mkdir(AUDIO_DIR)
except: pass
try:
    if not exists(BOOKS_DIR):
        mkdir(BOOKS_DIR)
except: pass

#a--------------------------------------------------

try: greet = Gtk.Window(Gtk.WindowType.POPUP)
except: 
    greet = Gtk.Window()
    greet.set_title("مرحبا !")
greet.set_border_width(15)
greet.set_position(Gtk.WindowPosition.CENTER_ALWAYS)
greet.set_size_request(400,300)
vb = Gtk.VBox(False, 10)
img_greet = Gtk.Image()
img_greet.set_from_file(join(ICON_DIR,"greet.png"))
vb.pack_start(img_greet, False, False, 0)
vb.pack_start(Gtk.Label('الإصدار {}\nجارٍ تحميل برنامج دواوين العرب....'.format(version, ))
              , False, False, 0)
greet.add(vb)
greet.show_all()
while (Gtk.events_pending()): Gtk.main_iteration()

#a------------------------------------------
def rgba(value):
    if value.startswith('#'):
        value = value.lstrip('#')
        v = int(len(value)/3)
        R = int(value[0:v], 16)/15.999**v
        G = int(value[v:2*v], 16)/15.999**v
        B = int(value[2*v:3*v], 16)/15.999**v
    elif value.startswith('rgba'):
        value = value.lstrip('rgba')
        v = eval(value)
        R = v[0]/255.0
        G = v[1]/255.0
        B = v[2]/255.0
    else:
        value = value.lstrip('rgb')
        v = eval(value)
        R = v[0]/255.0
        G = v[1]/255.0
        B = v[2]/255.0
    A = 1.0
    return Gdk.RGBA(R, G, B, A)

#a-------------------------------------------
def rgb(value):
    if value.startswith('#'):
        value = value.lstrip('#')
        v = int(len(value)/3)
        R = int(value[0:v], 16)/16**(v-2)
        G = int(value[v:2*v], 16)/16**(v-2)
        B = int(value[2*v:3*v], 16)/16**(v-2)
    elif value.startswith('rgba'):
        value = value.lstrip('rgba')
        v = eval(value)
        R = v[0]
        G = v[1]
        B = v[2]
    else:
        value = value.lstrip('rgb')
        v = eval(value)
        R = v[0]
        G = v[1]
        B = v[2]
    return  'rgb({}, {}, {})'.format(R, G, B)

#a------------------------------------------
def can_modify(parent):
    if MY_DATA.startswith('/usr'):
        dlg = Gtk.MessageDialog(parent, Gtk.DialogFlags.MODAL,
                                Gtk.MessageType.ERROR, Gtk.ButtonsType.CLOSE, 'لا يمكن التعديل على قاعدة البيانات إلا إذا قمت بنسخها إلى مسار تملك صلاحية التعديل عليه')
        dlg.run()
        dlg.destroy()
        return False
    else: return True
    
#a------------------------------------------           
def tashkil(text):
    if d_config.getv('tashkil') == '0': return d_araby.stripTashkeel(text)
    else: return text

#a------------------------------------------
class ButtonFace(Gtk.ToggleButton):
    __gtype_name__ = 'buttonface'
    def __init__(self, name, icon):
        Gtk.ToggleButton.__init__(self)
        box = Gtk.Box(spacing=0, orientation=Gtk.Orientation.VERTICAL)
        box.set_border_width(3)
        label = Gtk.Label()
        label.set_line_wrap(True)
        label.set_line_wrap_mode(Pango.WrapMode.WORD)
        label.set_text(name)
        label.set_alignment(0.5, 0.5)
        label.override_font(Pango.FontDescription('KacstOne 13'))
        pixbaf = GdkPixbuf.Pixbuf.new_from_file_at_size(join(ICON_DIR, icon), 36, 24)
        img = Gtk.Image.new_from_pixbuf(pixbaf)
        box.pack_start(img, False, False, 5)
        box.pack_start(label, False, False, 0)
        self.add(box)
        self.set_size_request(75, 75)
        
#a------------------------------------------
class ViewPoem(Gtk.TextView):
    __gtype_name__ = 'MyView'
    def __init__(self, *a):
        Gtk.TextView.__init__(self)
        self.set_cursor_visible(False)
        self.set_editable(False)
        self.set_right_margin(20)
        self.set_left_margin(20)
        self.set_wrap_mode(Gtk.WrapMode.WORD)
        
#a------------------------------------------        
class ScrollClass(Gtk.ScrolledWindow):
    __gtype_name__ = 'Myscroll'
    def __init__(self, *a):
        Gtk.ScrolledWindow.__init__(self)
        
#a------------------------------------------
class TreeClass(Gtk.TreeView):
    __gtype_name__ = 'Tree'
    def __init__(self, *a):
        Gtk.TreeView.__init__(self)
        
#a------------------------------------------
class ViewClass(Gtk.TextView):
    __gtype_name__ = 'View'
    def __init__(self, *a):
        Gtk.TextView.__init__(self)
        self.set_cursor_visible(False)
        self.set_editable(False)
        self.set_right_margin(10)
        self.set_left_margin(10)
        self.set_wrap_mode(Gtk.WrapMode.WORD)
        
#a------------------------------------------
class ViewEdit(Gtk.TextView):
    __gtype_name__ = 'View-editable'
    def __init__(self, *a):
        Gtk.TextView.__init__(self)
        self.set_right_margin(20)
        self.set_left_margin(20)
        self.set_wrap_mode(Gtk.WrapMode.WORD)
        
#a------------------------------------------
def tool_button(icon_file, tooltip, function, data=None):
        ''' Build custom toolbutton '''
        toolbtn = Gtk.ToolButton()
        widget = Gtk.Image.new_from_file(join(APP_DIR, icon_file))
        toolbtn.set_icon_widget(widget)
        toolbtn.set_tooltip_text(tooltip)
        toolbtn.connect('clicked', function, data)
        return toolbtn

#a------------------------------------------
def combo(ls, name, v):
    new_ls = []
    new_ls.extend(ls)
    hb = Gtk.Box(spacing=5, orientation=Gtk.Orientation.HORIZONTAL)
    store = Gtk.ListStore(int, str)
    cmt = Gtk.ComboBox.new_with_model(store)
    if v == 1:
        new_ls.insert(0, [0, 'الكل'])
    for a in new_ls:
        store.append(a)
    renderer_text = Gtk.CellRendererText()
    renderer_text.set_property("ellipsize-set", True)
    #renderer_text.set_property("max-width-chars",10)
    renderer_text.set_property("weight",14)
    renderer_text.set_property("ellipsize", Pango.EllipsizeMode.END)
    cmt.pack_start(renderer_text, True)
    cmt.add_attribute(renderer_text, "text", 1)
    lab = Gtk.Label(name)
    lab.set_alignment(0,0.5)
    if v == 3:
        lab.set_size_request(200, 8)
        cmt.set_size_request(150, -1)
    elif v == 4:
        lab.set_size_request(40, -1)
        cmt.set_size_request(40, -1)
    else:
        lab.set_size_request(50, -1)
        cmt.set_size_request(120, -1)
    hb.pack_start(lab, False, False, 0)
    hb.pack_end(cmt, False, False, 0)
    if v == 1:
        cmt.set_active(0)
    return hb, cmt

#a------------------------------------------
def combo_all(ls, name):
    new_ls = []
    new_ls.extend(ls) 
    store = Gtk.ListStore(int, str)
    cmt = Gtk.ComboBox.new_with_model(store)
    new_ls.insert(0, [0, name])
    for a in new_ls: store.append(a)
    renderer_text = Gtk.CellRendererText()
    cmt.pack_start(renderer_text, True)
    cmt.add_attribute(renderer_text, "text", 1) 
    cmt.set_size_request(150, -1)
    cmt.set_active(0)
    cmt.set_wrap_width(int(len(ls)/6)+1)
    return cmt

#a------------------------------------------
def value_active(combo):
    if combo.get_active() == -1: return None
    v = combo.get_active_iter()
    model = combo.get_model()
    value = model.get_value(v, 0)
    return value

#a------------------------------------------
def text_active(combo):
    if combo.get_active() == -1: return None
    v = combo.get_active_iter()
    model = combo.get_model()
    value = model.get_value(v, 1)
    return value

#a------------------------------------------
def search_and_mark(text_buff, text_tag, text, start):
    end = text_buff.get_end_iter()
    match = start.forward_search(text, 0, end)
    if match != None:
        match_start, match_end = match
        text_buff.apply_tag(text_tag, match_start, match_end)
        search_and_mark(text_buff, text_tag, text, match_end)
        
def with_tag(text_buff, text_tag, ls):
    for text in ls:
        cursor_mark = text_buff.get_insert()
        start = text_buff.get_iter_at_mark(cursor_mark)
        if start.get_offset() == text_buff.get_char_count():
            start = text_buff.get_start_iter()
        search_and_mark(text_buff, text_tag, text, start)
        
#a------------------------------------------
class Buttonfun(Gtk.Button):
    __gtype_name__ = 'Buttonfun'
    def __init__(self, name, theme):
        Gtk.Button.__init__(self)
        label = Gtk.Label()
        label.set_text(name)
        self.set_size_request(-1, 65)
        self.set_name(name)
        self.set_relief(Gtk.ReliefStyle.NONE)
        label.override_font(Pango.FontDescription(theme.fontmp))
        label.override_color(Gtk.StateFlags.NORMAL, rgba(theme.colormp)) 
        self.add(label)

#a------------------------------------------
class TreePoem(Gtk.TreeView):
    __gtype_name__ = 'Treepoem'
    def __init__(self, *a):
        Gtk.TreeView.__init__(self)
