# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
##############################################################################

from gi.repository import Gtk, Pango
from d_contacts import MyDB
from d_viewer import ShowPoem
from d_tablabel import TabLabel
import d_config, d_tools, d_araby, d_customs


     
# class صفحة الدواوين--------------------------------------------------------
        
class dawawin_page(Gtk.HPaned):
    
    def change_font(self, *a):
        self.tarjama_tag.set_property('foreground', self.parent.theme.coloran) 
        self.tarjama_tag.set_property('font', self.parent.theme.fontan)
    
    def search_on_page(self, text):
        if len(self.poems_store) == 0: return
        self.notebook.set_current_page(1)
        self.theword0 = [text]
        self.modelfilter0.refilter()
    
    def near_page(self, v):
        if self.notebook.get_current_page() == 0:
            self.size_font_tarjama += v
            self.tarjama.override_font(Pango.FontDescription("{}".format(self.size_font_tarjama,))) 
        else:
            self.size_font_dawawin += v
            self.tree_poems.override_font(Pango.FontDescription("{}".format(self.size_font_dawawin,))) 
    
    def on_button_press(self, widget, event):
        if event.button == 3:
            self.popup.show_all()
            self.popup.popup(None, None, None, None, 3,
                             Gtk.get_current_event_time())
        elif event.button == 1 and event.get_click_count()[1] == 2:
            self.show_poem_cb()
    
                
    def modify_poem_cb(self, *a):
        if d_customs.can_modify(self.parent):
            model0, i0 = self.tree_poet.get_selection().get_selected()
            model, i = self.tree_poems.get_selection().get_selected()
            if i and i0:
                nm_poem = model.get_value(i, 2)
                nm_poet = model0.get_value(i0, 1)
                self.parent.main_notebook.set_current_page(5)
                if nm_poet == "أحدهم": nm_poet = 'ما لا يعرف قائله'
                self.parent.organiz.search_poets.set_text(nm_poet)
                self.parent.organiz.sel_poet.select_path((0,))
                self.parent.organiz.ok_poet()
                self.parent.entry_search.set_text(nm_poem)
                self.parent.organiz.sel_poem.select_path((0,))
                self.parent.organiz.ok_poem()
                self.parent.organiz.nbk1.set_current_page(0)
                self.parent.entry_search.set_text('')
    
    def show_poem_cb(self, *a):
        model, i = self.tree_poems.get_selection().get_selected()
        if i:
            id_poem = model.get_value(i,0)
            text = model.get_value(i,2)
            self.parent.poems_tgl.set_sensitive(True)
            n = self.parent.viewerpoem.get_n_pages()
            for s in range(n):
                ch = self.parent.viewerpoem.get_nth_page(s)
                if self.parent.viewerpoem.get_tab_label(ch).nm == text:
                    self.parent.viewerpoem.set_current_page(s)
                    self.parent.main_notebook.set_current_page(3)
                    return
            sr = ShowPoem(self.parent)
            sr.loading(id_poem, self.parent.theme.fontmp)
            self.parent.viewerpoem.append_page(sr,TabLabel(sr, text))
            self.parent.viewerpoem.show_all()
            self.parent.viewerpoem.set_current_page(-1)
            self.parent.main_notebook.set_current_page(3)
    
    def visible_cb0(self, model, itr, data):
        if len(self.theword0) == 0: return
        if d_araby.fuzzy(self.theword0[0]) in d_araby.fuzzy(model.get_value(itr, 2)):
            return True
        else: return False
        
    def ok_poet(self, *a):
        model, i = self.sel_poet.get_selected()
        if i:
            id_poet = model.get_value(i,0)
            d_config.setv('site', id_poet)
            self.to_poet(id_poet)
            
    def to_poet(self, id_poet):
        list_poems, tarjama = self.db.poems_of_poet(id_poet)
        nm_poet, lakab = self.db.name_poet(id_poet)
        self.tarjama_bfr.set_text(lakab+' : \n'+nm_poet+'، '+tarjama)
        ls = [lakab+' : ',]
        d_customs.with_tag(self.tarjama_bfr, self.tarjama_tag, ls)
        self.poems_store.clear()
        n = self.notebook.get_current_page()
        if n > 1:
            self.notebook.set_current_page(d_config.getn('open'))
        if len(list_poems) != 0:
            self.names_list0 = []
            self.modelfilter0 = self.poems_store.filter_new()
            for a in list_poems:
                i = a[0]
                rakm = list_poems.index(a, )+1
                name = a[1]
                abiat = a[2]
                if a[3] != 0: baher = d_tools.get_name(d_tools.elbehor, a[3])
                else: baher = '____'
                if a[4] != 0: rawi = d_tools.get_name(d_tools.elrawi, a[4])
                else: rawi = '____'
                if a[6] != 0: gharadh = d_tools.get_name(d_tools.elgharadh, a[6])
                else: gharadh = '____'
                if a[7] != 0: naw3 = d_tools.get_name(d_tools.elnaw3, a[7])
                else: naw3 = '____'
                self.poems_store.append([i, rakm, name, naw3, baher, gharadh, rawi, abiat])
                self.names_list0.append(name)
            self.theword0 = self.names_list0[:]
            self.modelfilter0.set_visible_func(self.visible_cb0, self.theword0) 
            self.tree_poems.set_model(self.modelfilter0)
        lab = ' {} ، {}  .: {} :.'.format(d_tools.nn_abiat_poems(self.db.n_poems_poet(id_poet), 1),
                                                                 d_tools.nn_abiat_poems(self.db.n_verses_poet(id_poet), 2),
                                                                 (self.db.name_poet(id_poet)[1]))
        self.lab_count.set_label(lab)

    
    def visible_cb(self, model, itr, data):
        if len(self.theword) == 0: return
        if d_araby.fuzzy(self.theword[0][0]) in d_araby.fuzzy(model.get_value(itr, 1)) and\
        (self.theword[0][1] == model.get_value(itr, 2) or self.theword[0][1] == 0) and\
        (self.theword[0][2] == model.get_value(itr, 3) or self.theword[0][2] == 0) and\
        (self.theword[0][3] == model.get_value(itr, 4) or self.theword[0][3] == 0):
            return True
        else: return False
        
    def search_cb(self, *a):
        self.theword = [[self.search_poets.get_text(), 
        d_customs.value_active(self.sexs),d_customs.value_active(self.lands),  d_customs.value_active(self.ages)]]
        self.modelfilter.refilter()
        
    def select_age(self, *a):
        if d_customs.value_active(self.ages) == 8: self.lands.set_sensitive(True)
        else:
            self.lands.set_active(0)
            self.lands.set_sensitive(False)
            
    def refresh_poets(self, *a):
        self.store_poet.clear()
        self.modelfilter = self.store_poet.filter_new()
        ls = self.db.all_poets()
        ls.append([0, 'ما لا يعرف قائله', 0, 22, 9])
        self.names_list = []
        n = 0
        for a in ls:
            if a[0] == d_config.getn('site'):
                self.path_site = (n,)
            n += 1
            s_list = []
            self.store_poet.append(a)
            s_list.append(a[1])
            s_list.append(a[2])
            s_list.append(a[3])
            s_list.append(a[4])
            self.names_list.append(s_list)
        self.theword = self.names_list[:]
        self.modelfilter.set_visible_func(self.visible_cb, self.theword) 
        self.tree_poet.set_model(self.modelfilter)
        
        iter0 = self.modelfilter.get_iter(self.path_site)
        self.tree_poet.get_selection().select_iter(iter0)
        self.tree_poet.scroll_to_cell(self.path_site)
        self.ok_poet()
    
    def fav_poem_cb(self, *a):
        if d_customs.can_modify(self.parent):
            model, i = self.tree_poems.get_selection().get_selected()
            if i:
                id_poem = model.get_value(i,0)
                check = self.parent.db.to_favorite(id_poem)
                if check == None:
                    d_customs.info(self.parent, 'تم إضافة هذه القصيدة للمفضلة')
                    
    def assemble_poem_cb(self, *a):
        if d_customs.can_modify(self.parent):
            model, i = self.tree_poems.get_selection().get_selected()
            if i:
                id_poem = model.get_value(i,0)
                self.parent.to_assemble(id_poem)
                
    def fav_poet_cb(self, *a):
        if d_customs.can_modify(self.parent):
            model, i = self.tree_poems.get_selection().get_selected()
            if i:
                id_poem = model.get_value(i,0)
                id_poet = self.parent.db.id_poet(id_poem)
                check = self.parent.db.to_fav_poet(id_poet)
                if check == None:
                    d_customs.info(self.parent, 'تم إضافة هذا الديوان للمفضلة')
    
    def __init__(self, parent):
        self.parent = parent
        self.path_site = 0
        self.db = MyDB()
        self.size_font_tarjama = int(self.parent.theme.fontch[-2:])
        self.size_font_dawawin = int(self.parent.theme.fonttp[-2:])
        Gtk.HPaned.__init__(self)
        self.set_position(250)
        
        self.vbox = Gtk.Box(spacing=2,orientation=Gtk.Orientation.VERTICAL)
        
        self.ages = d_customs.combo_all(d_tools.age_poet, 'كلّ العصور')
        self.vbox.pack_start(self.ages, False, False, 0)
        self.ages.connect('changed', self.search_cb)
        self.ages.connect('changed', self.select_age)
        
        self.lands = d_customs.combo_all(d_tools.elbalad, 'كلّ البلدان')
        self.lands.set_sensitive(False)
        self.vbox.pack_start(self.lands, False, False, 0)
        self.lands.connect('changed', self.search_cb)
        
        self.sexs = d_customs.combo_all(d_tools.sex_poet, 'كلا الجنسين')
        self.vbox.pack_start(self.sexs, False, False, 0)
        self.sexs.connect('changed', self.search_cb)
        
        self.search_poets = Gtk.SearchEntry()
        self.search_poets.set_placeholder_text('بحث عن شاعر')
        self.search_poets.connect('changed', self.search_cb)
        self.vbox.pack_start(self.search_poets, False, False, 0)
        
        self.store_poet = Gtk.ListStore(int, str, int, int, int)
        self.tree_poet = d_customs.TreeClass()
        self.tree_poet.set_headers_visible(False)
        cell = Gtk.CellRendererText()
        #cell.set_property("ellipsize", Pango.EllipsizeMode.END)
        kal = Gtk.TreeViewColumn('الشعراء', cell, text=1)
        self.tree_poet.append_column(kal)
        self.sel_poet = self.tree_poet.get_selection()
        self.tree_poet.connect("cursor-changed", self.ok_poet)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_poet)
        
        self.vbox.pack_start(scroll, True, True, 0)
        
        vbox2 = Gtk.Box(spacing=3,orientation=Gtk.Orientation.VERTICAL)
        self.notebook = Gtk.Notebook()
        self.notebook.set_scrollable(True)
        self.tarjama = d_customs.ViewClass()
        self.tarjama_bfr = self.tarjama.get_buffer()
        self.tarjama_tag = self.tarjama_bfr.create_tag("title")
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tarjama)
        lab = Gtk.Label("الترجمة")
        lab.set_size_request(150, -1)
        self.notebook.append_page(scroll, lab)
        
        self.poems_store = Gtk.ListStore(int,int,str,str,str,str,str,int)
        
        self.tree_poems = d_customs.TreePoem()
        
        vbox = Gtk.Box(spacing=3, orientation=Gtk.Orientation.VERTICAL)
        self.lab_count = Gtk.Label('  القصائد :   ، الأبيات :    .:   :.    ')
        self.lab_count.override_font(Pango.FontDescription('Bold'))
        self.lab_count.set_alignment(0, 0.5)
        self.lab_count.set_ellipsize(Pango.EllipsizeMode.END)
        self.tree_poems.set_grid_lines(Gtk.TreeViewGridLines.HORIZONTAL)
        self.tree_poems.connect("button-press-event", self.on_button_press)
        raq = Gtk.TreeViewColumn('#', Gtk.CellRendererText(), text=1)
        self.tree_poems.append_column(raq)
        poems = Gtk.TreeViewColumn('القصيدة', Gtk.CellRendererText(), text=2)
        self.tree_poems.append_column(poems)
        elnaw3 = Gtk.TreeViewColumn('النوع', Gtk.CellRendererText(), text=3)
        self.tree_poems.append_column(elnaw3)
        elbaher = Gtk.TreeViewColumn('البحر', Gtk.CellRendererText(), text=4)
        self.tree_poems.append_column(elbaher)
        elgharadh = Gtk.TreeViewColumn('الغرض', Gtk.CellRendererText(), text=5)
        self.tree_poems.append_column(elgharadh)
        elrawi = Gtk.TreeViewColumn('الروي', Gtk.CellRendererText(), text=6)
        self.tree_poems.append_column(elrawi)
        verses = Gtk.TreeViewColumn('عدد الأبيات', Gtk.CellRendererText(), text=7)
        verses.set_expand(True)
        self.tree_poems.append_column(verses)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_poems)
        vbox.pack_start(scroll, True, True, 0)
        lab = Gtk.Label("القصائد")
        lab.set_size_request(150, -1)
        self.notebook.append_page(vbox, lab)
        
        def switch(widget, p, n):
            d_config.setv('open', n)
        self.notebook.connect('switch-page', switch)
        
        vbox2.pack_start(self.notebook, True, True, 0)
        vbox2.pack_start(self.lab_count, False, False, 0)
        self.pack1(self.vbox, False, False)
        self.pack2(vbox2, True, False)
        self.change_font()
        
        #--- Popup menu
        self.popup = Gtk.Menu()
        show_poem = Gtk.ImageMenuItem('اعرض القصيدة')
        show_poem.connect('activate', self.show_poem_cb)
        self.popup.append(show_poem)
        
        modify_poem = Gtk.ImageMenuItem('عدّل القصيدة')
        modify_poem.connect('activate', self.modify_poem_cb)
        self.popup.append(modify_poem)
        
        fav_poem = Gtk.ImageMenuItem('فضّل القصيدة')
        fav_poem.connect('activate', self.fav_poem_cb)
        self.popup.append(fav_poem)
        
        assemble_poem = Gtk.ImageMenuItem('أضفها لمجموع')
        assemble_poem.connect('activate', self.assemble_poem_cb)
        self.popup.append(assemble_poem)
        
        fav_poet = Gtk.ImageMenuItem('فضّل الديوان')
        fav_poet.connect('activate', self.fav_poet_cb)
        self.popup.append(fav_poet)
        self.popup.show_all()
        self.refresh_poets()
        self.show_all()
        self.notebook.set_current_page(d_config.getn('open'))