# -*- coding: utf-8 -*-

#a############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
#a############################################################################

from gi.repository import Gtk, Pango
import d_araby, d_customs, d_stemming
from d_contacts import DictDB
import re

# class نافذة المعاجم---------------------------------------------------------    

class Explanatory(Gtk.Box):
    
    def show_terms(self, term):
        nasse0 = self.view_dict_bfr.get_text(self.view_dict_bfr.get_start_iter(), 
                                            self.view_dict_bfr.get_end_iter(),True)
        new_term = ''
        search_tokens = []
        if len(term) ==3:
            if term[1] == term[2]:
                term = term[:2]+'ا'+term[2:]
        for l in term:
            new_term += '({}(\u0651)?([\u064b\u064c\u064d\u064e\u064f\u0650\u0652])?)'.format(l, )
        if 'ا' in new_term: new_term = new_term.replace('ا', '[اأآإؤويءئى]')
        elif 'أ' in new_term: new_term = new_term.replace('أ', '[آاأإؤويءئى]')
        new_term = new_term.replace('ه', '[هة]')
        re_term = re.compile('({})'.format(new_term,))
        r_findall = re_term.findall(nasse0)
        for r in r_findall:
            try: 
                if r[0] not in search_tokens: search_tokens.append(r[0])
            except: pass
        d_customs.with_tag(self.view_dict_bfr, self.anawin_tag, search_tokens)
    
    def show_charh(self, *a):
        model, i = self.sel_dict.get_selected()
        if i:
            p = model.get_path(i)
            if model.iter_has_child(i) :
                if self.tree_dict.row_expanded(p):
                    self.tree_dict.collapse_row(p)
                else: self.tree_dict.expand_row(p, False) 
            else:
                term = model.get_value(i, 0)
                dicte = model.get_value(i, 1)
                charh = self.mydict.show_charh(term, dicte)
                self.view_dict_bfr.set_text(charh[0][0]) 
                self.show_terms(term)
    
    def search_on_page(self, text):
        self.show_charh()
        while (Gtk.events_pending()): Gtk.main_iteration()
        search_tokens = []
        nasse = self.view_dict_bfr.get_text(self.view_dict_bfr.get_start_iter(), 
                                            self.view_dict_bfr.get_end_iter(),True).split()
        if text == '': 
            for a in self.all_term:
                txt = d_araby.fuzzy(a)
                for term in nasse: 
                    if txt in d_araby.fuzzy(term):
                        search_tokens.append(term)
        else:
            txt = d_araby.fuzzy(text)
            for term in nasse: 
                if txt in d_araby.fuzzy(term):
                    search_tokens.append(term)
        d_customs.with_tag(self.view_dict_bfr, self.search_tag, search_tokens)
    
    def search_on_active(self, text):
        if text == '': return
        elif len(text) < 3: 
            d_customs.erro(self.parent, 'أدخل كلمة بها أكثر من حرفين للبحث عنها')
            return
        all_root, all_term = d_stemming.get_root(''+text)
        self.tree_dict.collapse_all()
        self.store_dict.clear()
        self.view_dict_bfr.set_text('')
        if len(all_root['lisan'])+len(all_root['mekhtar']) == 0:
                d_customs.erro(self.parent, 'لا يوجد نتيجة'); return
        if len(all_root['lisan']) != 0: 
            a1 = self.store_dict.append(None, ['لسان العرب', 'lisan'])
            for text in all_root['lisan']:
                self.store_dict.append(a1, [text, 'lisan'])
        if len(all_root['mekhtar']) != 0: 
            a4 = self.store_dict.append(None, ['مختار الصحاح', 'mekhtar'])
            for text in all_root['mekhtar']:
                self.store_dict.append(a4, [text, 'mekhtar'])
        self.all_term = all_term
                
    def near_page(self, v):
        self.size_font += v
        self.view_dict.override_font(Pango.FontDescription("{}".format(self.size_font,))) 
    
    def show_index(self, f_letter, mdict):
        self.tree_dict.collapse_all()
        self.store_dict.clear()
        self.view_dict_bfr.set_text('')
        while (Gtk.events_pending()): Gtk.main_iteration()
        if mdict == 1 or mdict == 0:
            all_index = self.mydict.all_index('lisan', f_letter)
            if len(all_index) > 0:
                a1 = self.store_dict.append(None, ['لسان العرب', 'lisan'])
                for a in all_index:
                    self.store_dict.append(a1, [a[0], 'lisan'])
        if mdict == 2 or mdict == 0:
            all_index = self.mydict.all_index('mekhtar', f_letter)
            if len(all_index) > 0:
                a4 = self.store_dict.append(None, ['مختار الصحاح', 'mekhtar'])
                for a in all_index:
                    self.store_dict.append(a4, [a[0], 'mekhtar'])
    
    def select_letter(self, *a):
        if self.btn_letters.get_active() == 0:
            self.store_dict.clear() 
            return
        letter = d_customs.text_active(self.btn_letters)
        f_letter = letter[0]
        mdict = d_customs.value_active(self.btn_dicts)
        self.show_index(f_letter, mdict)
    
    def select_dict(self, *a):
        mdict = d_customs.value_active(self.btn_dicts)
        if self.btn_letters.get_active() != 0: 
            letter = d_customs.text_active(self.btn_letters)
            f_letter = letter[0]
            self.show_index(f_letter, mdict)
    
    def __init__(self, parent):
        self.parent = parent
        self.mydict = DictDB()
        self.size_font = int(self.parent.theme.fontch[-2:])
        self.all_term = []
        Gtk.Box.__init__(self, spacing=1, orientation=Gtk.Orientation.HORIZONTAL)
        self.tree_dict = d_customs.TreeClass()
        self.tree_dict.set_headers_visible(False)
        self.sel_dict = self.tree_dict.get_selection()
        cell = Gtk.CellRendererText()
        kal = Gtk.TreeViewColumn('الجذور', cell, text=0)
        self.tree_dict.append_column(kal)
        self.store_dict = Gtk.TreeStore(str, str)
        self.tree_dict.set_model(self.store_dict)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_dict)
        self.tree_dict.connect("cursor-changed", lambda *a: self.search_on_page(""))
        scroll.set_policy(Gtk.PolicyType.NEVER, Gtk.PolicyType.AUTOMATIC)
        
        vbox = Gtk.Box(spacing=1,orientation=Gtk.Orientation.VERTICAL)
        
        letters = [ 
            [1, "ألف"], 
            [2, "باء"], 
            [3, 'تاء' ], 
            [4, 'ثاء' ],
            [5, 'جيم' ], 
            [6, 'حاء' ], 
            [7, 'خاء' ], 
            [8, 'دال' ], 
            [9, 'ذال' ],
            [10, 'راء' ], 
            [11, 'زاي' ], 
            [12, 'سين' ], 
            [13, 'شين' ], 
            [14, 'صاد' ],
            [15, 'ضاد' ], 
            [16, 'طاء' ], 
            [17, 'ظاء' ], 
            [18, 'عين' ], 
            [19, 'غين' ],
            [20, 'فاء' ], 
            [21, 'قاف' ], 
            [22, 'كاف' ], 
            [23, 'لام' ], 
            [24, 'ميم' ],
            [25, 'نون' ], 
            [26, 'هاء' ], 
            [27, 'واو' ], 
            [28, 'ياء' ],
            ]
        self.btn_letters = d_customs.combo_all(letters, 'اختر حرفًا')
        self.btn_letters.set_wrap_width(4)
        self.btn_letters.connect('changed', self.select_letter)
        dicts = [
                 [1, 'لسان العرب'], 
                 [2, 'مختار الصحاح'] 
                 ]
        self.btn_dicts = d_customs.combo_all(dicts, 'جميع المعاجم')
        self.btn_dicts.connect('changed', self.select_dict)
        
        buttonbox = Gtk.ButtonBox.new(Gtk.Orientation.VERTICAL)
        buttonbox.set_layout(Gtk.ButtonBoxStyle.CENTER)
        buttonbox.set_spacing(1)
        
        buttonbox.add(self.btn_dicts)
        buttonbox.add(self.btn_letters)
        vbox.pack_start(buttonbox, False, False, 0)
        vbox.pack_start(scroll, True, True, 0)
        
        self.view_dict = d_customs.ViewClass()
        self.view_dict_bfr = self.view_dict.get_buffer()
        self.search_tag = self.view_dict_bfr.create_tag("search")
        self.search_tag.set_property('background', self.parent.theme.colorss) 
        self.anawin_tag = self.view_dict_bfr.create_tag("anawin")
        self.anawin_tag.set_property('foreground', self.parent.theme.coloran) 
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.view_dict)
        self.pack_start(vbox, False, False, 0)
        self.pack_start(scroll, True, True, 0)
        
        self.show_all()