# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
##############################################################################

from shutil import copyfile
from os.path import join, exists
from os import mkdir
from gi.repository import Gtk, Pango
#from gi.repository import WebKit
import d_config, d_customs

fontan  = 'KacstOne 15'
colormp = '#202040400000'
coloran = '#868609091515'
colorb  = '#fdfdfdfdd7d7'

#wv = WebKit.WebView()

class Exporter(object):
    
    def __init__(self, parent, name_poem, name_poet, text_poem, font):
        self.parent = parent
        self.background_image = d_config.getv('ornament-file')
        if d_config.getv('theme') == '5':
            self.colorb = d_customs.rgb(d_config.getv('colorb'))
            self.colormp = d_customs.rgb(d_config.getv('colormp'))
            self.coloran = d_customs.rgb(d_config.getv('coloran'))
            self.fontan = d_config.getv('fontan')
        else:
            self.colorb = d_customs.rgb(colorb)
            self.colormp = d_customs.rgb(colormp)
            self.coloran = d_customs.rgb(coloran)
            self.fontan = fontan
            
        self.name_poem = name_poem
        self.name_poet = name_poet
        self.text_poem = text_poem
        fdmp = Pango.FontDescription(font)
        self.fontmp_family = fdmp.get_family()
        self.fontmp_size = font[-2:]+'px'
        fdan = Pango.FontDescription(self.fontan)
        self.fontan_family = fdan.get_family()
        self.fontan_size = self.fontan[-2:]+'px'

    def make_html(self, *a):
        background = 'background-color: {};'.format(self.colorb,)
        html_text = self.text_poem.replace('\n', '\n<br>').replace(' ', '&nbsp;')
        if d_config.getv('theme') == '0':
            template = [
                        '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"', 
                        '"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">', 
                        '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">', 
                        '<head>', 
                        '<title>{}</title>'.format(self.name_poem,), 
                        '<meta http-equiv="content-type" content="text/html; charset=utf-8" />', 
                        '<style type="text/css">', 
                        'body {', 
                        'text-align: center; ', 
                        '}', 
                        'span.speaker{', 
                        'font-family: {};'.format(self.fontan_family,), 
                        'font-size: {};'.format(self.fontan_size,), 
                        'color: {};'.format(self.coloran,), 
                        '}', 
                        'span.nasse{', 
                        'font-family: {};'.format(self.fontmp_family,), 
                        'font-size: {};'.format(self.fontmp_size,), 
                        '}', 
                        '</style>', 
                        '</head>', 
                        '<body dir="rtl">', 
                        '<span class="speaker">{}</span><br>'.format(self.name_poet,), 
                        '<span class="nasse">{}</span>'.format(html_text,), 
                        '</body>', 
                        '</html>']
        else:
            template = [
                        '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"', 
                        '"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">', 
                        '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">', 
                        '<head>', 
                        '<title>{}</title>'.format(self.name_poem,), 
                        '<meta http-equiv="content-type" content="text/html; charset=utf-8" />', 
                        '<style type="text/css">', 
                        'body {', 
                        'text-align: center; ', 
                        '{}'.format(background,), 
                        '}', 
                        'span.speaker{', 
                        'font-family: {};'.format(self.fontan_family,), 
                        'font-size: {};'.format(self.fontan_size,), 
                        'color: {};'.format(self.coloran,), 
                        '}', 
                        'span.nasse{', 
                        'font-family: {};'.format(self.fontmp_family,), 
                        'font-size: {};'.format(self.fontmp_size,), 
                        'color: {};'.format(self.colormp,), 
                        '}', 
                        '</style>', 
                        '</head>', 
                        '<body dir="rtl">', 
                        '<span class="speaker">{}</span><br>'.format(self.name_poet,), 
                        '<span class="nasse">{}</span>'.format(html_text,), 
                        '</body>', 
                        '</html>']
        text =  '\n'.join(template)
        return text
    
    def dlg_dest(self):
        dir_save = None
        save_dlg = Gtk.FileChooserDialog("اختر المجلد الذي تريد التصدير إليه", self.parent,
                                    Gtk.FileChooserAction.SELECT_FOLDER,
                                    (Gtk.STOCK_OK, Gtk.ResponseType.OK,
                                    Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL))
        res = save_dlg.run()
        if res == Gtk.ResponseType.OK:
            dir_save = save_dlg.get_filename()
        save_dlg.destroy()
        return dir_save
    
    def export_html(self, *a):    
        template = self.make_html()
        dir_save = self.dlg_dest()
        if dir_save == None: return
        if not exists(join(dir_save, self.name_poem)):
            try:  mkdir(join(dir_save, self.name_poem))
            except: raise
        file_save = open(join(dir_save, self.name_poem, self.name_poem+'.html'), 'w')
        file_save.write(template)
        file_save.close()
            
    def export_txt(self, *a):    
        template = self.text_poem
        dir_save = self.dlg_dest()
        if dir_save == None: return
        if not exists(join(dir_save, self.name_poem)):
            try:  mkdir(join(dir_save, self.name_poem))
            except: raise
        file_save = open(join(dir_save, self.name_poem, self.name_poem+'.txt'), 'w')
        file_save.write(template)
        file_save.close()
     
    def print_pdf(self, action, *a, **kw):
        """
        html = self.make_html()
        wv.load_html_string(html,'file:///')
        return getattr(wv, action)(*a,**kw)
        """
