

# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
##############################################################################

from os.path import join, dirname, realpath, exists
from gi.repository import Gtk, Gdk, GdkPixbuf, Pango
import d_customs, d_config, d_tools
from d_viewer import ShowPoem
from d_tablabel import TabLabel
from os import mkdir, remove
from shutil import rmtree


COL_NAME = 0
COL_PIXBUF = 1
COL_ID = 2

# class نافذة قائمة الكتب-----------------------------------------------------------------------

class Favorites(Gtk.Box):
    
    def __init__(self, parent):
        self.parent = parent
        self.build()

    def search_on_page(self, *a):
        return
    
    def search_on_active(self, *a):
        return

    def show_last_poems(self, *a): 
        list_history = eval(d_config.getv('history'))
        self.store_icon.clear()
        for a in reversed(list_history):
            n_abiat = self.parent.db.abiat_poem(a[0])
            name_poet = self.parent.db.name_poet(self.parent.db.id_poet(a[0]))[1]
            text = a[1]+'\n'+name_poet+'\n'+d_tools.nn_abiat_poems(n_abiat, 2)
            self.store_icon.append([text, self.poem_history_icon, a[0]])          
    
    def show_fav_poets(self, *a): 
        list_fav_poets = self.parent.db.favorite_poets()
        self.store_icon.clear()
        for a in reversed(list_fav_poets):
            n_poems = self.parent.db.n_poems_poet(a[0])
            n_abiat = self.parent.db.n_verses_poet(a[0])
            name_poet = self.parent.db.name_poet(a[0])[1]
            text = 'ديوان '+name_poet+'\n'+d_tools.nn_abiat_poems(n_poems, 1)+'\n'+d_tools.nn_abiat_poems(n_abiat, 2)
            self.store_icon.append([text, self.poem_poets_icon, a[0]]) 
    
    def show_fav_poems(self, *a):
        list_fav_poems = self.parent.db.favorite_poems()
        self.store_icon.clear()
        for a in reversed(list_fav_poems):
            n_abiat = self.parent.db.abiat_poem(a[0])
            name_poet = self.parent.db.name_poet(self.parent.db.id_poet(a[0]))[1]
            text = a[1]+'\n'+name_poet+'\n'+d_tools.nn_abiat_poems(n_abiat, 2)
            self.store_icon.append([text, self.poem_fav_icon, a[0]]) 
    
    def show_poems_recite(self, *a): 
        list_recite_poems = self.parent.db.recited_poems()
        self.store_icon.clear()
        for a in reversed(list_recite_poems):
            n_abiat = self.parent.db.abiat_poem(a[0])
            name_poet = self.parent.db.name_poet(self.parent.db.id_poet(a[0]))[1]
            text = a[1]+'\n'+name_poet+'\n'+d_tools.nn_abiat_poems(n_abiat, 2)+'\nإلقاء: '+a[3]
            self.store_icon.append([text, self.poem_recite_icon, a[0]]) 

    def show_page(self, n):
        if n == '0': self.show_last_poems()
        elif n == '1': self.show_fav_poets()
        elif n == '2': self.show_fav_poems()
        elif n == '4': self.show_poems_recite()
        elif n == '5': self.show_fav_poets()
        self.n_p = n

    def on_button_press(self, widget, event):
        if event.button == 3:
            self.popup.show_all()
            self.popup.popup(None, None, None, None, 3,
                             Gtk.get_current_event_time())

    def del_item_cb(self, *a):
        item = self.iconview.get_selected_items() 
        if len(item) > 0:
            id_item = self.store_icon[item[0]][COL_ID]
            res = d_customs.sure(self.parent, 'هل تريد حذف العنصر المحدد؟')
            if res == -8:
                if self.n_p == '0': 
                    self.store_icon.remove(self.store_icon.get_iter(item[0]))
                    list_history = eval(d_config.getv('history'))
                    for a in list_history:
                        if a[0] == id_item: list_history.remove(a)
                    d_config.setv('history', repr(list_history))
                else:
                    if d_customs.can_modify(self.parent):
                        if self.n_p == '1': 
                            check = self.parent.db.out_fav_poet_one(id_item)
                            if check == None: self.store_icon.remove(self.store_icon.get_iter(item[0]))
                        elif self.n_p == '2': 
                            check = self.parent.db.out_favorite_one(id_item)
                            if check == None: self.store_icon.remove(self.store_icon.get_iter(item[0]))
                        elif self.n_p == '4': 
                            check = self.parent.db.remove_recite_one(id_item)
                            if check == None: 
                                self.store_icon.remove(self.store_icon.get_iter(item[0]))
                                file_media = join(d_customs.AUDIO_DIR, self.parent.db.is_recited(id_item)[2])
                                if exists(file_media): 
                                    remove(file_media)
        else: d_customs.erro(self.parent, 'أنت لم تحدد أي عنصر')

    def del_allitems_cb(self, *a):
        res = d_customs.sure(self.parent, 'هل تريد حذف جميع العناصر؟')
        if res == -8:
            if self.n_p == '0': 
                d_config.setv('history', '[]')
                self.list_history = []
                self.store_icon.clear()
            else:
                if d_customs.can_modify(self.parent):
                    if self.n_p == '1': 
                        check = self.parent.db.out_fav_poet_all()
                        if check == None: self.store_icon.clear()
                    elif self.n_p == '2': 
                        check = self.parent.db.out_favorite_all()
                        if check == None: self.store_icon.clear()
                    elif self.n_p == '4': 
                        check = self.parent.db.remove_recite_all()
                        if check == None: self.store_icon.clear()
                        res = d_customs.sure(self.parent, 'هل تريد حذف الملفات الصوتية أيضا؟')
                        if res == -8: rmtree(d_customs.AUDIO_DIR)

    def item_active(self, widget, path):
        item = widget.get_selected_items()
        model = widget.get_model()
        id_item = model[item[0]][COL_ID]
        if self.n_p in ['0', '2', '4']: 
            text = self.parent.db.poem_info(id_item)[1]
            self.parent.poems_tgl.set_sensitive(True)
            n = self.parent.viewerpoem.get_n_pages()
            for s in range(n):
                ch = self.parent.viewerpoem.get_nth_page(s)
                if self.parent.viewerpoem.get_tab_label(ch).nm == text:
                    self.parent.viewerpoem.set_current_page(s)
                    self.parent.main_notebook.set_current_page(3)
                    return
            sr = ShowPoem(self.parent)
            sr.loading(id_item, self.parent.theme.fontmp)
            self.parent.viewerpoem.append_page(sr,TabLabel(sr, text))
            self.parent.viewerpoem.show_all()
            self.parent.viewerpoem.set_current_page(-1)
            self.parent.main_notebook.set_current_page(3)
        elif self.n_p == '1': 
            if id_item == 0: return 
            self.parent.dawawin_page.notebook.set_current_page(1)
            self.parent.main_notebook.set_current_page(1)
            self.parent.dawawin_page.to_poet(id_item)
        if self.n_p == '4':
            recited = self.parent.db.is_recited(id_item)
            try: 
                file_media = join(d_customs.AUDIO_DIR, recited[2])
                if not exists(file_media): d_customs.erro(self.parent, 'لا يوجد ملف صوتي لهذه القصيدة')
            except: d_customs.erro(self.parent, 'لا يوجد ملف صوتي لهذه القصيدة')
    
    def near_page(self, v):
        return         
        
    def build(self, *a):
        self.n_p = '0'
        Gtk.Box.__init__(self, orientation=Gtk.Orientation.VERTICAL)
        # a أيقونات المفضلات--------------------------
        self.poem_poets_icon = GdkPixbuf.Pixbuf.new_from_file_at_size(join(d_customs.ICON_DIR, 'poem_daw_icon.png'), 148, 148)
        self.poem_history_icon = GdkPixbuf.Pixbuf.new_from_file_at_size(join(d_customs.ICON_DIR, 'poem_history_icon.png'), 148, 148)
        self.poem_fav_icon = GdkPixbuf.Pixbuf.new_from_file_at_size(join(d_customs.ICON_DIR, 'poem_fav_icon.png'), 148, 148)
        self.poem_recite_icon = GdkPixbuf.Pixbuf.new_from_file_at_size(join(d_customs.ICON_DIR, 'poem_recite_icon.png'), 148, 148)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        self.pack_start(scroll, True, True, 0)
        self.store_icon = Gtk.ListStore(str, GdkPixbuf.Pixbuf, int)
        self.iconview = Gtk.IconView()
        self.iconview.set_reorderable(True)
        self.iconview.set_model(self.store_icon)
        self.iconview.override_font(Pango.FontDescription('KacstOne 15'))
        self.iconview.connect("button-press-event", self.on_button_press)
        self.iconview.set_text_column(COL_NAME)
        self.iconview.set_pixbuf_column(COL_PIXBUF)
        self.iconview.set_item_width(150)
        self.iconview.set_row_spacing(50)
        self.iconview.connect("item-activated", self.item_active)
        scroll.add(self.iconview)
        self.iconview.grab_focus()
        
        #--- Popup menu
        self.popup = Gtk.Menu()
        del_item = Gtk.ImageMenuItem('احذف العنصر المحدد')
        del_item.connect('activate', self.del_item_cb)
        self.popup.append(del_item)
        del_allitems = Gtk.ImageMenuItem('مسح جميع العناصر')
        del_allitems.connect('activate', self.del_allitems_cb)
        self.popup.append(del_allitems)
        self.popup.show_all()
