# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
##############################################################################

from gi.repository import Gtk, Pango
from d_viewer import ShowPoem
from d_tablabel import TabLabel
import d_tools, d_customs, d_araby


# class صفحة المصفاة-------------------------------------------------------------------    
    
class FilterPoem(Gtk.Box):
    
    def visible_cb(self, model, itr, data):
        if len(self.theword) == 0: return
        if d_araby.fuzzy(self.theword[0]) in d_araby.fuzzy(model.get_value(itr, 1)):
            return True
        else: return False
        
    def search_on_page(self, text):
        self.theword = [text]
        self.modelfilter.refilter()
        
    def  search_on_active(self, text):
        self.theword = [text]
        self.modelfilter.refilter()
    
    def near_page(self, v):
        self.size_font_dawawin += v
        self.tree_poems.override_font(Pango.FontDescription("{}".format(self.size_font_dawawin,))) 
    
    def select_page(self, btn):
        n = int(btn.get_name())
        self.load_poems(n)
    
    def a3aridh_elbaher(self, *a):
        #self.refresh(self.select_page, 9)
        model = self.arodh.get_model()
        model.clear()
        baher = d_customs.value_active(self.baher)
        model.append([0, 'الكل'])
        if baher == 0:
            for a in d_tools.ela3aridh:
                model.append(a)
            self.arodh.set_active(0)
            return
        a3aridh = d_tools.ela3aridh_in_behor[baher]
        for a in a3aridh:
            nm = d_tools.get_name(d_tools.ela3aridh, a)
            model.append([a, nm])
        self.arodh.set_active(0)
    
    def toggled_cb(self, btn):
        if btn.get_active():
            for a in self.list_btn:
                if a.get_name() != btn.get_name():
                    a.set_active(False)
    
    def next_cb(self, *a):
        self.r += 1
        self.add_btn()
        self.prev_p.set_sensitive(True)
        if self.r > (self.n_pages-1)/10:
            self.next_p.set_sensitive(False)
            
    
    def prev_cb(self, *a):
        self.r -= 1
        self.add_btn()
        self.next_p.set_sensitive(True)
        if self.r == 1:
            self.prev_p.set_sensitive(False)
    
    def add_btn(self, *a):
        de = self.btns_pages.get_children()
        for a in de:
            self.btns_pages.remove(a)
        self.btns_pages.pack_start(self.prev_p, False, False, 0)
        self.list_btn = []
        for a in range(10*(self.r-1),(10*self.r)):
            if a < self.n_pages:
                btn = Gtk.ToggleButton(str(a+1))
                btn.set_name(str(a))
                btn.override_font(Pango.FontDescription('KacstOne 10'))
                btn.set_size_request(35, -1)
                btn.connect('toggled', self.toggled_cb)
                btn.connect('toggled', self.select_page)
                if a == 0 : btn.set_active(True)
                self.btns_pages.pack_start(btn, False, False, 0)
                self.list_btn.append(btn)
        self.btns_pages.pack_start(self.next_p, False, False, 0)
        self.btns_pages.show_all()
    
    def refresh(self, *a):
        self.r = 1
        self.prev_p = Gtk.Button(' < ')
        self.prev_p.connect('clicked', self.prev_cb)
        self.prev_p.set_sensitive(False)
        self.next_p = Gtk.Button(' > ')
        if self.n_pages <= 10: self.next_p.set_sensitive(False)
        self.next_p.connect('clicked', self.next_cb)
        self.add_btn()
        self.lab_pages.set_label('الصفحات {}'.format(str(self.n_pages),))
    
    def change_filter(self, *a):
        age = d_customs.value_active(self.ages)
        balad = d_customs.value_active(self.lands)
        sex = d_customs.value_active(self.sexs)
        baher = d_customs.value_active(self.baher)
        rawi = d_customs.value_active(self.rawi)
        kafia = d_customs.value_active(self.kafia)
        arodh = d_customs.value_active(self.arodh)
        naw3 = d_customs.value_active(self.naw3)
        gharadh = d_customs.value_active(self.gharadh)
        self.poems_id = self.parent.db.filter_poem(sex, balad, age, baher, rawi, kafia, arodh, gharadh, naw3)
        if len(self.poems_id) == 0: self.n_pages = 0
        else: self.n_pages = int(len(self.poems_id)/100)+1
        self.refresh()
        self.load_poems(0)
        
    def load_poems(self, v):
        self.poems_store.clear()
        self.names_list = []
        self.modelfilter = self.poems_store.filter_new()
        if len(self.poems_id) != 0:
            for a in range(v*100, (v+1)*100):
                if a < len(self.poems_id):
                    ls = self.parent.db.poem_info(self.poems_id[a])
                    i = self.poems_id[a]
                    name = ls[1]
                    if ls[2] != 0: n_poet, l_poet = self.parent.db.name_poet(ls[2])
                    else: l_poet = 'أحدهم'
                    abiat = ls[6]
                    if ls[7] != 0: baher = d_tools.get_name(d_tools.elbehor, ls[7])
                    else: baher = '____'
                    if ls[8] != 0: rawi = d_tools.get_name(d_tools.elrawi, ls[8])
                    else: rawi = '____'
                    if ls[11] != 0: gharadh = d_tools.get_name(d_tools.elgharadh, ls[11])
                    else: gharadh = '____'
                    if ls[12] != 0: naw3 = d_tools.get_name(d_tools.elnaw3, ls[12])
                    else: naw3 = '____'
                    self.poems_store.append([i, name, l_poet, naw3, baher, gharadh, rawi, abiat])
                    self.names_list.append(name)
        self.theword = self.names_list[:]
        self.modelfilter.set_visible_func(self.visible_cb, self.theword) 
        self.tree_poems.set_model(self.modelfilter)
    
    def on_button_press(self, widget, event):
        if event.button == 3:
            self.popup.show_all()
            self.popup.popup(None, None, None, None, 3,
                             Gtk.get_current_event_time())
        elif event.button == 1 and event.get_click_count()[1] == 2:
            self.show_poem_cb()
     
    def to_poet_cb(self, btn, *a):
        model, i = self.tree_poems.get_selection().get_selected()
        if i:
            id_poem = model.get_value(i, 0)
            id_poet = self.parent.db.id_poet(id_poem)
            if id_poet == 0: return 
            self.parent.dawawin_page.notebook.set_current_page(0)
            self.parent.main_notebook.set_current_page(1)
            self.parent.dawawin_page.to_poet(id_poet)
      
    def fav_poem_cb(self, *a):
        if d_customs.can_modify(self.parent):
            model, i = self.tree_poems.get_selection().get_selected()
            if i:
                id_poem = model.get_value(i,0)
                check = self.parent.db.to_favorite(id_poem)
                if check == None:
                    d_customs.info(self.parent, 'تم إضافة هذه القصيدة للمفضلة')
                    
    def assemble_poem_cb(self, *a):
        if d_customs.can_modify(self.parent):
            model, i = self.tree_poems.get_selection().get_selected()
            if i:
                id_poem = model.get_value(i,0)
                self.parent.to_assemble(id_poem)   
                
    def modify_poem_cb(self, *a):
        if d_customs.can_modify(self.parent):
            model, i = self.tree_poems.get_selection().get_selected()
            if i:
                nm_poem = model.get_value(i, 1)
                nm_poet = model.get_value(i, 2)
                self.parent.main_notebook.set_current_page(5)
                if nm_poet == "أحدهم": nm_poet = 'ما لا يعرف قائله'
                self.parent.organiz.search_poets.set_text(nm_poet)
                self.parent.organiz.sel_poet.select_path((0,))
                self.parent.organiz.ok_poet()
                self.parent.entry_search.set_text(nm_poem)
                self.parent.organiz.sel_poem.select_path((0,))
                self.parent.organiz.ok_poem()
                self.parent.organiz.nbk1.set_current_page(0)
                self.parent.entry_search.set_text('')
        
    def show_poem_cb(self, *a):
        model, i = self.tree_poems.get_selection().get_selected()
        if i:
            id_poem = model.get_value(i,0)
            text = model.get_value(i,1)
            self.parent.poems_tgl.set_sensitive(True)
            n = self.parent.viewerpoem.get_n_pages()
            for s in range(n):
                ch = self.parent.viewerpoem.get_nth_page(s)
                if self.parent.viewerpoem.get_tab_label(ch).nm == text:
                    self.parent.viewerpoem.set_current_page(s)
                    self.parent.main_notebook.set_current_page(3)
                    return
            sr = ShowPoem(self.parent)
            sr.loading(id_poem, self.parent.theme.fontmp)
            self.parent.viewerpoem.append_page(sr,TabLabel(sr, text))
            self.parent.main_notebook.set_current_page(3) 
            self.parent.viewerpoem.show_all()
            self.parent.viewerpoem.set_current_page(-1)   
    
    def __init__(self, parent):
        self.parent = parent
        self.size_font_dawawin = int(self.parent.theme.fonttp[-2:])
        self.poems_id = self.parent.db.all_poems_id()
        Gtk.Box.__init__(self, spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        vbox2 = Gtk.Box(orientation=Gtk.Orientation.VERTICAL)
        
        buttonbox = Gtk.ButtonBox.new(Gtk.Orientation.VERTICAL)
        buttonbox.set_layout (Gtk.ButtonBoxStyle.START)
        buttonbox.set_spacing(2)
        self.pack_start(buttonbox, False, False, 0)
        
        self.lab_pages = Gtk.Label('الصفحات {}')
        self.lab_pages.set_alignment(0,0.5)
        buttonbox.add(self.lab_pages)
        
        self.ages = d_customs.combo_all(d_tools.age_poet, 'كلّ العصور')
        buttonbox.add(self.ages)
        self.ages.connect('changed', self.change_filter)
        
        self.lands = d_customs.combo_all(d_tools.elbalad, 'كلّ البلدان')
        buttonbox.add(self.lands)
        self.lands.connect('changed', self.change_filter)
        
        self.sexs = d_customs.combo_all(d_tools.sex_poet, 'كلا الجنسين')
        buttonbox.add(self.sexs)
        self.sexs.connect('changed', self.change_filter)
        
        self.baher = d_customs.combo_all(d_tools.elbehor, 'كلّ البحور')
        self.baher.connect('changed', self.a3aridh_elbaher)
        self.baher.connect('changed', self.change_filter)
        buttonbox.add(self.baher)
        
        self.rawi = d_customs.combo_all(d_tools.elrawi, 'كلّ الرويّات')
        self.rawi.connect('changed', self.change_filter)
        buttonbox.add(self.rawi)
        
        self.kafia = d_customs.combo_all(d_tools.elkawafi, 'كلّ القوافي')
        self.kafia.connect('changed', self.change_filter)
        buttonbox.add(self.kafia)
        
        self.arodh = d_customs.combo_all(d_tools.ela3aridh, 'كلّ الأعاريض')
        self.arodh.connect('changed', self.change_filter)
        #buttonbox.add(self.arodh)
        
        self.naw3 = d_customs.combo_all(d_tools.elnaw3, 'كلّ الأنواع')
        self.naw3.connect('changed', self.change_filter)
        buttonbox.add(self.naw3)
        
        self.gharadh = d_customs.combo_all(d_tools.elgharadh, 'كلّ الأغراض')
        self.gharadh.connect('changed', self.change_filter)
        buttonbox.add(self.gharadh)
        
        self.poems_store = Gtk.ListStore(int,str,str,str,str,str,str,int)
        self.tree_poems = d_customs.TreePoem()
        self.tree_poems.set_grid_lines(Gtk.TreeViewGridLines.HORIZONTAL)
        self.tree_poems.connect("button-press-event", self.on_button_press)
        poems = Gtk.TreeViewColumn('القصيدة', Gtk.CellRendererText(), text=1)
        self.tree_poems.append_column(poems)
        poets = Gtk.TreeViewColumn('الشاعر', Gtk.CellRendererText(), text=2)
        self.tree_poems.append_column(poets)
        elnaw3 = Gtk.TreeViewColumn('النوع', Gtk.CellRendererText(), text=3)
        self.tree_poems.append_column(elnaw3)
        elbaher = Gtk.TreeViewColumn('البحر', Gtk.CellRendererText(), text=4)
        self.tree_poems.append_column(elbaher)
        elgharadh = Gtk.TreeViewColumn('الغرض', Gtk.CellRendererText(), text=5)
        self.tree_poems.append_column(elgharadh)
        elrawi = Gtk.TreeViewColumn('الروي', Gtk.CellRendererText(), text=6)
        self.tree_poems.append_column(elrawi)
        verses = Gtk.TreeViewColumn('عدد الأبيات', Gtk.CellRendererText(), text=7)
        verses.set_expand(True)
        self.tree_poems.append_column(verses)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_poems)
        if len(self.parent.db.all_poems_id()) == 0: self.n_pages = 0
        else: self.n_pages = int(len(self.parent.db.all_poems_id())/100)+1
        
        self.load_poems(0)
        self.btns_pages = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)
        Gtk.StyleContext.add_class(self.btns_pages.get_style_context(), "linked")
        hb_btn = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)
        self.refresh()
        self.btns_pages.set_border_width(2)
        vbox2.pack_start(hb_btn, False, False, 0)
        vbox2.pack_start(scroll, True, True, 0)
        hb_btn.pack_start(self.btns_pages, True, False, 0)
        self.pack_start(vbox2, True, True, 0)
        self.show_all()
        
        #--- Popup menu
        self.popup = Gtk.Menu()
        show_poem = Gtk.ImageMenuItem('اعرض القصيدة')
        show_poem.connect('activate', self.show_poem_cb)
        self.popup.append(show_poem)
        
        show_poet = Gtk.ImageMenuItem('اعرض الشاعر')
        show_poet.connect('activate', self.to_poet_cb)
        self.popup.append(show_poet)
        
        fav_poem = Gtk.ImageMenuItem('فضّل القصيدة')
        fav_poem.connect('activate', self.fav_poem_cb)
        self.popup.append(fav_poem)
        
        assemble_poem = Gtk.ImageMenuItem('أضفها لمجموع')
        assemble_poem.connect('activate', self.assemble_poem_cb)
        self.popup.append(assemble_poem)
        
        modify_poem = Gtk.ImageMenuItem('عدّل القصيدة')
        modify_poem.connect('activate', self.modify_poem_cb)
        self.popup.append(modify_poem)
        self.popup.show_all()
        