# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
##############################################################################

from gi.repository import Gtk, Pango
import d_customs, d_scan, d_araby, d_tools
from d_contacts import HelpDB
from os.path import join

Gtk.Widget.set_default_direction(Gtk.TextDirection.RTL)

# class صفحة العروض-------------------------------------------------------------------

class Metrics(Gtk.Notebook):
   
    def search_on_page(self, text):
        return
   
    def near_page(self, v):
        self.size_font += v
        self.view_info.override_font(Pango.FontDescription("{}".format(self.size_font,))) 
        self.view_scan.override_font(Pango.FontDescription("{}".format(self.size_font,))) 
        self.prescript.override_font(Pango.FontDescription("{}".format(self.size_font,))) 
        self.zihaf_info.override_font(Pango.FontDescription("{}".format(self.size_font,))) 
   
    def __init__(self, parent):
        self.parent = parent
        self.myhelp = HelpDB()
        self.size_font = int(self.parent.theme.fontch[-2:])
        Gtk.Notebook.__init__(self)
        self.build()
    
    def convert_to_taf3ilat(self, text):
        taf3ilat_list = list(text)
        for i in range(len(taf3ilat_list)):
            taf3ilat_list[i] = d_scan.short_awzan[taf3ilat_list[i]]
        taf3ilat_txt = ' '.join(taf3ilat_list)
        return taf3ilat_txt
    
    def naw3_zihaf(self, bait, text, baher, taf3ila_naw3, taf3ila_raqm):
        arodh_is_dharb = ''
        if '*' not in bait: arodh_is_dharb = 'وهي الضرب نفسه'
        for b in d_scan.Details[baher][0]:
            if len(b[1]) == len(bait):
                if b[0] == 1: arodh = 'تامّة' 
                elif b[0] == 2: arodh =  'مجزوءة' 
                elif b[0] == 3: arodh =  'مشطورة'
                elif b[0] == 4: arodh =  'منهوكة'
                elif b[0] == 5: arodh =  'مخلّعة' 
                taf = int(b[1][taf3ila_raqm])
                break
        text0 = d_scan.short_awzan[text].strip()
        if taf3ila_naw3 == 3:
            if taf in d_scan.Details[baher][1].keys():
                for a in d_scan.Details[baher][1][taf]:
                    if a in d_scan.Changes[taf].keys():
                        if text0 == d_scan.Changes[taf][a].strip():
                            return d_scan.Zihafat_3ilal[a][1]
            return 'صحيحة'
        if taf3ila_naw3 == 1:
            for a in range(2, len(b)):
                taf0 = b[a][0]
                if taf0 < 0: 
                    taf0 = taf0*(-1)
                    arodh_is_dharb = 'ولا تجوز إلا في التصريع'
                if taf0 == 0 or taf0 == 100:
                    if text0 == d_scan.Taf3ilat[taf]: return arodh+' '+'صحيحة'+' '+arodh_is_dharb
                elif text0 == d_scan.Changes[taf][taf0].strip():
                        return arodh+' '+d_scan.Zihafat_3ilal[taf0][1]+' '+arodh_is_dharb
            return arodh+' '+'صحيحة'+' '+arodh_is_dharb
        if taf3ila_naw3 == 2:
            for a in range(2, len(b)):
                for c in range(1, len(b[a])):
                    dharb = b[a][c]
                    if dharb == 0 :
                        if text0 == d_scan.Taf3ilat[taf]: return 'صحيح'
                    elif  text0 == d_scan.Changes[taf][dharb].strip():
                            return d_scan.Zihafat_3ilal[dharb][2]
            return 'صحيح'
     
    def info_taf3ilat(self, text, baher):
        result = ''
        if '*'  in text:
            result += '******* الصدر *******\n'
        result += 'التفعيلة الأولى :     '+self.naw3_zihaf(text, text[0], baher, 3, 0)+'\n'
        if len(text) != 5 and len(text) != 2:
            result += 'التفعيلة الثانية :     '+self.naw3_zihaf(text, text[1], baher, 3, 1)+'\n'
        if len(text) == 9:
            result += 'التفعيلة الثالثة :     '+self.naw3_zihaf(text, text[2], baher, 3, 2)+'\n'
        if '*'  in text: i = text.index('*', )
        else: i = 0
        result += 'العروض :     '+self.naw3_zihaf(text, text[i-1], baher, 1, i-1)+'\n'
        if '*'  in text:
            result += '******* العجز *******\n'
            if len(text) == 5:
                result += 'التفعيلة الأولى :     '+self.naw3_zihaf(text, text[3], baher, 3, 3)+'\n'
            elif len(text) == 7:
                result += 'التفعيلة الأولى :     '+self.naw3_zihaf(text, text[4], baher, 3, 4)+'\n'
                result += 'التفعيلة الثانية :     '+self.naw3_zihaf(text, text[5], baher, 3, 5)+'\n'
            elif len(text) == 9:
                result += 'التفعيلة الأولى :     '+self.naw3_zihaf(text, text[5], baher, 3, 5)+'\n'
                result += 'التفعيلة الثانية :     '+self.naw3_zihaf(text, text[6], baher, 3, 6)+'\n'
                result += 'التفعيلة الثالثة :     '+self.naw3_zihaf(text, text[7], baher, 3, 7)+'\n'
        if '*'  in text:
            result += 'الضرب :     '+self.naw3_zihaf(text, text[-1], baher, 2, -1)+'\n'
        return result
    
    def scan_cb(self, *a):
        v = 0
        if self.ishbaa_m.get_active(): v = 1
        text = self.verse_dictation_bfr.get_text(self.verse_dictation_bfr.get_start_iter(),
                                self.verse_dictation_bfr.get_end_iter(), False)
        if text != '':
            wazn = d_scan.writing_wazn(text, v)
            ls_awzan = d_scan.meter_verse(wazn)
            text1 = d_scan.writing_spoken(text, v)
            if len(ls_awzan) == 0:
                d_customs.erro(self.parent, '''
لم يستطع البرنامج تحديد بحر هذا البيت
هل جميع الأحرف المنطوقة مكتوبة في الكتابة العروضية ؟
إن لم تكن ، فقد يكون الخطأ في التشكيل !.''')
                takti31= d_scan.writing_scan(text, v)
                result = 'الكتابة العروضية :     '+text1+'\n'
                result += 'الكتابة التقطيعية :     '+takti31+'\n'
            else:
                taf3ilat_txt = self.convert_to_taf3ilat(ls_awzan[0][3])
                result = 'الكتابة العروضية :     '+text1+'\n'
                result += 'الكتابة التقطيعية :     '+d_scan.writing_scan(taf3ilat_txt, v)+'\n'
                s = 1
                if len(ls_awzan) > 1: result += 'هذا الوزن ينتمي لأكثر من بحر فقد يكون : \n'.format(str(s),) 
                for a in ls_awzan:
                    if s > 1: result += 'وقد يكون : *****************************************\n'.format(str(s),) 
                    result += 'البحر :     '+d_scan.Elbehor[a[1]]+'\n'
                    result += 'الكتابة التفعيلية :     '+self.convert_to_taf3ilat(a[3])+'\n'
                    result += self.info_taf3ilat(a[3], a[1])
                    s += 1
            self.view_scan_bfr.set_text(result)
            d_customs.with_tag(self.view_scan_bfr, self.title_tag2, 
                             ['الكتابة العروضية :','الكتابة التقطيعية :', 
                              'البحر :', 'الكتابة التفعيلية :', 'العروض :', 'الضرب :',
                              '******* العجز *******', 'التفعيلة الأولى : ', 'التفعيلة الثانية :', 
                              'التفعيلة الثالثة :', '******* الصدر *******'])
    
    def tashkeel_cb(self, btn, haraka):
        self.verse_dictation_bfr.insert_at_cursor(haraka)
    
    def show_page_zihafat(self, *a):
        model, i = self.sel_zihafat.get_selected()
        if i:
            v = model.get_value(i,1)
            self.zihaf_info_bfr.set_text(d_scan.Zihafat_ta3rif[v][1])
            d_customs.with_tag(self.zihaf_info_bfr, self.zihaf_info_tag, [d_scan.Zihafat_ta3rif[v][1].split('\n')[0],])
    
    def show_page_mekadimat(self, *a):
        model, i = self.sel_mekaddima.get_selected()
        if i:
            v = model.get_value(i,1)
            txt = self.myhelp.show_page_mekadimat(v)
            self.prescript_bfr.set_text(txt[0][0])
            d_customs.with_tag(self.prescript_bfr, self.prescript_tag, [txt[0][0].split('\n')[0],])
    
    def show_page_behor(self, *a):
        model, i = self.sel_behor.get_selected()
        if i:
            v = model.get_value(i,1)
            txt = self.myhelp.show_page_behor(v)
            self.view_info_bfr.set_text(txt[0][0])
            d_customs.with_tag(self.view_info_bfr, self.view_info_tag, [txt[0][0].split('\n')[0], '- وزنه  :', '- مفتاحه :', '- أعاريضه وأضربه :', '- استعماله :', '- التغييرات الجائزة في تفعيلاته :'])
    
    def change_taf3ila(self, *a):
        if self.taf3ila.get_active() == -1: return
        model1 = self.takiir.get_model()
        model2 = self.sabab.get_model()
        model1.clear()
        model2.clear()
        taf3ila = d_customs.value_active(self.taf3ila)
        for a in d_scan.Changes[taf3ila].keys():
            if a in d_scan.Zihafat_ta3rif.keys():
                model1.append([a, d_scan.Changes[taf3ila][a]])
                model2.append([a, d_scan.Zihafat_ta3rif[a][0]])
   
    def change_sabab(self, *a):
        sabab = d_customs.value_active(self.sabab)
        model = self.takiir.get_model()
        txt = d_customs. text_active(self.sabab)
        ls = []
        for a in model:
            ls.append(a)
        idx = d_tools.get_index(ls, sabab)
        if idx == None: return
        self.takiir.set_active(idx)
        s = txt.split(' ')
        if len(s) == 1:
            self.zihaf_info_bfr.set_text(d_scan.Zihafat_ta3rif[sabab][1])
            d_customs.with_tag(self.zihaf_info_bfr, self.zihaf_info_tag, [d_scan.Zihafat_ta3rif[sabab][1].split('\n')[0],])
        elif len(s) > 1:
            l = d_scan.Zihafat_ta3rif[sabab][1]
            self.zihaf_info_bfr.set_text(d_scan.Zihafat_ta3rif[l[0]][1]+'\n'+d_scan.Zihafat_ta3rif[l[1]][1])
            d_customs.with_tag(self.zihaf_info_bfr, self.zihaf_info_tag, [d_scan.Zihafat_ta3rif[l[0]][1].split('\n')[0], d_scan.Zihafat_ta3rif[l[1]][1].split('\n')[0]])

                
    def change_takiir(self, *a):
        takiir= d_customs.value_active(self.takiir)
        model = self.sabab.get_model()
        ls = []
        for a in model:
            ls.append(a)
        idx = d_tools.get_index(ls, takiir)
        if idx == None: return
        self.sabab.set_active(idx) 
        txt = d_customs. text_active(self.sabab)
        s = txt.split(' ')
        if len(s) == 1:
            self.zihaf_info_bfr.set_text(d_scan.Zihafat_ta3rif[takiir][1])
            d_customs.with_tag(self.zihaf_info_bfr, self.zihaf_info_tag, [d_scan.Zihafat_ta3rif[takiir][1].split('\n')[0],])
        elif len(s) > 1:
            l = d_scan.Zihafat_ta3rif[takiir][1]
            self.zihaf_info_bfr.set_text(d_scan.Zihafat_ta3rif[l[0]][1]+'\n'+d_scan.Zihafat_ta3rif[l[1]][1])
            d_customs.with_tag(self.zihaf_info_bfr, self.zihaf_info_tag, [d_scan.Zihafat_ta3rif[l[0]][1].split('\n')[0], d_scan.Zihafat_ta3rif[l[1]][1].split('\n')[0]])
        
    def build(self, *a):
        
        #a صفحة تقطيع الأبيات الشعرية--------------------------------------------
        vb3 = Gtk.Box(spacing=3, orientation=Gtk.Orientation.VERTICAL)
        info = '''
        - يستحسن الفصل بين الشطرين بنجمة واحدة
        - يجب تشكيل البيت شكلا تاما
        - الحرف العاري عن التشكيل يعتبر ساكنا
        - يجب حذف جميع الرموز والأعداد
        - الكتابة العروضية هي كتابة الأحرف الملفوظة
        - الحرف إن كان ملفوظا ولم يكن في الكتابة العروضية
           فهو خطأ قديكون بسبب عدم تشكيله إن كان متحركا
           أوعدم تشكيل الحرف الذي يليه إن كان ساكنا 
        - قد يشبع البرنامج ما لا يستحق الإشباع لذلك ينصح
           باختيار الإشباع يدويا وتقوم بزيادة حرف المد
           إلى ما يستحق الإشباع دون غيره
        '''
        hb = Gtk.Box(spacing=7, orientation=Gtk.Orientation.HORIZONTAL)
        hb.set_border_width(7)
        vbox = Gtk.Box(spacing=3, orientation=Gtk.Orientation.VERTICAL)
        self.verse_dictation = d_customs.ViewEdit()
        self.verse_dictation_bfr = self.verse_dictation.get_buffer()
        self.verse_dictation.override_font(Pango.FontDescription('Simplified Naskh 22'))
        self.verse_dictation.set_size_request(-1, 64)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.set_policy(Gtk.PolicyType.NEVER, Gtk.PolicyType.NEVER)
        scroll.add(self.verse_dictation)
        hb.pack_start(scroll, True, True, 0)
        scan_btn = Gtk.Button('تقطيع البيت')
        scan_btn.connect('clicked', self.scan_cb)
        vbox.pack_start(scan_btn, False, False, 0)
        info_btn = Gtk.Button('إرشادات')
        info_btn.connect('clicked', lambda *a: self.view_scan_bfr.set_text(info))
        vbox.pack_start(info_btn, False, False, 0)
        hb.pack_start(vbox, False, False, 0)
        vb3.pack_start(hb, False, False, 3)
        
        hb1 = Gtk.Box(spacing=0, orientation=Gtk.Orientation.HORIZONTAL)
        hb1.set_border_width(7)
        hb = Gtk.Box(spacing=0, orientation=Gtk.Orientation.HORIZONTAL)
        Gtk.StyleContext.add_class(hb.get_style_context(), "linked")
        lab = Gtk.Label('التشكيل :   ')
        lab.set_alignment(0,0.5)
        hb1.pack_start(lab, False, False, 0)
        shadda = d_customs.tool_button(join(d_customs.ICON_DIR, 'shadda.png'), 'الشدة', self.tashkeel_cb, d_araby.SHADDA)
        hb.pack_start(shadda, False, False, 0)
        skon = d_customs.tool_button(join(d_customs.ICON_DIR, 'skon.png'), 'السكون',self.tashkeel_cb, d_araby.SUKUN)
        hb.pack_start(skon, False, False, 0)
        fatha = d_customs.tool_button(join(d_customs.ICON_DIR, 'fatha.png'), 'الفتحة',self.tashkeel_cb, d_araby.FATHA)
        hb.pack_start(fatha, False, False, 0)
        damma = d_customs.tool_button(join(d_customs.ICON_DIR, 'damma.png'), 'الضمة',self.tashkeel_cb, d_araby.DAMMA)
        hb.pack_start(damma, False, False, 0)
        kasra = d_customs.tool_button(join(d_customs.ICON_DIR, 'kasra.png'), 'الكسرة',self.tashkeel_cb, d_araby.KASRA)
        hb.pack_start(kasra, False, False, 0)
        fatha2 = d_customs.tool_button(join(d_customs.ICON_DIR, 'fatha2.png'), 'الفتحتين',self.tashkeel_cb, d_araby.FATHATAN)
        hb.pack_start(fatha2, False, False, 0)
        damma2 = d_customs.tool_button(join(d_customs.ICON_DIR, 'damma2.png'), 'الضمتين',self.tashkeel_cb, d_araby.DAMMATAN)
        hb.pack_start(damma2, False, False, 0)
        kasra2 = d_customs.tool_button(join(d_customs.ICON_DIR, 'kasra2.png'), 'الكسرتين',self.tashkeel_cb, d_araby.KASRATAN)
        hb.pack_start(kasra2, False, False, 0)
        hb1.pack_start(hb, False, False, 0)
        
        self.ishbaa_m = Gtk.CheckButton('معالجة إشباع ميم وهاء الضمير يدويا')
        hb1.pack_end(self.ishbaa_m, False, False, 0)
        vb3.pack_start(hb1, False, False, 3)
        
        self.view_scan = d_customs.ViewClass()
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.view_scan)
        self.view_scan_bfr = self.view_scan.get_buffer()
        self.view_scan_bfr.set_text(info)
        self.title_tag2 = self.view_scan_bfr.create_tag("title")
        self.title_tag2.set_property('foreground', self.parent.theme.coloran) 
        vb3.pack_start(scroll, True, True, 0)
        lab = Gtk.Label("تقطيع الأبيات")
        lab.set_size_request(150, -1)
        self.append_page(vb3, lab)
        
        #a صفحة المقدمات العروضية--------------------------------------
        self.store_mekaddima = Gtk.ListStore(str, int)
        mekadimat = self.myhelp.titles_mekadimat()
        for a in mekadimat:
            self.store_mekaddima.append([a[1], a[0]])
        hp0 = Gtk.HPaned()
        self.tree_mekaddima = d_customs.TreeClass()
        self.tree_mekaddima.set_headers_visible(False)
        self.sel_mekaddima = self.tree_mekaddima.get_selection()
        cell = Gtk.CellRendererText()
        kal = Gtk.TreeViewColumn('الفهرس', cell, text=0)
        self.tree_mekaddima.append_column(kal)
        self.tree_mekaddima.set_model(self.store_mekaddima)
        scroll = Gtk.ScrolledWindow()
        scroll.set_size_request(200, -1)
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_mekaddima)
        self.tree_mekaddima.connect("cursor-changed", self.show_page_mekadimat)
        hp0.pack1(scroll, False, False)
        self.prescript = d_customs.ViewClass()
        self.prescript_bfr = self.prescript.get_buffer()
        self.prescript_tag = self.prescript_bfr.create_tag("prescript")
        self.prescript_tag.set_property('foreground', self.parent.theme.coloran) 
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.prescript)
        hp0.pack2(scroll, True, True)
        lab = Gtk.Label("مقدمات مهمة")
        lab.set_size_request(150, -1)
        self.append_page(hp0, lab)
        
        #a صفحة البحور الشعرية--------------------------------------------
        hb1 = Gtk.Box(spacing=6,orientation=Gtk.Orientation.HORIZONTAL)
        self.tree_behor = d_customs.TreeClass()
        self.tree_behor.set_headers_visible(False)
        self.sel_behor = self.tree_behor.get_selection()
        cell = Gtk.CellRendererText()
        kal = Gtk.TreeViewColumn('البحور', cell, text=0)
        self.tree_behor.append_column(kal)
        self.store_behor = Gtk.ListStore(str, int)
        behor = self.myhelp.titles_behor()
        for a in behor:
            self.store_behor.append([a[1], a[0]])
        self.tree_behor.set_model(self.store_behor)
        scroll = Gtk.ScrolledWindow()
        scroll.set_size_request(150, -1)
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_behor)
        self.tree_behor.connect("cursor-changed", self.show_page_behor)
        scroll.set_policy(Gtk.PolicyType.NEVER, Gtk.PolicyType.AUTOMATIC)
        hb1.pack_start(scroll, False, False, 0)
        self.view_info = d_customs.ViewClass()
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.view_info)
        self.view_info_bfr = self.view_info.get_buffer()
        self.view_info_tag = self.view_info_bfr.create_tag("prescript")
        self.view_info_tag.set_property('foreground', self.parent.theme.coloran) 
        hb1.pack_start(scroll, True, True, 0)
        lab = Gtk.Label("بحور الشعر")
        lab.set_size_request(150, -1)
        self.append_page(hb1, lab)
        
        #a صفحة الزحافات والعلل--------------------------------------------
        vb4 = Gtk.Box(spacing=0, orientation=Gtk.Orientation.VERTICAL)    
        hbox = Gtk.Box(spacing=11, orientation=Gtk.Orientation.HORIZONTAL)
        ls = [] 
        for a in [1, 2, 3, 4, 5, 6, 7, 8, 9, 0]:
            ls.append([a, d_scan.Taf3ilat[a]])
        hb, self.taf3ila = d_customs.combo(ls, 'التفعيلة', 0)
        hbox.pack_start(hb, False, False, 0)
        self.taf3ila.connect('changed', self.change_taf3ila)

        self.ls_takiir = [] 
        hb, self.takiir = d_customs.combo(self.ls_takiir, 'التغيير', 0)
        hbox.pack_start(hb, False, False, 0)
        self.takiir.connect('changed', self.change_takiir)

        self.ls_sabab = [] 
        hb, self.sabab = d_customs.combo(self.ls_sabab, 'السبب', 0)
        hbox.pack_start(hb, False, False, 0)
        self.sabab.connect('changed', self.change_sabab)
        
        hp2 = Gtk.HPaned()
        
        self.store_zihafat = Gtk.ListStore(str, int)
        for a in d_scan.Zihafat_ta3rif.keys():
            if a > 35: break
            self.store_zihafat.append([d_scan.Zihafat_ta3rif[a][0], a])
        self.tree_zihafat = d_customs.TreeClass()
        self.tree_zihafat.set_headers_visible(False)
        self.sel_zihafat = self.tree_zihafat.get_selection()
        cell = Gtk.CellRendererText()
        kal = Gtk.TreeViewColumn('الفهرس', cell, text=0)
        self.tree_zihafat.append_column(kal)
        self.tree_zihafat.set_model(self.store_zihafat)
        scroll = Gtk.ScrolledWindow()
        scroll.set_size_request(150, -1)
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.set_policy(Gtk.PolicyType.NEVER, Gtk.PolicyType.AUTOMATIC)
        scroll.add(self.tree_zihafat)
        self.tree_zihafat.connect("cursor-changed", self.show_page_zihafat)
        hp2.pack1(scroll, False, False)
        self.zihaf_info = d_customs.ViewClass()
        self.zihaf_info_bfr = self.zihaf_info.get_buffer()
        self.zihaf_info_tag = self.zihaf_info_bfr.create_tag("prescript")
        self.zihaf_info_tag.set_property('foreground', self.parent.theme.coloran) 
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.zihaf_info)
        hp2.pack2(scroll, True, False)
        vb4.pack_start(hbox, False, False, 7)
        vb4.pack_start(hp2, True, True, 0)
        lab = Gtk.Label("الزحافات والعلل")
        lab.set_size_request(150, -1)
        self.append_page(vb4, lab)
        
#        self.show_all()
