# -*- coding: utf-8 -*-

#a############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
#a############################################################################

from os.path import join
from d_contacts import MyDB
from gi.repository import Gtk, Pango
import d_tools, d_araby, d_customs

# class صفحة التعديل--------------------------------------------------

class Organize(Gtk.Box):
    
    def visible_cb(self, model, itr, data):
        if len(self.theword) == 0: return
        if d_araby.fuzzy(self.theword[0]) in d_araby.fuzzy(model.get_value(itr, 1)):
            return True
        else: return False
        
    def search_cb(self, *a):
        self.theword = [self.search_poets.get_text()]
        self.modelfilter.refilter()
    
    def visible_cb0(self, model, itr, data):
        if len(self.theword) == 0: return
        if d_araby.fuzzy(self.theword0[0]) in d_araby.fuzzy(model.get_value(itr, 1)):
            return True
        else: return False
        
    def search_on_page(self, text):
        if len(self.store_poems) == 0: return
        self.theword0 = [text]
        self.modelfilter0.refilter()
    
    def near_page(self, v):
        self.size_font += v
        self.view_charh.override_font(Pango.FontDescription("{}".format(self.size_font,))) 
        self.view_nasse.override_font(Pango.FontDescription("{}".format(self.size_font,))) 
        self.view_sabab.override_font(Pango.FontDescription("{}".format(self.size_font,))) 
        self.view_tarjama.override_font(Pango.FontDescription("{}".format(self.size_font,))) 
    
    def __init__(self, parent):
        self.parent = parent
        self.db = MyDB()
        self.size_font = int(self.parent.theme.fontch[-2:])
        self.list_modifieds = []
        self .build()
    
    def modify_data(self, *a):
        if d_customs.can_modify(self.parent):
            model, i = self.sel_poem.get_selected()
            id_poem = model.get_value(i,0)
            text = d_tools.right_space(self.view_nasse_bfr.get_text(self.view_nasse_bfr.get_start_iter(),
                                                            self.view_nasse_bfr.get_end_iter(), False))
            if text == '': d_customs.erro(self.parent, 'لقد تم مسح القصيدة'); return
            nam = self.nm_poem.get_text()
            if nam == '' : d_customs.erro(self.parent, 'ضع اسما للقصيدة\nأو أول شطر منها'); return
            naw3 = d_customs.value_active(self.naw3)
            if naw3 == None : d_customs.erro(self.parent, 'حدد نوع القصيدة'); return
            if naw3 == 1:
                baher = d_customs.value_active(self.baher)
                if baher == None : 
                    if self.active_baher.get_active() == False:
                        baher = 0
                    else: d_customs.erro(self.parent, 'حدد بحر القصيدة'); return
                rawi = d_customs.value_active(self.rawi)
                if rawi == None : 
                    if self.active_rawi.get_active() == False:
                        rawi = 0
                    else:  d_customs.erro(self.parent, 'حدد روي القصيدة'); return
                kafia = d_customs.value_active(self.kafia)
                if kafia == None : 
                    if self.active_kafia.get_active() == False:
                        kafia = 0
                    else:  d_customs.erro(self.parent, 'حدد قافية القصيدة'); return
                arodh = d_customs.value_active(self.arodh)
                if arodh == None : 
                    if self.active_arodh.get_active() == False:
                        arodh = 0
                    else:  d_customs.erro(self.parent, 'حدد عروض القصيدة'); return
            elif naw3 == 2:
                baher = d_customs.value_active(self.baher)
                if baher == None : 
                    if self.active_baher.get_active() == False:
                        baher = 0
                    else:  d_customs.erro(self.parent, 'حدد بحر القصيدة'); return
                rawi = 0
                kafia = 0
                arodh = 0
            else:
                baher = 0
                rawi = 0
                kafia = 0
                arodh = 0
            gharadh = d_customs.value_active(self.gharadh)
            if gharadh == None : 
                    if self.active_gharadh.get_active() == False:
                        gharadh = 0
                    else:  d_customs.erro(self.parent, 'حدد غرض القصيدة'); return
            charh = self.view_charh_bfr.get_text(self.view_charh_bfr.get_start_iter(),
                                                 self.view_charh_bfr.get_end_iter(), False)
            sabab = self.view_sabab_bfr.get_text(self.view_sabab_bfr.get_start_iter(),
                                                 self.view_sabab_bfr.get_end_iter(), False)
            label = Gtk.Label()
            label.override_font(Pango.FontDescription('KacstOne 15'))
            if naw3 != 5:
                if d_tools.is_machtor(text):
                    longer_half, n_abiat = d_tools.longer_half(text, label, 1)
                else:
                    longer_half, n_abiat = d_tools.longer_half(text, label, 0)
            else: longer_half = 0
            msg = d_customs.sure(self.parent, '''
                هل أنت متأكد بأنك 
                تريد تعديل البيانات ؟
                ''' )
            if msg == Gtk.ResponseType.NO:
                return
            check = self.parent.db.modify_poem(id_poem, nam, text, sabab, charh, n_abiat, 
                                               baher, rawi, kafia, arodh, gharadh, naw3, longer_half)
            if check == None: d_customs.info(self.parent, 'تم تعديل البيانات بنجاح'); return
    
    def modify_poet_cb(self, *a):
        if d_customs.can_modify(self.parent):
            model, i = self.sel_poet.get_selected()
            id_poet = model.get_value(i,0)
            if id_poet != 0:
                nm = self.nm_poet.get_text()
                lak = self.lak_poet.get_text()
                if nm == lak == '': d_customs.erro(self.parent, 'ضع أسما للشاعر'); return
                if nm == '': nm += lak
                elif lak == '': lak += nm
                age = d_customs.value_active(self.ages)
                if age == None : d_customs.erro(self.parent, 'حدد عصر الشاعر\nأو اجعله غير معروف'); return
                balad = d_customs.value_active(self.lands)
                if self.lands.get_sensitive():
                    if balad == None : d_customs.erro(self.parent, 'حدد بلد الشاعر\nأو اجعله غير معروف'); return
                else: balad = 22
                sex = d_customs.value_active(self.sexs)
                if sex == None : d_customs.erro(self.parent, 'حدد جنس الشاعر'); return
                die = self.dh_poet.get_value()
                tarjama = self.view_tarjama_bfr.get_text(self.view_tarjama_bfr.get_start_iter(),
                                                         self.view_tarjama_bfr.get_end_iter(), False)
                msg = d_customs.sure(self.parent, '''
                    هل أنت متأكد بأنك 
                    تريد تعديل بيانات الشاعر ؟
                    ''' )
                if msg == Gtk.ResponseType.NO:
                    return
                check = self.parent.db.modify_poet(id_poet, nm, lak, tarjama, die, sex, balad, age)
                if check == None: d_customs.info(self.parent, 'تم تعديل البيانات بنجاح'); return
            else: return
    
    def load_data(self, text_poem='', text_sabab='', 
                  text_charh='', nm_poem='', baher=-1, rawi=-1, gharadh=-1, kafia=-1, naw3=-1, arodh=-1):
        self.view_nasse_bfr.set_text(text_poem)
        self.view_sabab_bfr.set_text(text_sabab)
        self.view_charh_bfr.set_text(text_charh)
        self.nm_poem.set_text(nm_poem)
        self.naw3.set_active(naw3)
        if self.baher.get_visible():
            self.baher.set_active(baher)
            if baher == -1: self.active_baher.set_active(False)
            else: self.active_baher.set_active(True)
        if self.rawi.get_visible():
            self.rawi.set_active(rawi)
            if rawi == -1: self.active_rawi.set_active(False)
            else: self.active_rawi.set_active(True)
        if self.gharadh.get_visible():
            self.gharadh.set_active(gharadh)
            if gharadh == -1: self.active_gharadh.set_active(False)
            else: self.active_gharadh.set_active(True)
        if self.kafia.get_visible():
            self.kafia.set_active(kafia)
            if kafia == -1: self.active_kafia.set_active(False)
            else: self.active_kafia.set_active(True)
        if self.arodh.get_visible():
            if arodh == None: arodh = -1
            self.arodh.set_active(arodh)
            if arodh == -1: self.active_arodh.set_active(False)
            else: self.active_arodh.set_active(True)
    
    # a حذف ديوان
    
    def remove_poet(self,*a):
        if d_customs.can_modify(self.parent):
            model, i = self.sel_poet.get_selected()
            if i:
                id_poet = model.get_value(i,0)
                nm = model.get_value(i,1)
                msg = d_customs.sure(self.parent, '''
                سيتم حذف ديوان {}"
                مع بيانات الشاعر، هل تريد الاستمرار ؟
                '''.format(nm,))
                if msg == Gtk.ResponseType.YES:
                    check = self.parent.db.remove_poet(id_poet)
                    if check == None:
                        self.refresh_poets()
    
    # a حذف قصيدة
                    
    def remove_poem(self,*a):
        if d_customs.can_modify(self.parent):
            model, i = self.sel_poem.get_selected()
            if i:
                id_poem = model.get_value(i,0)
                nm = model.get_value(i,1)
                msg = d_customs.sure(self.parent, '''
                سيتم حذف قصيدة {}
                هل تريد الاستمرار ؟
                '''.format(nm,))
                if msg == Gtk.ResponseType.YES:
                    check = self.parent.db.remove_poem(id_poem)
                    if check == None:
                        self.ok_poet()
    
    def ok_poem(self, *a):
        self.notebk.set_current_page(1)
        model, i = self.sel_poem.get_selected()
        if i:
            id_poem = model.get_value(i,0)
            text_poem, text_sabab, text_charh, text_ta3lik = self.parent.db.get_poem(id_poem)
            nm_poem = self.parent.db.name_poem(id_poem)
            baher = self.parent.db.get_id_baher(id_poem)-1
            rawi = d_tools.get_index(d_tools.elrawi, self.parent.db.rawi_poem(id_poem))
            gharadh = d_tools.get_index(d_tools.elgharadh, self.parent.db.gharadh_poem(id_poem))
            kafia = d_tools.get_index(d_tools.elkawafi, self.parent.db.kafia_poem(id_poem))
            naw3 = d_tools.get_index(d_tools.elnaw3, self.parent.db.naw3_poem(id_poem))
            if baher == -1:
                arodh = -1
            else:
                arodh = d_tools.get_index_arodh(self.parent.db.get_id_baher(id_poem), 
                                                  self.parent.db.arodh_poem(id_poem))
            self.load_data(text_poem, text_sabab, text_charh, nm_poem, baher, rawi, gharadh,
                            kafia, naw3, arodh)
            self.list_modifieds = []
            self.list_modifieds.append(text_poem)
            self.redo.set_sensitive(False)  
    
    def ok_poet(self, *a):
        model, i = self.sel_poet.get_selected()
        if i:
            id_poet = model.get_value(i,0)
            list_poems, self.text_tarjama = self.parent.db.poems_of_poet(id_poet)
            if id_poet != 0:
                self.vb_poet.set_sensitive(True)
                self.view_tarjama_bfr.set_text(self.text_tarjama)
                self.lak_poet.set_text(self.parent.db.name_poet(id_poet)[1])
                self.nm_poet.set_text(self.parent.db.name_poet(id_poet)[0])
                self.ages.set_active(d_tools.get_index(d_tools.age_poet, self.parent.db.age_poet(id_poet)))
                self.lands.set_active(d_tools.get_index(d_tools.elbalad, self.parent.db.balad_poet(id_poet)))
                self.sexs.set_active(d_tools.get_index(d_tools.sex_poet, self.parent.db.sex_poet(id_poet)))
                self.dh_poet.set_value(float(self.parent.db.death_poet(id_poet)))
            else:
                self.vb_poet.set_sensitive(False)
                self.view_tarjama_bfr.set_text('')
                self.lak_poet.set_text('')
                self.nm_poet.set_text('')
                self.ages.set_active(-1)
                self.lands.set_active(-1)
                self.sexs.set_active(-1)
                self.dh_poet.set_value(0.0)
            self.store_poems.clear()
            self.load_data()
            if len(list_poems) != 0:
                self.names_list0 = []
                self.modelfilter0 = self.store_poems.filter_new()
                for a in list_poems:
                    self.store_poems.append([a[0], a[1]])
                    self.names_list0.append(a[1])
                self.theword0 = self.names_list0[:]
                self.modelfilter0.set_visible_func(self.visible_cb0, self.theword0) 
                self.tree_poems.set_model(self.modelfilter0)
            self.notebk.set_current_page(0)
            
    def change_text(self, *a):
        text = (self.view_nasse_bfr.get_text(self.view_nasse_bfr.get_start_iter(), self.view_nasse_bfr.get_end_iter(), False))
        model, i = self.sel_poem.get_selected()
        if i:
            id_poem = model.get_value(i,0)
            if len(self.list_modifieds) > 0:
                if text != self.list_modifieds[-1]:
                    self.list_modifieds.append(text)
                    self.redo.set_sensitive(True)
    
    def redo_text(self, *a):
        del self.list_modifieds[-1]
        self.view_nasse_bfr.set_text(self.list_modifieds[-1])
        del self.list_modifieds[-1]
        del self.list_modifieds[-1]
        if len(self.list_modifieds) == 1:
            self.redo.set_sensitive(False)      
    
    def change_naw3(self, *a):
        if self.naw3.get_active() == 0:
            self.baher_hb.show_all()
            self.rawi_hb.show_all()
            self.kafia_hb.show_all()
            self.arodh_hb.show_all()
        elif self.naw3.get_active() == 1:
            self.baher_hb.show_all()
            self.rawi_hb.hide()
            self.kafia_hb.hide()
            self.arodh_hb.hide()
        else:
            self.baher_hb.hide()
            self.rawi_hb.hide()
            self.kafia_hb.hide()
            self.arodh_hb.hide()
    
    def a3aridh_elbaher(self, *a):
        model = self.arodh.get_model()
        model.clear()
        baher = d_customs.value_active(self.baher)
        if baher == None: return
        a3aridh = d_tools.ela3aridh_in_behor[baher]
        for a in a3aridh:
            nm = d_tools.get_name(d_tools.ela3aridh, a)
            model.append([a, nm])
    
    def select_age(self, *a):
        if d_customs.value_active(self.ages) == 8: self.lands.set_sensitive(True)
        else:
            self.lands.set_active(-1)
            self.lands.set_sensitive(False)
    
    def tashkeel_cb(self, btn, haraka):
        self.view_nasse_bfr.insert_at_cursor(haraka)
    
    def merge_poet_cb(self, *a):
        if d_customs.can_modify(self.parent):
            new_poet = self.poets_entry1.get_text()
            if new_poet == '': return
            poet, sex, balad, age = self.parent.db.id_name_poet(new_poet)
            if poet == None: d_customs.erro(self.parent, 'ضع الاسم الصحيح للشاعر'); return
            model, i = self.sel_poet.get_selected()
            if i:
                poet_old = model.get_value(i,0)
                self.parent.db.merge_poet(poet_old, poet, sex, balad, age)
                d_customs.info(self.parent, 'تم دمج ديوان {} مع ديوان {}'.format(model.get_value(i,1), new_poet))
    
    def move_poem_cb(self, *a):
        if d_customs.can_modify(self.parent):
            new_poet = self.poets_entry.get_text()
            if new_poet == '': return
            poet, sex, balad, age = self.parent.db.id_name_poet(new_poet)
            if poet == None: d_customs.erro(self.parent, 'ضع الاسم الصحيح للشاعر'); return
            model, i = self.sel_poem.get_selected()
            if i:
                poem = model.get_value(i,0)
                self.parent.db.change_poet(poem, poet, sex, balad, age)
                d_customs.info(self.parent, 'تم نقل القصيدة {} إلى ديوان {}'.format(model.get_value(i,1), new_poet))
                model.remove(i)
      
    def refresh_poets(self, *a):
        self.store_poet.clear()
        ls = self.db.all_poets()
        self.modelfilter = self.store_poet.filter_new()
        ls.append([0, 'ما لا يعرف قائله', 0, 22, 9])
        self.names_list = []
        for a in ls:
            s_list = []
            self.store_poet.append(a)
            s_list.append(a[2])
            self.names_list.append(s_list)
        self.theword = self.names_list[:]
        self.modelfilter.set_visible_func(self.visible_cb, self.theword) 
        self.tree_poet.set_model(self.modelfilter)
      
    def build(self,*a): 
        Gtk.Box.__init__(self,spacing=3,orientation=Gtk.Orientation.VERTICAL)
        hp1 = Gtk.HPaned()
        self.pack_start(hp1, True, True, 0)
        self.tree_poet = d_customs.TreeClass()
        self.tree_poet.set_headers_visible(False)
        self.sel_poet = self.tree_poet.get_selection()
        cell = Gtk.CellRendererText()
        cell.set_property("wrap-mode", Pango.WrapMode.WORD_CHAR)
        cell.set_property("wrap-width", 150)
        kal = Gtk.TreeViewColumn('دواوين الشعراء', cell, text=1)
        self.tree_poet.append_column(kal)
        self.store_poet = Gtk.ListStore(int, str, int, int, int)
        self.refresh_poets()
        self.tree_poet.connect("cursor-changed", self.ok_poet)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_poet)
        scroll.set_size_request(150, -1)
        scroll.set_policy(Gtk.PolicyType.NEVER, Gtk.PolicyType.AUTOMATIC)
        vb = Gtk.Box(spacing=1,orientation=Gtk.Orientation.VERTICAL)
        try: self.search_poets = Gtk.SearchEntry()
        except: self.search_poets = Gtk.Entry()
        self.search_poets.set_placeholder_text('بحث عن شاعر')
        self.search_poets.connect('changed', self.search_cb)
        vb.pack_start(self.search_poets, False, False, 0)
        vb.pack_start(scroll, True, True, 0)
        hp1.pack1(vb, False, False)
        
        hp2 = Gtk.HPaned()
        hp1.pack2(hp2, True, True)
        self.store_poems = Gtk.ListStore(int, str)
        self.tree_poems = d_customs.TreeClass()
        self.tree_poems.set_model(self.store_poems)
        self.sel_poem = self.tree_poems.get_selection()
        self.tree_poems.set_grid_lines(Gtk.TreeViewGridLines.HORIZONTAL)
        self.tree_poems.connect("cursor-changed", self.ok_poem)
        poems = Gtk.TreeViewColumn('القصائد', Gtk.CellRendererText(), text=1)
        self.tree_poems.append_column(poems)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_poems)
        scroll.set_size_request(180, -1)
        hp2.pack1(scroll, False, False)
        
        self.notebk = Gtk.Notebook()
        hp2.pack2(self.notebk, True, True)
        self.notebk.set_show_tabs(False)
        self.nbk1 = Gtk.Notebook()
        self.nbk2 = Gtk.Notebook()
        self.view_nasse  = d_customs.ViewEdit()
        self.view_nasse.set_justification(Gtk.Justification.CENTER)
        self.view_nasse_bfr = self.view_nasse.get_buffer()
        self.view_nasse_bfr.connect('changed', self.change_text)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.view_nasse)
        vb = Gtk.Box(spacing=0, orientation=Gtk.Orientation.VERTICAL)
        
        hb1 = Gtk.Box(spacing=0, orientation=Gtk.Orientation.HORIZONTAL)
        hb1.set_border_width(3)
        hb = Gtk.Box(spacing=0, orientation=Gtk.Orientation.HORIZONTAL)
        Gtk.StyleContext.add_class(hb.get_style_context(), "linked")
        lab = Gtk.Label('التشكيل :   ')
        lab.set_alignment(0,0.5)
        hb1.pack_start(lab, False, False, 0)
        shadda = d_customs.tool_button(join(d_customs.ICON_DIR, 'shadda.png'), 'الشدة', self.tashkeel_cb, d_araby.SHADDA)
        hb.pack_start(shadda, False, False, 0)
        skon = d_customs.tool_button(join(d_customs.ICON_DIR, 'skon.png'), 'السكون',self.tashkeel_cb, d_araby.SUKUN)
        hb.pack_start(skon, False, False, 0)
        fatha = d_customs.tool_button(join(d_customs.ICON_DIR, 'fatha.png'), 'الفتحة',self.tashkeel_cb, d_araby.FATHA)
        hb.pack_start(fatha, False, False, 0)
        damma = d_customs.tool_button(join(d_customs.ICON_DIR, 'damma.png'), 'الضمة',self.tashkeel_cb, d_araby.DAMMA)
        hb.pack_start(damma, False, False, 0)
        kasra = d_customs.tool_button(join(d_customs.ICON_DIR, 'kasra.png'), 'الكسرة',self.tashkeel_cb, d_araby.KASRA)
        hb.pack_start(kasra, False, False, 0)
        fatha2 = d_customs.tool_button(join(d_customs.ICON_DIR, 'fatha2.png'), 'الفتحتين',self.tashkeel_cb, d_araby.FATHATAN)
        hb.pack_start(fatha2, False, False, 0)
        damma2 = d_customs.tool_button(join(d_customs.ICON_DIR, 'damma2.png'), 'الضمتين',self.tashkeel_cb, d_araby.DAMMATAN)
        hb.pack_start(damma2, False, False, 0)
        kasra2 = d_customs.tool_button(join(d_customs.ICON_DIR, 'kasra2.png'), 'الكسرتين',self.tashkeel_cb, d_araby.KASRATAN)
        hb.pack_start(kasra2, False, False, 0)
        hb1.pack_start(hb, False, False, 0)
        vb.pack_start(scroll, True, True, 0)
        
        self.redo = Gtk.ToolButton(stock_id=Gtk.STOCK_REDO)
        self.redo.set_sensitive(False)
        hb1.pack_end(self.redo, False, False, 3)
        self.redo.connect('clicked', self.redo_text)
        vb.pack_start(hb1, False, False, 0)
        lab = Gtk.Label('القصيدة')
        lab.set_size_request(100, -1)
        self.nbk1.append_page(vb, lab)
        
        self.view_charh = d_customs.ViewEdit()
        self.view_charh_bfr = self.view_charh.get_buffer()
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.view_charh)
        lab = Gtk.Label('الشرح')
        lab.set_size_request(100, -1)
        self.nbk1.append_page(scroll, lab)
        
        vb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.VERTICAL)
        vb.set_border_width(3)
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        la0 = Gtk.Label('اسم القصيدة')
        la0.set_alignment(0,0.5)
        hb.pack_start(la0, False, False, 0)
        self.nm_poem = Gtk.Entry()
        self.nm_poem.set_placeholder_text('إن لم يكن لها اسم ، اكتب صدر أول بيت بدلا من ذلك')
        hb.pack_start(self.nm_poem, True, True, 0)
        vb.pack_start(hb, False, False, 0)
  
        hb, self.naw3 = d_customs.combo(d_tools.elnaw3, 'النوع', 0)
        vb.pack_start(hb, False, False, 0)
        self.naw3.connect('changed', self.change_naw3)
        
        hb, self.gharadh = d_customs.combo(d_tools.elgharadh, 'الغرض', 0)
        vb.pack_start(hb, False, False, 0)
        self.active_gharadh = Gtk.CheckButton('')
        self.active_gharadh.set_active(True)
        def active_gharadh_cb(widget, *a):
            if self.active_gharadh.get_active():
                self.gharadh.set_sensitive(True)
            else:
                self.gharadh.set_sensitive(False)
        self.active_gharadh.connect('toggled', active_gharadh_cb)
        hb.pack_start(self.active_gharadh, False, False, 0)

        self.baher_hb, self.baher = d_customs.combo(d_tools.elbehor, 'البحر', 0)
        self.baher.connect('changed', self.a3aridh_elbaher)
        vb.pack_start(self.baher_hb, False, False, 0)
        self.active_baher = Gtk.CheckButton('')
        self.active_baher.set_active(True)
        def active_baher_cb(widget, *a):
            if self.active_baher.get_active():
                self.baher.set_sensitive(True)
            else:
                self.baher.set_sensitive(False)
        self.active_baher.connect('toggled', active_baher_cb)
        self.baher_hb.pack_start(self.active_baher, False, False, 0)
        
        self.rawi_hb, self.rawi = d_customs.combo(d_tools.elrawi, 'الروي', 0)
        vb.pack_start(self.rawi_hb, False, False, 0)
        self.active_rawi = Gtk.CheckButton('')
        self.active_rawi.set_active(True)
        def active_rawi_cb(widget, *a):
            if self.active_rawi.get_active():
                self.rawi.set_sensitive(True)
            else:
                self.rawi.set_sensitive(False)
        self.active_rawi.connect('toggled', active_rawi_cb)
        self.rawi_hb.pack_start(self.active_rawi, False, False, 0)
        
        self.kafia_hb, self.kafia = d_customs.combo(d_tools.elkawafi, 'القافية', 0)
        vb.pack_start(self.kafia_hb, False, False, 0)
        self.active_kafia = Gtk.CheckButton('')
        self.active_kafia.set_active(True)
        def active_kafia_cb(widget, *a):
            if self.active_kafia.get_active():
                self.kafia.set_sensitive(True)
            else:
                self.kafia.set_sensitive(False)
        self.active_kafia.connect('toggled', active_kafia_cb)
        self.kafia_hb.pack_start(self.active_kafia, False, False, 0)
        
        self.arodh_hb, self.arodh = d_customs.combo([], 'العروض وضربها', 0)
        vb.pack_start(self.arodh_hb, False, False, 0)
        self.active_arodh = Gtk.CheckButton('')
        self.active_arodh.set_active(True)
        def active_arodh_cb(widget, *a):
            if self.active_arodh.get_active():
                self.arodh.set_sensitive(True)
            else:
                self.arodh.set_sensitive(False)
        self.active_arodh.connect('toggled', active_arodh_cb)
        self.arodh_hb.pack_start(self.active_arodh, False, False, 0)
        
        la1 = Gtk.Label('سبب النظم')
        la1.set_alignment(0,1)
        vb.pack_start(la1, False, False, 0)
        self.view_sabab = d_customs.ViewEdit()
        self.view_sabab_bfr = self.view_sabab.get_buffer()
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.view_sabab)
        vb.pack_start(scroll, True, True, 0)
        lab = Gtk.Label('معلوماتها')
        lab.set_size_request(100, -1)
        self.nbk1.append_page(vb, lab)
        
        self.view_tarjama = d_customs.ViewEdit()
        self.view_tarjama_bfr = self.view_tarjama.get_buffer()
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.view_tarjama)
        lab = Gtk.Label('الترجمة')
        lab.set_size_request(120, -1)
        self.nbk2.append_page(scroll, lab)
        
        self.vb_poet = Gtk.Box(spacing=3, orientation=Gtk.Orientation.VERTICAL)
        self.vb_poet.set_border_width(3)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        hb.pack_start(Gtk.Label('الاسم المشتهر'), False, False, 0)
        self.lak_poet = Gtk.Entry()
        hb.pack_start(self.lak_poet, True, True, 0)
        self.vb_poet.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        hb.pack_start(Gtk.Label('الاسم الحقيقي'), False, False, 0)
        self.nm_poet = Gtk.Entry()
        hb.pack_start(self.nm_poet, True, True, 0)
        self.vb_poet.pack_start(hb, False, False, 0)
        
        hb, self.ages = d_customs.combo(d_tools.age_poet, 'العصر', 0)
        self.ages.connect('changed', self.select_age)
        self.vb_poet.pack_start(hb, False, False, 0)
        
        hb, self.lands = d_customs.combo(d_tools.elbalad, 'البلد', 0)
        self.vb_poet.pack_start(hb, False, False, 0)
        
        hb, self.sexs = d_customs.combo(d_tools.sex_poet, 'الجنس', 0)
        self.vb_poet.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        hb.pack_start(Gtk.Label('الوفاة (هـ)'), False, False, 0)
        adj = Gtk.Adjustment(1435, -300, 1435, 1, 5.0, 0.0)
        self.dh_poet = Gtk.SpinButton()
        self.dh_poet.set_adjustment(adj)
        self.dh_poet.set_wrap(True)
        hb.pack_start(self.dh_poet, False, False, 0)
        self.vb_poet.pack_start(hb, False, False, 0)
        lab = Gtk.Label('معلومات الشاعر')
        lab.set_size_request(120, -1)
        self.nbk2.append_page(self.vb_poet, lab)
        
        vb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.VERTICAL)
        vb.set_border_width(3)
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        move_poem = Gtk.Button('نقل القصيدة الحالية إلى ديوان : ')
        move_poem.connect('clicked', self.move_poem_cb)
        hb.pack_start(move_poem, False, False, 0)
        self.poets_entry = Gtk.Entry()
        self.poets_entry.set_placeholder_text('اكتب حرفا لتحصل على التكملة')
        self.completion03 = Gtk.EntryCompletion()
        self.completion03.set_model(self.store_poet)
        self.completion03.set_text_column(1)
        self.poets_entry.set_completion(self.completion03)
        hb.pack_start(self.poets_entry, True, True, 0)
        vb.pack_start(hb, False, False, 0)
        
        hbox = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)
        self.del_poem = Gtk.Button('حذف قصيدة')
        self.del_poem.connect('clicked',self.remove_poem)
        hbox.pack_start(self.del_poem, False, False, 0)
        vb.pack_start(hbox, False, False, 0)
        lab = Gtk.Label('متقدم')
        lab.set_size_request(100, -1)
        self.nbk1.append_page(vb, lab)
        
        vb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.VERTICAL)
        vb.set_border_width(3)
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        merge_poet = Gtk.Button('دمج الشاعر الحالي مع الشاعر : ')
        merge_poet.connect('clicked', self.merge_poet_cb)
        hb.pack_start(merge_poet, False, False, 0)
        self.poets_entry1 = Gtk.Entry()
        self.poets_entry1.set_placeholder_text('اكتب حرفا لتحصل على التكملة')
        self.completion04 = Gtk.EntryCompletion()
        self.completion04.set_model(self.store_poet)
        self.completion04.set_text_column(1)
        self.poets_entry1.set_completion(self.completion04)
        hb.pack_start(self.poets_entry1, True, True, 0)
        vb.pack_start(hb, False, False, 0)
        
        hbox = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)
        self.del_poet = Gtk.Button('حذف ديوان')
        self.del_poet.connect('clicked',self.remove_poet)
        hbox.pack_start(self.del_poet, False, False, 0)
        vb.pack_start(hbox, False, False, 0)
        lab = Gtk.Label('متقدم')
        lab.set_size_request(120, -1)
        self.nbk2.append_page(vb, lab)
        
        vb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.VERTICAL)
        hbox = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)
        self.modif_poet = Gtk.Button('تعديل الشاعر')
        self.modif_poet.connect('clicked',self.modify_poet_cb)
        hbox.pack_start(self.modif_poet, False, False, 0)
        vb.pack_start(self.nbk2, True, True, 0)
        vb.pack_start(hbox, False, False, 0)
        self.notebk.append_page(vb, Gtk.Label(''))
        
        vb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.VERTICAL)
        hbox = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)
        self.modif_poem = Gtk.Button('تعديل القصيدة')
        self.modif_poem.connect('clicked',self.modify_data)
        hbox.pack_start(self.modif_poem, False, False, 0)
        
        self.modif_direct = Gtk.CheckButton('تعديل بمجرد التغيير')
        def modif_direct_cb(widget, *a):
            if self.modif_direct.get_active():
                self.modif_poem.set_sensitive(False)
            else:
                self.modif_poem.set_sensitive(True)
        self.modif_direct.connect('toggled', modif_direct_cb)
        #hbox.pack_start(self.modif_direct, False, False, 11)
        vb.pack_start(self.nbk1, True, True, 0)
        vb.pack_start(hbox, False, False, 0)

        self.notebk.append_page(vb, Gtk.Label(''))

        self.show_all()
        