# -*- coding: utf-8 -*-

#a############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
#a############################################################################

from os.path import join, expanduser
import os
from shutil import copyfile, copytree
from d_contacts import MyDB
from gi.repository import Gtk
import d_config, d_customs
from d_about import About



# class نافذة التفضيلات----------------------------------------------------------       
        
class Preference(Gtk.Dialog):
    
    def __init__(self, parent):
        self.parent = parent
        self.db = MyDB()
        self.build()        
    
    def refresh(self, *a):
        self.parent.refresh()
        
    def specified(self, cbox):
        if cbox.get_active() == 0:
            self.frame.set_sensitive(False)
            d_config.setv('theme', 0)
            d_customs.info(self.parent, "سوف تحتاج إلى إعادة تشغيل برنامج الدواوين")
        elif cbox.get_active() == 1:
            self.frame.set_sensitive(False)
            d_config.setv('theme', 1)
        elif cbox.get_active() == 2:
            self.frame.set_sensitive(False)
            d_config.setv('theme', 2)
        elif cbox.get_active() == 3:
            self.frame.set_sensitive(False)
            d_config.setv('theme', 3)
        elif cbox.get_active() == 4:
            self.frame.set_sensitive(False)
            d_config.setv('theme', 4)
        elif cbox.get_active() == 5:
            self.frame.set_sensitive(True)
            d_config.setv('theme', 5)
        self.parent.theme.refresh()
        self.refresh()
        
    def ch_font(self, btn):
        nconf = btn.get_name()
        dialog = Gtk.FontChooserDialog("اختر خطا", self.parent)
        dialog.set_font(d_config.getv(nconf))
        response = dialog.run()
        if response == Gtk.ResponseType.OK:
            font = dialog.get_font()
            d_config.setv(nconf, font)
        dialog.destroy()
        self.parent.theme.refresh()
        
    def ch_color(self, btn):
        nconf = btn.get_name()
        dialog = Gtk.ColorChooserDialog("اختر لونا", self.parent)
        dialog.set_rgba(d_customs.rgba(d_config.getv(nconf)))
        response = dialog.run()
        if response == Gtk.ResponseType.OK:
            color = dialog.get_rgba().to_string()
            d_config.setv(nconf, color)
        dialog.destroy()
        self.parent.theme.refresh()
    
    def change_vls(self, btn, nm):
        v = btn.get_active()
        d_config.setv(nm, v)
   
    def change_path_db(self, *a):
        open_dlg = Gtk.FileChooserDialog('تغيير مسار قاعدة البيانات',
                                         self.parent, Gtk.FileChooserAction.OPEN,
                                        (Gtk.STOCK_OK, Gtk.ResponseType.OK,
                                         Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL))
        
        Filter = Gtk.FileFilter()
        Filter.set_name("قاعدة البيانات")
        Filter.add_pattern("Dawawin.db")
        open_dlg.add_filter(Filter)
        
        res = open_dlg.run()
        if res == Gtk.ResponseType.OK:
            d_config.setv('path', open_dlg.get_filenames()[0])  
            d_customs.info(self.parent, "سوف تحتاج إلى إعادة تشغيل برنامج الدواوين")    
        open_dlg.destroy()
    
    def new_db(self,*a): 
        save_dlg = Gtk.FileChooserDialog('مسار قاعدة البيانات الجديدة', self.parent,
                                    Gtk.FileChooserAction.SELECT_FOLDER,
                                    (Gtk.STOCK_OK, Gtk.ResponseType.OK,
                                    Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL))
        res = save_dlg.run()
        if res == Gtk.ResponseType.OK:
            new_dir = join(save_dlg.get_filename(), 'دواوين العرب')
            if os.path.exists(join(new_dir,'Dawawin.db')):
                d_customs.erro(self.parent, 'يوجد قاعدة بيانات في هذا الدليل بالفعل')
            else:
                if not os.path.exists(new_dir):
                    os.mkdir(new_dir)
                if not os.path.exists(join(new_dir,'Audio')):
                    os.mkdir(join(new_dir,'Audio'))
                if not os.path.exists(join(new_dir,'Books')):
                    os.mkdir(join(new_dir,'Books'))
                self.parent.db.create_db(join(new_dir,'Dawawin.db'))
                d_customs.info(self.parent, 'تم إضافة قاعدة بيانات جديدة')
        save_dlg.destroy()
   
    def copy_to_home_cb(self, *a):
        res = d_customs.sure(self.parent, '''
        قد تحتاج هذه العملية إذا كان لديك قاعدة بيانات
        في مسار لا تملك الصلاحيات للتعديل عليها فيه
        هل تريد المواصلة ؟''')
        if res == -8:
            save_dlg = Gtk.FileChooserDialog('مسار قاعدة البيانات الجديدة', self.parent,
                                    Gtk.FileChooserAction.SELECT_FOLDER,
                                    (Gtk.STOCK_OK, Gtk.ResponseType.OK,
                                    Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL))
            res0 = save_dlg.run()
            if res0 == Gtk.ResponseType.OK:
                new_dir = join(save_dlg.get_filename(), 'دواوين العرب')
                if os.path.exists(join(new_dir,'Dawawin.db')):
                    d_customs.erro(self.parent, 'يوجد قاعدة بيانات في هذا الدليل بالفعل')
                else:
                    copytree(d_customs.AUDIO_DIR, join(new_dir, 'Audio'))
                    copytree(d_customs.BOOKS_DIR, join(new_dir, 'Books'))
                    copyfile(d_customs.MY_DATA, join(new_dir,'Dawawin.db'))
                    d_customs.info(self.parent, 'تمت عملية النسخ بنجاح')
                    res1 = d_customs.sure(self.parent, 'قد تحتاج تغيير المسار إلى القاعدة الجديدة\nهل تريد فعل ذلك ؟')
                    if res1 == -8:
                        d_config.setv('path', join(new_dir, 'Dawawin.db'))    
                        d_customs.info(self.parent, "سوف تحتاج إلى إعادة تشغيل برنامج الدواوين")
            save_dlg.destroy()
       
    def switch_page(self, btn):
        if btn.get_active():
            if btn.get_name()== "theme":
                self.notebook.set_current_page(0)
                self.wins_btn.set_active(False)
                self.prop_btn.set_active(False)
                self.path_btn.set_active(False)
                self.info_btn.set_active(False)
            elif btn.get_name()== "wins":
                self.notebook.set_current_page(1)
                self.path_btn.set_active(False)
                self.theme_btn.set_active(False)
                self.prop_btn.set_active(False)
                self.info_btn.set_active(False)
            elif btn.get_name()== "path":
                self.notebook.set_current_page(2)
                self.wins_btn.set_active(False)
                self.theme_btn.set_active(False)
                self.prop_btn.set_active(False)
                self.info_btn.set_active(False)
            elif btn.get_name()== "prop":
                self.notebook.set_current_page(3)
                self.wins_btn.set_active(False)
                self.path_btn.set_active(False)
                self.theme_btn.set_active(False)
                self.info_btn.set_active(False)
            elif btn.get_name()== "info":
                self.notebook.set_current_page(4)
                self.wins_btn.set_active(False)
                self.path_btn.set_active(False)
                self.theme_btn.set_active(False)
                self.prop_btn.set_active(False)
    
    def count_cb(self, *a):
        d_customs.info(self.parent, '''
        إحصاء الدواوين والقصائد والأبيات الملحقة بقاعدة بيانات برنامج دواوين العرب :
        عدد الدواوين الإجمالي : {} ،
        عدد القصائد الإجمالي : {} ،
        عدد الأبيات الإجمالي : {} ،
        '''.format(self.parent.db.n_dawawin(), self.parent.db.n_poems(), self.parent.db.n_verses()))
     
    def open_page(self, btn, v): 
        if d_customs.can_modify(self.parent):
            self.parent.main_notebook.set_current_page(v)
             
    def build(self,*a):
        Gtk.Dialog.__init__(self, parent=self.parent)
        self.set_size_request(500, -1)
        vbox1 = self.vbox
        vbox = Gtk.Box(spacing=0,orientation=Gtk.Orientation.HORIZONTAL)
        Gtk.StyleContext.add_class(vbox.get_style_context(), "linked")
        hb_bar = Gtk.HeaderBar()
        hb_bar.set_show_close_button(True)
        self.set_titlebar(hb_bar)
        hb_bar.set_custom_title(vbox)
        vbox.set_border_width(3)
        self.notebook = Gtk.Notebook()
        self.notebook.set_show_tabs(False)
        
        box = Gtk.Box(spacing=5, orientation=Gtk.Orientation.VERTICAL)
        box1 = Gtk.Box(spacing=4, orientation=Gtk.Orientation.VERTICAL)
        box1.set_border_width(5)
        self.frame = Gtk.Frame()
        box.set_border_width(5)
        ls = ['بدون', 'أنيق' ,'أزرق','أحمر','معتم', 'مخصص']
        style_btn = Gtk.ComboBoxText()
        for a in ls:
            style_btn.append_text(a)
        style_btn.set_active(d_config.getn('theme'))
        style_btn.connect("changed", self.specified)
        if d_config.getn('theme') != 5: self.frame.set_sensitive(False)
        hb = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)
        hb.pack_start(Gtk.Label('النمط'), False, False, 0)
        hb.pack_end(style_btn, False, False, 0)
        box.pack_start(hb, False, False, 0)
        box.pack_start(self.frame, True, True, 0)
       
        list_w1 = [['القوائم الجانبية','td'], ['قائمة القصائد','tp'], ['متن القصيدة','mp'], 
                   ['الشرح والترجمة','ch'], ['العناوين','an']]
        list_w2 = [['لون خلفية العرض','b'], ['لون خط التحديد','fs'], ['لون خلفية التحديد','bs'], 
                   ['لون تحديد البحث','ss'], ['لون خلفية خاص','bp']]
        for a in list_w1:
            hbox = Gtk.Box(spacing=10,orientation=Gtk.Orientation.HORIZONTAL)
            btn1 = Gtk.ToolButton(stock_id = Gtk.STOCK_SELECT_FONT)
            btn1.set_name('font'+a[1])
            btn1.connect('clicked',self.ch_font)
            btn2 = Gtk.ToolButton(stock_id = Gtk.STOCK_SELECT_COLOR)
            btn2.set_name('color'+a[1])
            btn2.connect('clicked',self.ch_color)
            hbox.pack_end(btn2, False, False, 0)
            hbox.pack_end(btn1, False, False, 0)
            hbox.pack_start(Gtk.Label(a[0]), False, False, 0)
            box1.pack_start(hbox, False, False, 0)
            
        for a in list_w2:
            hbox = Gtk.Box(spacing=10,orientation=Gtk.Orientation.HORIZONTAL)
            btn = Gtk.ToolButton(stock_id = Gtk.STOCK_SELECT_COLOR)
            btn.set_name('color'+a[1])
            btn.connect('clicked',self.ch_color)
            hbox.pack_end(btn, False, False, 0)
            hbox.pack_start(Gtk.Label(a[0]), False, False, 0)
            box1.pack_start(hbox, False, False, 0)
            
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(box1)
        self.frame.add(scroll)
        
        hbox = Gtk.Box(spacing=10,orientation=Gtk.Orientation.HORIZONTAL)
        ref = Gtk.Button("تحديث الواجهة")
        ref.connect('clicked', self.refresh)
        hbox.pack_start(ref, False, False, 0)
        
        btn_font = Gtk.ToolButton(stock_id = Gtk.STOCK_SELECT_FONT)
        btn_font.set_name('fontall')
        btn_font.connect('clicked',self.ch_font)
        hbox.pack_end(btn_font, False, False, 0)
        hbox.pack_end(Gtk.Label('خط النافذة'), False, False, 0)
        box.pack_start(hbox, False, False, 0)
        self.notebook.append_page(box, Gtk.Label('خط ولون'))
        
        box = Gtk.Box(spacing=5, orientation=Gtk.Orientation.VERTICAL)
        box.set_border_width(6) 
        
        modif_all = Gtk.Button('نافذة الصيانة')
        modif_all.connect('clicked', self.open_page, 9)
        box.pack_start(modif_all, False, False, 0)
        
        btn_win_organize = Gtk.Button('نافذة التعديل')
        btn_win_organize.connect('clicked', self.open_page, 5)
        box.pack_start(btn_win_organize, False, False, 0)

        
        btn_win_export = Gtk.Button('نافذة المشاركة')
        btn_win_export.connect('clicked', self.open_page, 7)
        box.pack_start(btn_win_export, False, False, 0)
        
        btn_win_add = Gtk.Button('نافذة الإضافة')
        btn_win_add.connect('clicked', self.open_page, 6)
        box.pack_start(btn_win_add, False, False, 0)
        self.notebook.append_page(box, Gtk.Label('النوافذ'))

        box = Gtk.Box(spacing=5, orientation=Gtk.Orientation.VERTICAL)
        box.set_border_width(6) 
        
        b_dest = Gtk.Button('تغيير مسار قاعدة البيانات')
        b_dest.connect('clicked', self.change_path_db)  
        b_path = Gtk.Button('عرض المسار للقاعدة الحاليّة')
        b_path.connect('clicked', lambda *a: d_customs.info(self.parent, d_customs.MY_DATA))  
        box.pack_start(b_dest, False, False, 0)
        box.pack_start(b_path, False, False, 0)
        
        btn_new_db = Gtk.Button('إنشاء قاعدة البيانات  جديدة')
        btn_new_db.set_tooltip_text('قاعدة بيانات مفرغة لإعادة ملئها"')
        btn_new_db.connect('clicked', self.new_db)
        box.pack_start(btn_new_db, False, False, 0)  
        
        copy_to_home = Gtk.Button('نسخ قاعدة البيانات  إلى مسار جديد')
        copy_to_home.connect('clicked', self.copy_to_home_cb)
        box.pack_start(copy_to_home, False, False, 0)       
        self.notebook.append_page(box, Gtk.Label('المسار'))
        
        vb = Gtk.Box(spacing=5, orientation=Gtk.Orientation.VERTICAL)
        vb.set_border_width(6)
        ls = [[0, 'ضيق'],
            [1, 'وسط'],
            [2, 'واسع']]
        hb, self.bayn_abiat = d_customs.combo(ls, 'المسافة بين الأبيات', 3)
        self.bayn_abiat.set_active(d_config.getn('b_abiat'))
        self.bayn_abiat.connect('changed', self.change_vls, 'b_abiat')
        vb.pack_start(hb, False, False, 0)
        
        ls = [[0, 'ضيق'],
            [1, 'وسط'],
            [2, 'واسع']]
        hb, self.bayn_shater = d_customs.combo(ls, 'المسافة بين شطري البيت', 3)
        self.bayn_shater.set_active(d_config.getn('b_half'))
        self.bayn_shater.connect('changed', self.change_vls, 'b_half')
        vb.pack_start(hb, False, False, 0)
        
        ls = [[0, 'دوما'],
            [1, 'للحاجة']]
        hb, self.tarakeb = d_customs.combo(ls, 'تراكب شطري البيت', 3)
        self.tarakeb.set_active(d_config.getn('tarakeb'))
        self.tarakeb.connect('changed', self.change_vls, 'tarakeb')
        vb.pack_start(hb, False, False, 0)
        
        ls = [[0, 'بالتطويلات'],
            [1, 'بالمسافات']]
        hb, self.tandhid = d_customs.combo(ls, 'تعديل طول الشطر', 3)
        self.tandhid.set_active(d_config.getn('tandhid'))
        self.tandhid.connect('changed', self.change_vls, 'tandhid')
        vb.pack_start(hb, False, False, 0)
        
        hbox = Gtk.Box(spacing=10,orientation=Gtk.Orientation.HORIZONTAL)
        lab = Gtk.Label('أدنى طول للشطر بالبكسلات')
        lab.set_alignment(0,0.5)
        hbox.pack_start(lab, False, False, 0)
        adj = Gtk.Adjustment(150, 100, 700, 1, 5, 0)
        self.min_long = Gtk.SpinButton()
        self.min_long.set_size_request(150, -1)
        self.min_long.set_adjustment(adj)
        self.min_long.set_wrap(True)
        self.min_long.set_value(d_config.getf('min_long'))
        def change_min(widget, *a):
            v = self.min_long.get_value()
            d_config.setv('min_long', v)
        self.min_long.connect('value-changed', change_min)
        hbox.pack_end(self.min_long, False, False, 0)
        vb.pack_start(hbox, False, False, 0)
        
        hbox = Gtk.Box(spacing=10,orientation=Gtk.Orientation.HORIZONTAL)
        lab = Gtk.Label('التراكب إذا تجاوز طول الشطر')
        lab.set_alignment(0,0.5)
        hbox.pack_start(lab, False, False, 0)
        adj = Gtk.Adjustment(350, 300, 1000, 1, 5, 0)
        self.max_long = Gtk.SpinButton()
        self.max_long.set_size_request(150, -1)
        self.max_long.set_adjustment(adj)
        self.max_long.set_wrap(True)
        self.max_long.set_value(d_config.getf('max_long'))
        def change_max(widget, *a):
            v = self.max_long.get_value()
            d_config.setv('max_long', v)
        self.max_long.connect('value-changed', change_max)
        hbox.pack_end(self.max_long, False, False, 0)
        vb.pack_start(hbox, False, False, 0)
        
        ref = Gtk.Button("تحديث الواجهة")
        ref.connect('clicked', self.refresh)
        vb.pack_end(ref, False, False, 0)
        self.notebook.append_page(vb, Gtk.Label('تخطيط'))
        
        box = Gtk.Box(spacing=5, orientation=Gtk.Orientation.VERTICAL)
        box.set_border_width(6)
        self.n_poems_poets = Gtk.Button('عدد الدواوين والقصائد والأبيات')
        self.n_poems_poets.connect('clicked', self.count_cb)
        box.pack_start(self.n_poems_poets, False, False, 0)
        detail_count = Gtk.Button('إحصاء شامل مفصل وسريع')
        detail_count.connect('clicked', lambda *a: self.parent.main_notebook.set_current_page(8))
        box.pack_start(detail_count, False, False, 0)
        
        btn_about = Gtk.Button('حول برنامج دواوين العرب')
        btn_about.connect('clicked', lambda *a: About(self.parent))
        box.pack_start(btn_about, False, False, 0)
        
        btn_help = Gtk.Button('صفحة المساعدة')
        btn_help.connect('clicked', self.parent.show_help)
        box.pack_start(btn_help, False, False, 0)
        
        web_page = Gtk.LinkButton.new_with_label("http://sourceforge.net/projects/dawawin/files/",
                                                'صفحة البرنامج على الشّبكة')
        box.pack_start(web_page, False, False, 0)
        
        db_void = Gtk.LinkButton.new_with_label("http://sourceforge.net/projects/dawawin/files/DawawinArab.7z/download",
                                                'تنزيل قاعدة بيانات للتجربة')
        box.pack_start(db_void, False, False, 0)
        
        db_book = Gtk.LinkButton.new_with_label("http://sourceforge.net/projects/dawawin/files/AdabBooks.7z/download",
                                                'تنزيل مجموعة من الكتب الأدبية')
        box.pack_start(db_book, False, False, 0)
        self.notebook.append_page(box, Gtk.Label('المعلومات'))
        
        vbox1.pack_start(self.notebook, True, True, 0)
        
        self.theme_btn = Gtk.ToggleButton()
        img = Gtk.Image()
        img.set_from_icon_name('preferences-system', Gtk.IconSize.LARGE_TOOLBAR)
        self.theme_btn.set_image(img)
        self.theme_btn.set_name('theme')
        self.theme_btn.set_active(True)
        self.theme_btn.connect("clicked", self.switch_page)
        vbox.pack_start(self.theme_btn, False, False, 0)
        
        self.wins_btn = Gtk.ToggleButton()
        img = Gtk.Image()
        img.set_from_icon_name('go-home', Gtk.IconSize.LARGE_TOOLBAR)
        self.wins_btn.set_image(img)
        self.wins_btn.set_name('wins')
        self.wins_btn.connect("clicked", self.switch_page)
        vbox.pack_start(self.wins_btn, False, False, 0)
        
        self.path_btn = Gtk.ToggleButton()
        img = Gtk.Image()
        img.set_from_icon_name('document-open', Gtk.IconSize.LARGE_TOOLBAR)
        self.path_btn.set_image(img)
        self.path_btn.set_name('path')
        self.path_btn.connect("clicked", self.switch_page)
        vbox.pack_start(self.path_btn, False, False, 0)
        
        self.prop_btn = Gtk.ToggleButton()
        img = Gtk.Image()
        img.set_from_icon_name('document-properties', Gtk.IconSize.LARGE_TOOLBAR)
        self.prop_btn.set_image(img)
        self.prop_btn.set_name('prop')
        self.prop_btn.connect("clicked", self.switch_page)
        vbox.pack_start(self.prop_btn, False, False, 0)
        
        self.info_btn = Gtk.ToggleButton()
        img = Gtk.Image()
        img.set_from_icon_name('dialog-information', Gtk.IconSize.LARGE_TOOLBAR)
        self.info_btn.set_image(img)
        self.info_btn.set_name('info')
        self.info_btn.connect("clicked", self.switch_page)
        vbox.pack_start(self.info_btn, False, False, 0)
        
        self.show_all()