# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
##############################################################################

from gi.repository import Gtk
from d_contacts import MyDB
import d_customs, d_tools

# class صفحة التسلية-------------------------------------------------------------------    

class Repair(Gtk.Box):
    
    def search_on_page(self, text):
        return
    
    def near_page(self, v):
        return
    
    def modify_langer(self, *a):
        msg = d_customs.sure(self.parent, '''
            هذه العملية تستغرق وقتا وقد تكون بدون فائدة 
            تابع إن كنت متأكدا من وجود قصائد غير منظمة ؟
            ''' )
        if msg == Gtk.ResponseType.NO:
            return
        label = Gtk.Label()
        ls_poem = self.db.poems_0_langer()
        self.set_sensitive(False)
        s = 0
        for a in ls_poem:
            s += 1
            n = float(s)/float(len(ls_poem))
            while (Gtk.events_pending()): Gtk.main_iteration()
            text_poem = self.db.get_poem(a[0])[0]
            langer = d_tools.longer_half(text_poem, label, d_tools.is_machtor(text_poem))[0]
            self.db.repair_langer(a[0], langer)
            self.progress_langer.set_fraction(n)
        self.set_sensitive(True)
        self.progress_langer.set_fraction(0.0)
        d_customs.info(self.parent, 'تم الأمر بنجاح')
    
    def modify_rawi(self, *a):
        ls_poem = self.db.poems_no_rawi()
        if len(ls_poem) == 0: 
            d_customs.info(self.parent, 'لا يوجد قصائد رويها غير معروف')
            return
        self.set_sensitive(False)
        s = 0
        for a in ls_poem:
            s += 1
            n = float(s)/float(len(ls_poem))
            while (Gtk.events_pending()): Gtk.main_iteration()
            text_poem = self.db.get_poem(a[0])[0]
            rawi = d_tools.get_int_rawi(d_tools.rawi_poem(text_poem))
            self.db.repair_rawi(a[0], rawi)
            self.progress_rawi.set_fraction(n)
        self.set_sensitive(True)
        self.progress_rawi.set_fraction(0.0)
        
    def modify_kafia(self, *a):
        ls_poem = self.db.poems_no_kafia()
        if len(ls_poem) == 0: 
            d_customs.info(self.parent, 'لا يوجد قصائد قافيتها غير معروفة')
            return
        self.set_sensitive(False)
        s = 0
        for a in ls_poem:
            s += 1
            n = float(s)/float(len(ls_poem))
            while (Gtk.events_pending()): Gtk.main_iteration()
            text_poem = self.db.get_poem(a[0])[0]
            kafia = d_tools.kafia_poem(text_poem)
            self.db.repair_kafia(a[0], kafia)
            self.progress_kafia.set_fraction(n)
        self.set_sensitive(True)
        self.progress_kafia.set_fraction(0.0)
        
    def modify_abiat(self, *a):
        ls_poem = self.db.poems_0_abiat()
        if len(ls_poem) == 0: 
            d_customs.info(self.parent, 'لا يوجد قصائد عدد أبياتها غير معروف')
            return
        self.set_sensitive(False)
        s = 0
        for a in ls_poem:
            s += 1
            n = float(s)/float(len(ls_poem))
            while (Gtk.events_pending()): Gtk.main_iteration()
            text_poem = self.db.get_poem(a[0])[0]
            if d_tools.is_machtor(text_poem):
                abiat = d_tools.my_split(text_poem, 1)[1]
            else:
                abiat = d_tools.my_split(text_poem, 0)[1]
            self.db.repair_abiat(a[0], abiat)
            self.progress_abiat.set_fraction(n)
        self.set_sensitive(True)
        self.progress_abiat.set_fraction(0.0)
        
    def __init__(self, parent):
        self.parent = parent
        self.db = MyDB()
        Gtk.Box.__init__(self, spacing=3, orientation=Gtk.Orientation.VERTICAL)
        
        # a --------------------------------------------
        self.set_border_width(3)
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        modif_langer = Gtk.Button('إصلاح التنظيم')
        modif_langer.set_size_request(200, -1)
        modif_langer.set_tooltip_text('إصلاح القصائد التي تظهر غير مستوية الأشطار')
        modif_langer.connect('clicked',self.modify_langer)
        self.progress_langer = Gtk.ProgressBar()
        hb.pack_start(modif_langer, False, False, 0)
        hb.pack_start(self.progress_langer, True, True, 0)
        self.pack_start(hb, False, False, 0)
        
        hb =Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        modif_rawi = Gtk.Button('إصلاح الروي')
        modif_rawi.set_size_request(200, -1)
        modif_rawi.set_tooltip_text('إصلاح حرف الروي في جميع القصائد غير المعروف رويها')
        modif_rawi.connect('clicked',self.modify_rawi)
        self.progress_rawi = Gtk.ProgressBar()
        hb.pack_start(modif_rawi, False, False, 0)
        hb.pack_start(self.progress_rawi, True, True, 0)
        self.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        modif_kafia = Gtk.Button('إصلاح القافية')
        modif_kafia.set_size_request(200, -1)
        modif_kafia.set_tooltip_text('إصلاح القافية في جميع القصائد غير المعروف قافيتها')
        modif_kafia.connect('clicked',self.modify_kafia)
        self.progress_kafia = Gtk.ProgressBar()
        hb.pack_start(modif_kafia, False, False, 0)
        hb.pack_start(self.progress_kafia, True, True, 0)
        self.pack_start(hb, False, False, 0)
        
        hb = Gtk.Box(spacing=3, orientation=Gtk.Orientation.HORIZONTAL)
        modif_abiat = Gtk.Button('إصلاح عدد الأبيات')
        modif_abiat.set_size_request(200, -1)
        modif_abiat.set_tooltip_text('إصلاح عدد الأبيات في جميع القصائد غير المعروف عدد أبياتها')
        modif_abiat.connect('clicked',self.modify_abiat)
        self.progress_abiat = Gtk.ProgressBar()
        hb.pack_start(modif_abiat, False, False, 0)
        hb.pack_start(self.progress_abiat, True, True, 0)
        self.pack_start(hb, False, False, 0)
        self.show_all()