#!/usr/bin/python
# -*- coding: utf-8 -*-

#a############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
#a############################################################################

import re, itertools
import  d_araby
from d_contacts import AwzanDB
z = 1

myawzan = AwzanDB()

#a العلل والزحافات------------------------------------------------------------
  
Zihafat_3ilal = { 
                 0:['لا شيء','صحيحة','صحيح'],
                 100:['لا شيء','صحيحة','صحيح'],
                 1:['إذالة','مذالة','مذال'],
                 2:['إضمار','مضمرة','مضمر'], 
                 3:['بتر','بتراء','أبتر'], 
                 4:['ترفيل','مرفّلة','مرفّل'], 
                 5:['تسبيغ','مسبّغة','مسبّغ'], 
                 6:['تشعيث','مشعّثة','مشعّث'], 
                 7:['ثلم','ثلماء','أثوم'], 
                 8:['جمم','جمّاء','أجمّ'], 
                 9:['حذذ','حذّاء','أحذّ'], 
                 10:['حذف','محذوفة','محذوف'], 
                 11:['خبل','مخبولة','مخبول'], 
                 12:['خبن','مخبونة','مخبون'], 
                 13:['خرب','خرباء','أخرب'], 
                 14:['خرم','خرماء','أخرم'], 
                 15:['خزل','مخزولة','مخزول'], 
                 16:['شتر','شتراء','أشتر'], 
                 17:['شكل','مشكولة','مشكول'], 
                 18:['صلم','صلماء','أصلم'], 
                 19:['طيّ','مطويّة','مطويّ'], 
                 20:['عصب','عصباء','أعصب'], 
                 21:['عضب','عضباء','أعضب'], 
                 22:['عقص','عقصاء','أعقص'], 
                 23:['عقل','معقولة','معقول'], 
                 24:['قبض','مقبوضة','مقبوض'], 
                 25:['قصر','مقصورة','مقصور'], 
                 26:['قصم','قصماء','أقصم'], 
                 27:['قطع','مقطوعة','مقطوع'], 
                 28:['قطف','مقطوفة','مقطوف'], 
                 29:['كفّ','مكفوفة','مكفوف'], 
                 30:['كبل','مكبولة','مكبول'], 
                 31:['نقص','منقوصة','منقوص'], 
                 32:['كسف','مكسوفة','مكسوف'], 
                 33:['وقص','موقوصة','موقوص'], 
                 34:['وقف','موقوفة','موقوف'],
                 35:['ثرم','ثرماء','أثرم'],
                 36:['إذالة وخبن','مذالة مخبونة','مذال مخبون'],
                 37:['إذالة وطيّ','مذالة مطويّة','مذال مطويّ'],
                 38:['إذالة وخبل','مذالة مخبولة','مذال مخبول'],
                 39:['خبن وقصر','مخبونة مقصورة','مخبون مقصور'], 
                 40:['خبن وحذف','مخبونة محذوفة','مخبون محذوف'],
                 41:['خبن وتسبيغ','مخبونة مسبّغة','مخبون مسبّغ'],
                 42:['إضمار وقطع','مضمرة مقطوعة','مضمر مقطوع'],
                 43:['إضمار وحذذ','مضمرة حذّاء','مضمر أحذّ'],
                 44:['إذالة وإضمار','مذالة مضمرة','مذال مضمر'],
                 45:['إذالة ووقص','مذالة موقوصة','مذال موقوص'],
                 46:['إذالة وخزل','مذالة خزلاء','مذال أخزل'], 
                 47:['إضمار وترفيل','مضمرة مرفّلة','مضمر مرفّل'],
                 48:['ترفيل ووقص','مرفّلة موقوصة','مرفّل موقوص'],
                 49:['ترفيل وخزل','مرفّلة خزلاء','مرفّل أخزل'],
                 50:['خبن ووقف','مخبونة موقوفة','مخبون موقوف'],
                 51:['طيّ ووقف','مطويّة موقوفة','مطويّ موقوف'],
                 52:['خبن وكسف','مخبونة مكسوفة','مخبون مكسوف'],
                 53:['طيّ وكسف','مكسوفة مطويّة','مكسوف مطويّ'],
                 54:['كسف وخبل','مكسوفة مخبولة','مكسوف مخبول'],
                 55:['خبل غير لازم','صحيحة دخلها خبل غير لازم','صحيح دخله خبل غير لازم'],
                 56:['خبن غير لازم','صحيحة دخلها خبن غير لازم','صحيح دخله خبن غير لازم'],
                 57:['كفّ غير لازم','صحيحة دخلها كفّ غير لازم','صحيح دخله كفّ غير لازم'],
                 58:['شكل غير لازم','صحيحة دخلها شكل غير لازم','صحيح دخله شكل غير لازم'],
                 59:['طيّ غير لازم','صحيحة دخلها طيّ غير لازم','صحيح دخله طيّ غير لازم'],
                 60:['إذالة وخبن غير لازم','مذالة دخلها خبن غير لازم','مذال دخله خبن غير لازم'],
                 61:['إذالة وطيّ غير لازم','مذالة دخلها طيّ غير لازم','مذال دخله طيّ غير لازم'],
                 62:['إذالة وخبل غير لازم','مذالة دخلها خبل غير لازم','مذال دخله خبل غير لازم'],
                 63:['قطع وخبن غير لازم','مقطوعة دخلها خبن غير لازم','مقطوع دخله خبن غير لازم'],
                 64:['قطف وقصر غير لازم','مقطوفة دخلها قصر غير لازم','مقطوف دخله قصر غير لازم'],
                 65:['قطف وقبض غير لازم','مقطوفة دخلها قبض غير لازم','مقطوف دخله قبض غير لازم'],
                 66:['عصب غير لازم','صحيحة دخلها عصب غير لازم','صحيح دخله عصب غير لازم'],
                 67:['إضمار غير لازم','صحيحة دخلها إضمار غير لازم','صحيح دخله إضمار غير لازم'],
                 68:['وقص غير لازم','صحيحة دخلها وقص غير لازم','صحيح دخله وقص غير لازم'],
                 69:['خزل غير لازم','صحيحة دخلها خزل غير لازم','صحيح دخله خزل غير لازم'],
                 70:['قطع وإضمار غير لازم','مقطوعة دخلها إضمار غير لازم','مقطوع دخله إضمار غير لازم'],
                 71:['إذالة وإضمار غير لازم','مذالة دخلها إضمار غير لازم','مذال دخله إضمار غير لازم'],
                 72:['إذالة ووقص غير لازم','مذالة دخلها وقص غير لازم','مذال دخله وقص غير لازم'],
                 73:['إذالة وخزل غير لازم','مذالة دخلها خزل غير لازم','مذال دخله خزل غير لازم'],
                 74:['ترفيل وإضمار غير لازم','مرفّلة دخلها إضمار غير لازم','مرفّل دخله إضمار غير لازم'],
                 75:['ترفيل ووقص غير لازم','مرفّلة دخلها وقص غير لازم','مرفّل دخله وقص غير لازم'],
                 76:['ترفيل وخزل غير لازم','مرفّلة دخلها خزل غير لازم','مرفّل دخله خزل غير لازم'],
                 77:['تسبيغ وخبن غير لازم','مسبّغة دخلها خبن غير لازم','مسبّغ دخله خبن غير لازم'],
                 78:['تسبيغ وكفّ غير لازم','مسبّغة دخلها كفّ غير لازم','مسبّغ دخله كفّ غير لازم'],
                 79:['تسبيغ وشكل غير لازم','مسبّغة دخلها شكل غير لازم','مسبّغ دخله شكل غير لازم'],
                 80:['حذف وخبن غير لازم','محذوفة دخلها خبن غير لازم','محذوف دخله خبن غير لازم'],
                 81:['قصر وخبن غير لازم','مقصورة دخلها خبن غير لازم','مقصور دخله خبن غير لازم'],
                 82:['وقف وخبن غير لازم','موقوفة دخلها خبن غير لازم','موقوف دخله خبن غير لازم'],
                 83:['قطع وطيّ غير لازم','مقطوعة دخلها طيّ غير لازم','مقطوع دخله طيّ غير لازم'],
                 84:['كسف وخبن غير لازم','مكسوفة دخلها خبن غير لازم','مكسوف دخله خبن غير لازم'],
                 85:['تشعيث غير لازم','صحيحة دخلها تشعيث غير لازم','صحيح دخله تشعيث غير لازم'],
                 86:['حذف غير لازم','صحيحة دخلها حذف غير لازم','صحيح دخله حذف غير لازم'],
                 87:['قبض غير لازم','صحيحة دخلها قبض غير لازم','صحيح دخله قبض غير لازم'],
                 88:['قطع غير لازم','صحيحة دخلها قطع غير لازم','صحيح دخله قطع غير لازم'],
                 89:['إذالة وقطع غير لازم','مذالة دخلها قطع غير لازم','مذال دخله قطع غير لازم'],
                 90:['ترفيل وخبن','مرفّلة مخبونة','مرفّل مخبون'],
                 91:['ترفيل وخبن وقطع غير لازم','مرفّلة مخبونة دخلها قطع غير لازم','مرفّل مخبون دخله قطع غير لازم'],
                 92:['عقل غير لازم','صحيحة دخلها عقل غير لازم','صحيح دخله عقل غير لازم'],
                 93:['عصب وكفّ غير لازم','عصباء دخلها كفّ غير لازم','أعصب دخله كفّ غير لازم'],
                 94:['عصب وقبض غير لازم','عصباء دخلها قبض غير لازم','أعصب دخله قبض غير لازم'],
                 95:['نقص غير لازم','صحيحة دخلها نقص غير لازم','صحيح دخله نقص غير لازم'],
                 }

Zihafat_ta3rif = { 
                 1:['إذالة','الإذالة :\n زيادة حرف ساكن على الوتد المجموع في ضرب البيت، ومثاله: مستفعلنْ يدخلها الإذالة فتصير مستفعلان.'],
                 2:['إضمار','الإضمار :\nوهو تسكين ثاني التفعيلة إذا كان متحركاً وثاني سبب، ومثاله: مُتَفاعِلُنْ يدخلها الإضمار فتصير : مُتْفاعِلُنْ.'], 
                 3:['بتر','البتر :\nحذف سبب خفيف في عروض البيت أو ضربه ثم قطع الوتد الذي قبله، ومثاله: فعولن تدخلها علة البتر فتصير فعْ.'], 
                 4:['ترفيل','الترفيل :\nزيادة سبب خفيف على الوتد المجموع في ضرب البيت، ومثاله: فاعِلُنْ يدخلها الترفيل فتصير فاعلاتن.'], 
                 5:['تسبيغ','التسبيغ :\nزيادة حرف ساكن على السبب الخفيف فى آخر الضرب، ومثاله:فاعلاتن تدخلها  علة التسبيغ فتصير فاعلاتان.'], 
                 6:['تشعيث','التشعيث :\nوهو حذف الحرف الأول أو الثاني في الوتد المجموع، ومثاله: فاعلن تدخله علة التشعيث فيصير:فاعِنْ أو فالُنْ.'], 
                 7:['ثلم','الثلم :\nالثلم والخرم بمعنى واحد،وهو حذف الحرف الأول من الوتد المجموع في التفعيلة الأولى في الشطر، ويكون في فعولن و مفاعيلن ومفاعلتن.'], 
                 8:['جمم','الجمم :\nهو تغيير يلحق مفاعلتن في بحر الوافر وبيانه: يدخل  العقل  مفاعلتن فتصير مفاعتن بحذف اللام ثم يلحقها الخرم فتصير فاعتن.'], 
                 9:['حذذ','الحذذ :\nوهو حذف الوتد المجموع من آخر التفعيلة، ومثاله: متفاعلن يدخلها الحذذ فتصير :متفا.'], 
                 10:['حذف','الحذف :\nإسقاط السبب الخفيف من آخر التفعيلة في عروض البيت أو ضربه،ومثاله :مفاعيلن تدخلها  علة الحذف فتصير مفاعي.'], 
                 11:['خبل','الخبل :\nوهو زحاف مركب من الخبن والطي، ومثاله : مُسْتَفْعِلُنْ يدخلها الخبن أولاً فتصير: مُتَفْعِلُنْ ثم يعقبه الطي فتصير : مُتَعِلُنْ.'], 
                 12:['خبن','الخبن :\nوهو حذف  الحرف الثاني من التفعيلة متى كان ساكناً وثاني سبب، ومثاله : مُسْتَفْعِلُنْ يدخلها الخبن فتصير :مُتَفْعِلُنْ.'], 
                 13:['خرب','الخرب :\nهو حذف الحرف الأول و الحرف الأخير من التفعيلة الأولى في الشطر الأول، ومثاله: مفاعيلن يدخلها الخرب فتصير فاعيل كما في بحر الهزج.'], 
                 14:['خرم','الخرم :\nوهو حذف الحرف الأول من الوتد المجموع في التفعيلة الأولى في الشطر، ويكون في فعولن و مفاعيلن ومفاعلتن.'], 
                 15:['خزل','الخزل :\nوهو زحاف مركب من الإضمار والطي، ومثاله:مُتَفاعِلُنْ يدخلها الإطمار أولاً فتصير :مُتْفاعِلُن ثم يعقبه الطي :فتصير :مُتْفَعِلُنْ.'], 
                 16:['شتر','الشتر :\nإسقاط الحرف الأول والخامس من التفعيلة الأولى  في الشطر الأول أو الثاني من البيت ويختص به بحرا الهزج والمضارع.'], 
                 17:['شكل','الشكل :\nوهو زحاف مركب من الخبن والكف، ومثاله فاعِلاتُنْ يدخلها الخبن أولاً فتصير :فَعِلاتُنْ ثم يعقبه الكف فتصير :فَعِلاتُ.'], 
                 18:['صلم','الصلم :\nحذف  الوتد المفروق في عروض البيت أوضربه، ومثاله: مفعولات تدخلها علة الصلم فتصير مفعو.'], 
                 19:['طيّ','الطي :\nوهو حدف الحرف الرابع من التفعيلة متى كان ساكناً، ومثاله: مُتَفاعِلُنْ يدخلها  الطي فتصير :مُتَفَعِلُنْ.'], 
                 20:['عصب','العصب :\nوهو تسكين الحرف الخامس من التفعيلة متى كان متحركاً وثاني سبب، ومثاله: مُفاعَلَتُنْ يدخلها العصب فتصير : مُفاعَلْتُنْ.'], 
                 21:['عضب','العضب :\nويقع في بحر الوافر في التفعيلة الأولى من الشطر الأول فإذا خرمت مفاعلتن صارت فاعَلتن.'], 
                 22:['عقص','العقص :\nهو تغيير يلحق مفاعلتن في بحر الوافر وبيانه: يدخل العصب على مفاعلتن فتصير مفاعلْتن بتسكين اللام ثم يلحقها الكف فتصير مفاعلْت ثم يلحقها الخرم فتصير فاعلْتُ بتسكين اللام.'], 
                 23:['عقل','العقل :\nوهو حذف خامس التفعيلة متى كان متحركاً وثاني سبب ومثاله:مُفاعَلَتُنْ يدخلها زحاف العقل فتصير : مُفاعَتُنْ.'], 
                 24:['قبض','القبض :\nوهو حذف الحرف الخامس من التفعيلة متى كان ساكناً وثاني سبب، ومثاله:فَعولُنْ يدخلها زحاف القبض فتصير :فَعولُ.'], 
                 25:['قصر','القصر :\nحذف ساكن السبب الخفيف في عروض البيت أوضربه  وتسكين متحركه، ومثاله: فاعلاتُن تدخلها علة القصر فتصير فاعلاتْ.'], 
                 26:['قصم','القصم :\nهو تغيير يلحق مفاعلتن في بحر الوافر وبيانه: يدخل العصب على مفاعلتن فتصير مفاعلْتن بتسكين اللام ثم يلحقها الخرم فتصير فاعلْتن.'], 
                 27:['قطع','القطع :\nحذف ساكن الوتد المجموع  في عروض البيت أو ضربه وتسكين ما قبله، ومثاله: متفاعلن تدخله  علة القطع فيصير متفاعلْ.'], 
                 28:['قطف','القطف :\nإسقاط السبب الخفيف من آخر التفعيلة في عروض البيت أو ضربه وتسكين ماقبله، ومثاله: مفاعلَتن تدخلها  علة القطف فتصير :مفاعلْ.'], 
                 29:['كفّ','الكف :\nوهو حذف الحرف السابع من التفعيلة متى كان ساكناً وثاني سبب، ومثاله: مَفاعيلُنْ يدخلها زحاف الكف فتصير : مَفاعيلُ.'], 
                 30:['كبل','الكبل :\nوهو زحاف مركب من الخبن والقطع، ومثاله مسْتَفْعِلُنْ يدخلها الخبن أولاً فتصير :متَفْعِلُنْ ثم يعقبه القطع فتصير :فَعُولُنْ.'], 
                 31:['نقص','النقص :\nوهوزحاف مركب من العصب والكف ،ومثاله مُفاعَلَتُنْ يدخلها العصب أولاً فتصير:مُفاعَلْتُنْ ثم يعقبه الكف فتصير:مُفاعَلْتُ.'], 
                 32:['كسف','الكسف :\nالكسف أو الكشف وهو حذف  آخر الوتد المفروق  في العروض أو الضرب، ومثاله: مفعولاتُ يدخلها الكسف فتصير: مغعولا.'], 
                 33:['وقص','الوقص :\nوهو حذف ثاني التفعيلة متى كان متحركاَ وثاني سبب، ومثاله: متَفاعلن يدخلها الوقص فتصير : مفاعلن.'], 
                 34:['وقف','الوقف :\nتسكين آخر الوتد المفروق في عروض البيت أو ضربه، ومثاله :مفعولاتُ تدخلها علة الوقف فتصير مفعولاتْ.'],
                 35:['ثرم','الثرم :\nوهو خرم فعولُ أي حذف أول متحرك فيها فتصير عولُ وتنقل إلى فعْلُ.'],
                 36:['إذالة وخبن', [1,12]],
                 37:['إذالة وطيّ',[1,19]],
                 38:['إذالة وخبل',[1,11]],
                 44:['إذالة وإضمار',[1,2]],
                 45:['إذالة ووقص',[1,33]],
                 46:['إذالة وخزل',[1,15]], 
                 89:['إذالة وقطع',[1,27]],
                 39:['خبن وقصر',[12,25]], 
                 40:['خبن وحذف',[12,10]],
                 41:['خبن وتسبيغ',[12,5]],
                 50:['خبن ووقف',[12,34]],
                 52:['خبن وكسف',[12,32]],
                 63:['قطع وخبن',[27,1]],
                 90:['ترفيل وخبن',[4,1]],
                 42:['إضمار وقطع',[2,27]],
                 43:['إضمار وحذذ',[2,9]],
                 47:['إضمار وترفيل',[2,4]],
                 48:['ترفيل ووقص',[4,33]],
                 49:['ترفيل وخزل',[4,15]],
                 51:['طيّ ووقف',[19,34]],
                 53:['طيّ وكسف',[19,32]],
                 54:['كسف وخبل',[32,11]],
                 64:['قطف وقصر',[28,25]],
                 65:['قطف وقبض',[28,24]],
                 78:['تسبيغ وكفّ',[5,29]],
                 79:['تسبيغ وشكل',[5,17]],
                 83:['قطع وطيّ',[27,19]],
                 93:['عصب وكفّ',[20,29]],
                 94:['عصب وقبض ',[20,24]],
                 }

#a التفعيلات العشر الرئيسة----------------------------------------------------  

Taf3ilat = {1:'فَعُولُنْ', 
            2:'فَاعِلُنْ', 
            3:'مُسْتَفْعِلُنْ', 
            4:'مَفَاعِيلُنْ', 
            5:'فَاعِلَاتُنْ', 
            6:'مُفَاعَلَتُنْ', 
            7:'مُتَفَاعِلُنْ', 
            8:'مَفْعُولَاتُ',
            9:'مُسْتَفْعِ_لُنْ',  
            0:'فَاعِ_لَاتُنْ', }

#a التغيرات الطارئة على التفعيلات-----------------------------------------------
#a   التغيرات عبارة عن قاموس مفاتيحه هي التفعيلات العشر الرئيسة  
#a   القيمة المقابلة لكل مفتاح هي قاموس التحولات التي تطرأ على التفعيلة  
#a   قاموس التحولات مفاتيحه الزحافات والعلل وقيمها هي صورة التفعيلة بعد التحول  
          
Changes = {
            1:{24:'فَعُولُ',
              87:'فَعُولُ', 
              25:'فَعُولْ', 
              7:'فَعْلُنْ', 
              35:'فَعْلُ', 
              10:'فَعَلْ',
              86:'فَعَلْ', 
              3:'فَعْ',},
           
            2:{12:'فَعِلُنْ', 
              56:'فَعِلُنْ', 
              27:'فَعْلُنْ',
              88:'فَعْلُنْ',
              1:'فَاعَلَانْ',
              60:'فَعِلَانْ',
              89:'فَعْلَانْ',
              90:'فَعِلَاتُنْ',
              91:'فَعْلَاتُنْ',},
           
            3:{12:'مَفَاعِلُنْ',
              56:'مَفَاعِلُنْ', 
              83:'فَاعِلُنْ', 
              19:'مُفْتَعِلُنْ', 
              59:'مُفْتَعِلُنْ',  
              11:'فَعَلَتُنْ',
              55:'فَعَلَتُنْ', 
              29:'مُسْتَفْعِلُ', 
              17:'مَفَاعِلُ', 
              27:'مَفْعُولُنْ', 
              30:'فَعُولُنْ',
              63:'فَعُولُنْ', 
              1:'مُسْتَفْعِلَانْ', 
              36:'مُفَاعِلَانْ', 
              37:'مُفْتَعِلَانْ', 
              38:'فَعَلَتَانْ',
              60:'مُفَاعِلَانْ', 
              61:'مُفْتَعِلَانْ', 
              62:'فَعَلَتَانْ',},
           
            4:{24:'مَفَاعِلُنْ', 
              29:'مَفَاعِيلُ', 
              57:'مَفَاعِيلُ', 
              25:'مَفَاعِيلْ', 
              10:'فَعُولُنْ', 
              14:'مَفْعُولُنْ', 
              16:'فَاعِلُنْ', 
              13:'مَفْعُولُ',},
           
            5:{12:'فَعِلَاتُنْ',
              56:'فَعِلَاتُنْ', 
              29:'فَاعِلَاتُ',
              57:'فَاعِلَاتُ', 
              17:'فَعِلَاتُ',
              58:'فَعِلَاتُ',
              25:'فَاعِلَانْ',
              39:'فَعِلَانْ',
              81:'فَعِلَانْ',
              10:'فَاعِلُنْ',
              40:'فَعِلُنْ',
              80:'فَعِلُنْ',
              3:'فَعْلُنْ',
              6:'مَفْعُولُنْ',
              85:'مَفْعُولُنْ',
              5:'فَاعِلَيَّانْ',
              41:'فَعِلَيَّانْ',
              77:'فَعِلَيَّانْ',
              78:'فَاعِلَاتُنْ',
              79:'فَعِلَاتُنْ',}, 
           
            6:{20:'مَفَاعِيلُنْ',
              66:'مَفَاعِيلُنْ',
              23:'مَفَاعِلُنْ', 
              31:'مَفَاعِيلُ',
              94:'مَفَاعِلُنْ', 
              93:'مَفَاعِيلُ', 
              92:'مَفَاعِلُنْ', 
              95:'مَفَاعِيلُ',
              28:'فَعُولُنْ', 
              64:'فَعُولْ',
              65:'فَعُولُ',
              21:'مَفْتَعِلُنْ', 
              26:'مَفْعُولُنْ', 
              8:'فَاعِلُنْ', 
              22:'مَفْعُولُ',},
           
            7:{2:'مُسْتَفْعِلُنْ',
              67:'مُسْتَفْعِلُنْ', 
              33:'مُفَاعِلُنْ',
              68:'مُفَاعِلُنْ', 
              15:'مُفْتَعِلُنْ',
              69:'مُفْتَعِلُنْ', 
              27:'فَعِلَاتُنْ', 
              42:'مَفْعُولُنْ', 
              70:'مَفْعُولُنْ',
              9:'فَعِلُنْ', 
              43:'فَعْلُنْ', 
              1:'مُتَفَاعِلَانْ', 
              44:'مُسْتَفْعِلَانْ', 
              71:'مُسْتَفْعِلَانْ',
              45:'مُفَاعِلَانْ',
              72:'مُفَاعِلَانْ', 
              46:'مُفْتَعِلَانْ', 
              73:'مُفْتَعِلَانْ', 
              4:'مُتَفَاعِلَاتُنْ', 
              47:'مُسْتَفْعِلَاتُنْ', 
              48:'مَفَاعِلَاتُنْ', 
              49:'مُفْتَعِلَاتُنْ',
              74:'مُسْتَفْعِلَاتُنْ', 
              75:'مَفَاعِلَاتُنْ', 
              76:'مُفْتَعِلَاتُنْ',},
           
            8:{12:'فَعُولَاتُ', 
              19:'فَاعِلَاتُ', 
              11:'فَعِلَاتُ', 
              34:'مَفْعُولَانْ', 
              50:'فَعُولَانْ', 
              82:'فَعُولَانْ', 
              51:'فَاعِلَانْ', 
              32:'مَفْعُولُنْ', 
              52:'فَعُولُنْ', 
              84:'فَعُولُنْ',
              53:'فَاعِلُنْ', 
              54:'فَعِلُنْ', 
              18:'فَعْلُنْ',},
           
           9:{12:'مَفَاعِلُنْ', 
              56:'مَفَاعِلُنْ',
              29:'مُسْتَفْعِلُ', 
              17:'مَفَاعِلُ', 
              57:'مُسْتَفْعِلُ', 
              58:'مَفَاعِلُ', 
              39:'فَعُولُنْ',  
              36:'مُفَاعِلَانْ',},
           
           0:{29:'فَاعِلَاتُ',
              57:'فَاعِلَاتُ',},
            }

#a البحور الشعرية----------------------------------------------------------------

Elbehor = {
            1:'الطَّوِيل',
            2:'المَدِيد',
            3:'البَسِيط',
            4:'الوافِر',
            5:'الكامِل',
            6:'الهَزَج',
            7:'الرَجَز',
            8:'الرَّمَل',
            9:'السَّريع',
            10:'المُنْسَرِح',
            11:'الخفيف',
            12:'المضارع',
            13:'المقتضب',
            14:'المجتث',
            15:'المتقارب',
            16:'المتدارك',
             }


#a استعمالات البحور------------------------------------------------------------------
#a الاستعمال هو استعمال البحر تاما بجميع تفعيلاته أو بإنقاص بعضها  

Usage = {
         1:'تامّ', 
         2:'مجزوء', 
         3:'مشطور', 
         4:'منهوك', 
         5:'مخلّع', 
         }

# a اختصارات قاعدة البيانات للأوزان
short_awzan = {
       '*' : '*'
       , 'J':'فَعُولُنْ'
       , 'K':'فَاعِلُنْ'
       , 'L':'مُسْتَفْعِلُنْ'
       , 'M':'مَفَاعِيلُنْ'
       , 'W':'فَاعِلَاتُنْ'
       , 'X':'مُفَاعَلَتُنْ'
       , 'C':'مُتَفَاعِلُنْ'
       , 'V':'مَفْعُولَاتُ'
       , 'B':'مُسْتَفْعِ_لُنْ'
       , 'N':'فَاعِ_لَاتُنْ'
       , 'a':'فَعُولُ'
       , 'b':'فَعُولْ'
       , 'c':'فَعْلُنْ'
       , 'z':'فَعْلُ'
       , 'e':'فَعَلْ'
       , 'r':'فَعْ'
       , 't':'فَعِلُنْ'
       , 'y':'فَاعَلَانْ'
       , 'u':'فَعِلَانْ'
       , 'i':'فَعْلَانْ'
       , 'o':'فَعِلَاتُنْ'
       , 'p':'فَعْلَاتُنْ'
       , 'q':'مَفَاعِلُنْ'
       , 's':'مُفْتَعِلُنْ'
       , 'd':'فَعَلَتُنْ'
       , 'f':'مُسْتَفْعِلُ'
       , 'g':'مَفَاعِلُ'
       , 'h':'مَفْعُولُنْ'
       , 'j':'مُسْتَفْعِلَانْ'
       , 'k':'مُفَاعِلَانْ'
       , 'l':'مُفْتَعِلَانْ'
       , 'm':'فَعَلَتَانْ'
       , 'H':'مَفَاعِيلُ'
       , 'w':'مَفَاعِيلْ'
       , 'x':'مَفْعُولُ'
       , 'v':'فَاعِلَاتُ'
       , 'n':'فَعِلَاتُ'
       , 'G':'فَاعِلَانْ'
       , 'F':'فَاعِلَيَّانْ'
       , 'A':'فَعِلَيَّانْ'
       , 'Z':'مَفْتَعِلُنْ'
       , 'E':'مُفَاعِلُنْ'
       , 'R':'مُتَفَاعِلَانْ'
       , 'T':'مُتَفَاعِلَاتُنْ'
       , 'Y':'مُسْتَفْعِلَاتُنْ'
       , 'U':'مَفَاعِلَاتُنْ'
       , 'I':'مُفْتَعِلَاتُنْ'
       , 'P':'فَعُولَاتُ'
       , 'Q':'مَفْعُولَانْ'
       , 'D':'فَعُولَانْ'}

#a التفاصيل--------------------------------------------------------------------------
#a   التفاصيل عبارة عن قاموس مفاتيحه تشير إلى البحور
#a   القيمة المقابله للمفتاح عبارة عن قائمة بها قائمة ثم قاموس ثم قائمة إن وجدت
#a   القائمة الأولى بها استعمالات البحر تاما أو مجزوءا .....إلخ
#a   القائمة الأخيرة هي قائمة الزحافات الخاصة بالتفعيلة الأولى إن وجدت
#a   القاموس مفاتيحه أرقام تفعيلات الحشو بدون تكرار والقيم المقابلة قوائم بالجوازات الممكنة
#a   وكل استعمال من الاستعمالات في القائمة الأولى عبارة قائمة أول عنصر فيها هو نوع الاستعمال
#a   أما ثاني عنصر فهو تمثيل لوزن الاستعمال في الدائرة العروضية
#a   أما باقي العناصر فكل عنصر فيها يمثل عروضا لهذا الاستعمال
#a    العروض عبارة عن قائمة تحوي العروض كعنصر أول وأضربه هي باقي العناصر
#a   العروض المسبوقة بعلامة السالب هي ما يجوز في التصريع فقط

Details = { 
            1:[[[1,'1414*1414',[24,0,24,10],[-100,0],[-10,10]]],
               {1:[0,24],4:[0,24,29]},[7,35]],
            2:[[[2,'525*525',[0,0,56],[56,0,56],[57,0,56],[58,0,56],[10,10,25,3],
                 [40,40,3],[-3,3],[-25,25]],
                 [3,'52*52',[0,0]]],
               {5:[0,12,29,17],2:[0,12]}],
            3:[[[1,'3232*3232',[12,12,27]],
               [2,'323*323',[0,0,56,59,1,60,61,62,27],[56,0,56,59,1,60,61,62,27],
                [59,0,56,59,1,60,61,62,27],[27,63,27],[63,63,27],[-1,1,60,61,62],
                [-60,1,60,61,62],[-61,1,60,61,62],[-62,1,60,61,62]],
               [5,'323*323',[30,30]]],
               {3:[0,12,19,11],2:[0,12]}],
            4:[[[1,'666*666',[28,28,64],[65,28,64],[64,28,64]],
               [2,'66*66',[0,0,20],[66,0,20],[92,0,20],[95,0,20]]],
               {6:[0,20,23,31],},[8,21,22,26]],
            5:[[[1,'777*777',[0,0,27,43,67,68,69,70],[67,0,27,43,67,68,69,70],
                 [68,0,27,43,67,68,69,70],[69,0,27,43,67,68,69,70],[9,9,43],[-43,43],[-27,27,70],[-70,27,70]],
                [2,'77*77',[0,0,1,4,27,67,68,69,70,71,72,73,74,75,76],
                 [67,0,1,4,27,67,68,69,70,71,72,73,74,75,76],[68,0,1,4,27,67,68,69,70,71,72,73,74,75,76],
                 [69,0,1,4,27,67,68,69,70,71,72,73,74,75,76],[-27,27,70],[-70,27,70],
                 [-4,4,74,75,76],[-74,4,74,75,76],[-75,4,74,75,76],[-76,4,74,75,76],
                 [-1,1,71,72,73],[-71,1,71,72,73],[-72,1,71,72,73],[-73,1,71,72,73]]],
               {7:[0,2,33,15],}], 
            6:[[[2,'44*44',[0,0,10],[57,0,10],[-10,10]]],
               {4:[0,24,29],},[13,14,16]],
            7:[[[1,'333*333',[0,0,27,55,56,59,63],[55,0,27,55,56,59,63],
                 [56,0,27,55,56,59,63],[59,0,27,55,56,59,63],[-27,27,63],[-63,27,63]],
               [2,'33*33',[0,0,55,56,59],[55,0,55,56,59],[56,0,55,56,59],[59,0,55,56,59]],
               [3,'333',[0,],[55,],[56,],[59,]],
               [4,'33',[0,],[55,],[56,],[59,]]],
               {3:[0,12,19,11],}],
            8:[[[1,'555*555',[10,0,10,25,56,80,81],[80,0,10,25,56,80,81],[-100,0,56],[-56,0,56]
                 ,[-25,25,81],[-81,25,81]],
                [2,'55*55',[0,0,5,10,56,77,78,79,80],[56,0,5,10,56,77,78,79,80],
                 [57,0,5,10,56,77,78,79,80],[58,0,5,10,56,77,78,79,80],[-10,10,80],[-80,10,80],
                 [-5,5,77,78,79],[-77,5,77,78,79],[-78,5,77,78,79],[-79,5,77,78,79]]],
               {5:[0,12,17,29],}],
            9:[[[1,'338*338',[53,53,51,18],[54,54,18],[-18,18],[-51,51]],
                [3,'338',[34,82]]],
               {3:[0,12,19,11]}],
            10:[[[1,'383*383',[0,19,27,63,83],[56,19,27,63,83],[59,19,27,63,83],
                  [-27,27,63,83],[-63,27,63,83],[-83,27,63,83]],
                 [4,'38',[34,],[32,],[82,],[84,]]],
                {3:[0,12,19,11],8:[0,12,19]}],
            11:[[[1,'595*595',[0,0,56,10,80,85],[57,0,56,10,80,85],[58,0,56,10,80,85],[56,0,56,10,80,85],
                  [10,80,10],[80,80,10],[-85,85]],
                 [2,'59*59',[0,0,39,56],[56,0,39,56],[57,0,39,56],[58,0,39,56],[-39,39]]],
                {5:[0,12,17,29],9:[0,12,17,29]}],
            12:[[[2,'40*40',[0,0],[57,0]]],
                {4:[0,24,29],},[13,16]],
            13:[[[2,'83*83',[19,19]]],
                {8:[0,12,19],}],
            14:[[[2,'95*95',[0,0,56],[56,0,56],[57,0,56],[58,0,56]]],
                {9:[0,12,17,29],5:[0,12,17,29]}],
            15:[[[1,'1111*1111',[0,0,25,10,3,86],[86,0,25,10,3,86],[87,0,25,10,3,86],[-3,3],[-25,25]],
                 [2,'111*111',[10,10,3],[-3,3]]],
                {1:[0,24],},[7,35]],
            16:[[[1,'2222*2222',[0,0,56,88],[56,0,56,88],[88,0,56,88]],
                 [2,'222*222',[0,0,1,90,56,88,60,89,91],[56,0,1,90,56,88,60,89,91],
                  [88,0,1,90,56,88,60,89,91],[-1,1,60,89],[-60,1,60,89],[-89,1,60,89],
                  [-90,90,91],[-91,90,91]]],
                {2:[0,12,27],}],
             }


#a قائمة بالبحور------------------------------------------------------------

def all_baher():
    all_baher = []
    for a in Elbehor.keys():
            all_baher.append([Elbehor[a],a])
    return all_baher

#a صور البحور------------------------------------------------------

def formats_taf3ilat(a, v, f=False):
    taf3ilah = []
    for c in range(len(Details[a][1][v])):
        if Details[a][1][v][c] == 0:
            taf = Taf3ilat[v]
            taf3ilah.append([taf, 'سالمة'])
        else:
            zihaf = Zihafat_3ilal[Details[a][1][v][c]][1]
            new_format = Changes[v][Details[a][1][v][c]]
            taf3ilah.append([new_format, zihaf])
    if len(Details[a]) > 2 and f == True:
        for d in range(len(Details[a][2])):
            zihaf = Zihafat_3ilal[Details[a][2][d]][1]
            new_format = Changes[v][Details[a][2][d]]
            taf3ilah.append([new_format, zihaf])
    return taf3ilah

def formats_padding(arodh_ls, a):
    global z
    all_padding = []
    taf3ila1 = [['',''],]
    taf3ila2 = [['',''],]
    taf3ila3 = [['',''],]
    taf3ila4 = [['',''],]
    taf3ila5 = [['',''],]
    taf3ila6 = [['',''],]
    txt = arodh_ls[-1]
    arodh = [arodh_ls[0],arodh_ls[1]]
    if len(arodh_ls) == 5:
        dharb = [arodh_ls[2],arodh_ls[3]]
    else:
        dharb = ['','']
    taf3ila1 = formats_taf3ilat(a, int(txt[0]), True)
    if len(txt) > 1:
        taf3ila2 = formats_taf3ilat(a, int(txt[1]))
    if len(txt) > 2:
        taf3ila3 = formats_taf3ilat(a, int(txt[2]))
    if len(txt) > 3:
        taf3ila4 = formats_taf3ilat(a, int(txt[3]))
    if len(txt) > 4:
        taf3ila5 = formats_taf3ilat(a, int(txt[4]))
    if len(txt) > 5:
        taf3ila6 = formats_taf3ilat(a, int(txt[5]))
    ls = list(itertools.product([[arodh, dharb],], taf3ila1, taf3ila2, taf3ila3, taf3ila4, taf3ila5, taf3ila6)) 
#    for p in ls:
#        cur.execute('INSERT INTO awzan VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)', 
#                             (z, a, '', '', '',p[0][0][1],p[0][0][0],p[0][1][1],p[0][1][0],
#                              p[1][0],p[1][1],p[2][0],p[2][1],p[3][0],p[3][1],
#                              p[4][0],p[4][1],p[5][0],p[5][1],p[6][0],p[6][1]))
#        con.commit()
#        z += 1
#        print z
           
    return all_padding

def a3aridh_tasri3(a, b, txt):
    return
                        
def formats_a3aridh(a, b, txt):
    all_a3aridh = []
    for c in range(2, len(Details[a][0][b])):
        taf3ilat = Details[a][0][b][1]
        if len(taf3ilat) > 3:
            taf3ilat = taf3ilat[:(len(taf3ilat)/2)-1]+taf3ilat[(len(taf3ilat)/2)+1:-1]
        else:
            taf3ilat = taf3ilat[:-1]
        if Details[a][0][b][c][0] < 0:
            v1 = (Details[a][0][b][c][0])*(-1)
            t1 = ' وتجوز في التصريع فقط'
        else:
            v1 = Details[a][0][b][c][0]
            t1 = '' 
        arodh = Usage[Details[a][0][b][0]] 
        arodh += 'ة '+Zihafat_3ilal[v1][1]+t1
        if len(txt) > 3:
            for e in range(1, len(Details[a][0][b][c])):
                dharb = Zihafat_3ilal[Details[a][0][b][c][e]][2]
                cc = Details[a][0][b][c][e]
                d1 = (len(txt)/2)-1 
                if v1 != 0 and v1 != 100:
                    text_arod = Changes[int(txt[d1])][v1]
                else:
                    text_arod = Taf3ilat[int(txt[d1])]
                d2 = len(txt)-1 
                if cc != 0:
                    text_dharb = Changes[int(txt[d2])][cc]
                else:
                    text_dharb = Taf3ilat[int(txt[d2])]
                all_a3aridh.append([arodh,text_arod,dharb,text_dharb,taf3ilat])
        else:
            arodh += ' وهي الضرب نفسه'
            d3 = len(txt)-1 
            if v1 != 0:
                text_arod_dharb = Changes[int(txt[d3])][v1]
            else:
                text_arod_dharb = Taf3ilat[int(txt[d3])]
            all_a3aridh.append([arodh,text_arod_dharb,taf3ilat])
    return all_a3aridh

def formats_behor():
    for a in range(1,17):
        for b in range(len(Details[a][0])):
            txt = Details[a][0][b][1]
            a3aridh = formats_a3aridh(a, b, txt)
            for arodh in a3aridh:
                formats_padding(arodh, a)

#a لايجوز اجتماع خمس متحركات


#a ما خالف لفظه كتابته--------------------------------------------------------

list_not_rw = {'إِلَه':'إِلَاه','الرَّحْمَن':'ارْرَحْمَان','لَكِن':'لَاكِن',
             'سَمَوَات':'سَمَاوَات','هَذَا':'هَاذَا','هَذِه':'هَاذِه','هَؤُلَاء':'هَاؤُلَاء',
             'ذَلِك':'ذَالِك','دَاوُد':'دَاوُود','طَاوُس':'طَاوُوس','مِائَة':'مِئَة',
             'أَنَا ':'أَنَ ','أُولَات':'أُلَات','أُولُو':'أُلُو','أُولِي':'أُلِي',
             'آ':'أَا','هَذِي':'هَاذِي','اَ':'َا','اً':'ً','ىَ':'َى',
             'ىً':'ً','ًا':'ً','ًى':'ً','هَهُنَا':'هَاهُنَا','هَكَذَا':'هَاكَذَا',
             'هَذَيْن':'هَاذَيْن',
             'اللَّهَ ':'الْلَاهَ ','اللَّهُ ':'الْلَاهُ ','اللَّهِ ':'الْلَاهِ ',
             'للَّهِ ':'لْلَاهِ ','اللَّهُمّ':'الْلَاهُمّ','اللهِ ': 'الْلَاهِ ',
             'عَمْرٍو':'عَمْرِنْ','عَمْرٌو':'عَمْرُنْ','عَمْرِو':'عَمْرِ','عَمْرَو':'عَمْرَ',
             'عَمْرُو':'عَمْرُ',
             'عَمْروٍ':'عَمْرِنْ','عَمْروٌ':'عَمْرُنْ','عَمْروِ':'عَمْرِ','عَمْروَ':'عَمْرَ',
             'عَمْروُ':'عَمْرُ',
             }

def not_rw(text):
    for a in list_not_rw.keys():
        text = re.sub(a, list_not_rw[a], text)
    return text
    
#a إشباع هاء الضمير-----------------------------------------------------------------

def ishbaa_ha(text):
    ls = text.split(' ')
    txt = ''
    for a in ls:
        if len(a) >= 3: 
            if not d_araby.isHaraka(a[-3]) or d_araby.isSukun(a[-3]):
                pass
            else:
                if a[-2:] == 'هُ':
                    a += 'و'
                if a[-2:] == 'هِ':
                    a += 'ي'
        txt += a+' ' 
    txt = txt.strip()
    return txt
    
#a إشباع ميم الضمير-----------------------------------------------------------------

def ishbaa_mim(text):
    ls = text.split(' ')
    txt = ''
    for a in ls:
        if len(a) > 3: 
            if a[-4:] in ['كُمُ', 'كِمُ', 'هُمُ', 'هِمُ', 'تُمُ']:
                a += 'و'
        txt += a+' ' 
    txt = txt.strip()
    return txt

#a إشباع حركة الروي-----------------------------------------------------------------

def itlak(text):
    d = {d_araby.FATHA:d_araby.ALEF, 
         d_araby.DAMMA:d_araby.WAW, 
         d_araby.KASRA:d_araby.YEH}
    if text[-1] in d.keys():
        text = text+d[text[-1]]
    return text

#a إلغاء الشدة في الأخير-----------------------------------------------------------------

def shadda_end(text):
    if text[-1] == d_araby.SHADDA and text[-2] not in d_araby.HARAKAT:
        text = text[:-1]
    elif text[-2:] == d_araby.SHADDA+d_araby.SUKUN or text[-2:] == d_araby.SUKUN+d_araby.SHADDA:
        text = text[:-2]
    return text

#a شكل الحرف الواقع قبل الألف بالفتحة-----------------------------------------------------------------

def tashkil_plus(text):
    txt = text[0]
    for a in range(1,len(text)):
        if text[a] == d_araby.ALEF and\
        text[a-1] not in d_araby.HARAKAT and\
        text[a-1] != ' ' and \
        text[a-2:a-1] == d_araby.DAMMA+d_araby.WAW:
            txt += d_araby.FATHA
        txt += text[a]
    return txt

#a معالجة النجمة-----------------------------------------------------------------

def elfassil(text):
    ls = text.split(' ')
    if '*' in ls:
        i = ls.index('*')
        ls.remove('*')
        txt = ls[i-1]
        txt = itlak(txt)
        ls[i-1] = txt
        text = ' '.join(ls)
    return text
    
#a فك التنوين----------------------------------------------

def tanwin(text):
    txt = ''
    for a in range(len(text)):
        if a < len(text)-2:
            if d_araby.DAMMATAN == text[a]:
                if text[a+2] == d_araby.ALEF or \
                text[a+2] == d_araby.ALEF_WASLA:
                    txt += d_araby.DAMMA+'نِ'
                else: txt += d_araby.DAMMA+'نْ'
            elif d_araby.FATHATAN == text[a]:
                if text[a+2] == d_araby.ALEF or \
                text[a+2] == d_araby.ALEF_WASLA:
                    txt += d_araby.FATHA+'نِ'
                else: txt += d_araby.FATHA+'نْ'
            elif d_araby.KASRATAN == text[a]:
                if text[a+2] == d_araby.ALEF or \
                text[a+2] == d_araby.ALEF_WASLA:
                    txt += d_araby.KASRA+'نِ'
                else: txt += d_araby.KASRA+'نْ'
            else:
                txt += text[a]
        else:
            if d_araby.DAMMATAN == text[a]:
                txt += d_araby.FATHA+'نْ'
            elif d_araby.FATHATAN == text[a]:
                txt += d_araby.FATHA+'نْ'
            elif d_araby.KASRATAN == text[a]:
                txt += d_araby.KASRA+'نْ'
            else:
                txt += text[a]
    return txt

#a تقطيع النص إلى مقاطع صوتية------------------------------
#a المقطع الصوتي عبارة عن الحرف الصامت وحركته القصيرة
#a حرف المد عبارة عن مقطع ساكن

def syllable(text):
    lst = []
    ls = text.split(' ')
    for a in ls:
        l = []
        for b in range(len(a)):
            if d_araby.isHaraka(a[b]): continue
            if b == len(a)-1: 
                l.append([a[b], 0])
                continue
            if d_araby.isHaraka(a[b+1]):
                if d_araby.isSukun(a[b+1]): c = 0
                else: c = 1
                l.append([a[b:b+2], c])
            else: l.append([a[b], 0])
        lst.append(l)
    return lst

#a التحليل-------------------------------------------------

def scan_verse(text, v=0):
    text = re.sub(' +', ' ', text)
    #text = re.sub('_', '', text)
    text = d_araby.stripTatweel(text)
    text = shadda_end(text)
    text = not_rw(text)
    text = d_araby.take_apart_tense(text)
    if v == 0:
        text = ishbaa_ha(text)
        text = ishbaa_mim(text)
    #text = tashkil_plus(text)
    text = tanwin(text)
    text = itlak(text)
    text = elfassil(text)
    ls = syllable(text)
    txt = ''+ls[0][0][0]
    wazn = '1'
    for a in range(len(ls)):
        for c in range(len(ls[a])):
            if a == 0 and c == 0: continue
            if a < len(ls)-1:
                if c < len(ls[a])-1:
                    if ls[a][c][1] == 0 and ls[a][c+1][1] == 0:
                        continue
                    else: 
                        txt += ls[a][c][0]
                        wazn += str(ls[a][c][1])
                else:
                    if ls[a][c][1] == 0 and ls[a+1][0][1] == 0:
                        continue
                    else: 
                        txt += ls[a][c][0]
                        wazn += str(ls[a][c][1])
            else:
                if c < len(ls[a])-2:
                    if ls[a][c][1] == 0 and ls[a][c+1][1] == 0:
                        continue
                    else: 
                        txt += ls[a][c][0]
                        wazn += str(ls[a][c][1])
                else:
                    txt += ls[a][c][0]
                    wazn += str(ls[a][c][1])
        txt += ' '
    if wazn[-1] == '1':
        wazn += '0'
    takti3 = re.sub('1','/', wazn)
    return txt, takti3, wazn

#a الكتابة العروضية----------------------------------------

def writing_spoken(text, v):
    txt, takti3, wazn = scan_verse(text, v)
    return txt

#a الكتابة التقطيعية---------------------------------------

def writing_scan(text, v):
    txt, takti3, wazn = scan_verse(text, v)
    return takti3

#a الوزن---------------------------------------

def writing_wazn(text, v):
    txt, takti3, wazn = scan_verse(text, v)
    return wazn

#a أيجاد البحور المحتملة-----------------------------------

def meter_verse(text):
    result = myawzan.meter_verse(text)
    return result
