# -*- coding: utf-8 -*-

#a############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
#a############################################################################

from os.path import join
import os, sqlite3
from gi.repository import Gtk, Pango, GObject
import d_tools, d_araby, d_customs
from d_viewer import ShowPoem
from d_tablabel import TabLabel
from d_contacts import Books
import pickle

# class صفحة نتائج البحث-------------------------------------------------------------------

class ResultSearch(Gtk.Notebook):
   
    def search_on_page(self, text):
        n = self.get_current_page()
        ch = self.get_nth_page(n)
        ch.search_on_poem(text) 
    
    def search_on_active(self, text):
        n = self.get_current_page()
        ch = self.get_nth_page(n)
        ch.search_on_active(text)
    
    def near_page(self, v):
        n = self.get_current_page()
        ch = self.get_nth_page(n)
        ch.showpoem.near_poem(v)
        
    def move_in_page(self, v):
        n = self.get_current_page()
        ch = self.get_nth_page(n)
        ch.move_in_page(v) 
   
    def __init__(self, parent):
        self.parent = parent
        Gtk.Notebook.__init__(self)
        self.set_scrollable(True)
        def eee(widget,*a):
            if self.get_n_pages() == 0:
                self.parent.search_result_item.set_sensitive(False)
                self.parent.main_notebook.set_current_page(0)
        self.connect("page-removed",eee)
        self.show_all()
        
# class عارض نتائج البحث في الدواوين-------------------------------------------------------------------

class ShowResult(Gtk.VPaned):
   
    def search_on_poem(self, text):
        self.showpoem.search_on_poem(text)
        
    def search_on_active(self, text):
        self.showpoem.search_on_poem(text)
        
    def move_in_page(self, v):
        model, i = self.tree_results.get_selection().get_selected()
        if i:
            p = model.get_path(i).get_indices()[0]
            if p+v == -1 or p+v == len(model): return
            i1 = model.get_iter((p+v,))
            self.tree_results.get_selection().select_iter(i1)
            self.tree_results.scroll_to_cell((p+v,))
        elif len(self.tree_results.get_model()) == 0: return
        else:
            i2 = model.get_iter((0,))
            self.tree_results.get_selection().select_iter(i2)
            self.tree_results.scroll_to_cell((0,))
        self.show_result()
   
    def __init__(self, parent):
        self.parent = parent
        self.showpoem = ShowPoem(self.parent)
        self.text = ''
        self.cursive = False
        self.results_list = []
        self.build()
    
    def show_result(self, *a):
        model, i = self.sel_result.get_selected()
        if i:
            id_poem = model.get_value(i,0)
            self.showpoem.loading(id_poem, self.parent.theme.fontmp)
            self.showpoem.mark_on_poem(self.text, self.cursive)
    
    def search(self, text, dict_perf, selected_list):
        self.text = text
        self.cursive = dict_perf['cursive']
        text = text.replace('"','')
        text = text.replace("'","")
        ls_term = []
        if dict_perf['with_tachkil'] == True: 
            cond = 'nasse LIKE ?'
        else:
            cond = 'fuzzy(nasse) LIKE ?'
            text = d_araby.fuzzy_plus(text)
        if dict_perf['identical'] == True:  pfx, sfx = '% ', ' %'
        else: pfx, sfx = '%', '%'
        if dict_perf['cursive'] == True:
            self.condition = 'fuzzy(nasse) LIKE ?'
            ls_term.append(pfx+text+sfx)
        else: 
            for a in text.split(' '):
                ls_term.append(pfx+a+sfx)
            if dict_perf['one_term'] == True:
                self.condition = ' OR '.join([cond]*len(ls_term))
            else :
                self.condition = ' AND '.join([cond]*len(ls_term))
#                if dict_perf['one_verse'] == True:
#                    self.condition = 'fuzzy(nasse) LIKE ?'
#                    ls_term = [pfx+text.replace(' ', '[.+]')+sfx]
        n, s = 0, 0
        for b in selected_list:
            n += 1
            while (Gtk.events_pending()): Gtk.main_iteration()
            self.progress.set_fraction(float(n)/(float(len(selected_list))))
            check = self.parent.db.search(b, self.condition, ls_term)
            if check == True:
                s += 1
                self.results_store.append([b, s, self.parent.db.name_poem(b),
                                           self.parent.db.name_poet(self.parent.db.id_poet(b))[1],
                                           d_tools.get_name(d_tools.elbehor, self.parent.db.get_id_baher(b)),
                                           d_tools.get_name(d_tools.elgharadh, self.parent.db.gharadh_poem(b)),
                                           d_tools.get_name(d_tools.elrawi, self.parent.db.rawi_poem(b)),])
                self.results_list.append([b, s, self.parent.db.name_poem(b),
                                           self.parent.db.name_poet(self.parent.db.id_poet(b))[1],
                                           d_tools.get_name(d_tools.elbehor, self.parent.db.get_id_baher(b)),
                                           d_tools.get_name(d_tools.elgharadh, self.parent.db.gharadh_poem(b)),
                                           d_tools.get_name(d_tools.elrawi, self.parent.db.rawi_poem(b)),])
            else: pass
        self.progress.set_fraction(0.0)
        self.progress.hide()
        self.n_result.set_label("عدد النتائج : "+str(len(self.results_list)))
        if len(self.results_list)>0:
            output = open(join(d_customs.HOME_DIR, 'poets', 'آخر بحث.pkl'), 'wb')
            pickle.dump((self.text, self.results_list), output)
            output.close()
   
    def sav_result_cb(self, *a):
        nm = self.sav_result_entry.get_text()
        if nm == "":
            d_customs.erro(self.parent, "أدخل الاسم أولا.")
        elif nm in os.listdir(join(d_customs.HOME_DIR, 'poets')): 
            d_customs.erro(self.parent, "يوجد بحث محفوظ بنفس الاسم !!")
        else:
            output = open(join(d_customs.HOME_DIR, 'poets', nm+'.pkl'), 'wb')
            pickle.dump((self.text, self.results_list), output)
            output.close()
        self.sav_result_entry.set_text("")
        
    def build(self, *a):
        Gtk.VPaned.__init__(self)
        self.pack1(self.showpoem, True, False)
        vb = Gtk.Box(spacing=7, orientation=Gtk.Orientation.VERTICAL)
        hb = Gtk.Box(spacing=7, orientation=Gtk.Orientation.HORIZONTAL)
        sav_result_btn = Gtk.ToolButton(Gtk.STOCK_SAVE)
        hb.pack_start(sav_result_btn, False, False, 0)
        sav_result_btn.connect('clicked', self.sav_result_cb)
        self.sav_result_entry = Gtk.Entry()
        self.sav_result_entry.set_placeholder_text('حفظ النتائج')
        hb.pack_start(self.sav_result_entry, False, False, 0)
        self.n_result = Gtk.Label()
        hb.pack_start(self.n_result, False, False, 0)
        self.progress = Gtk.ProgressBar()
        hb.pack_start(self.progress, True, True, 0)
        vb.pack_start(hb, False, False, 0)
        
        self.results_store = Gtk.ListStore(int,int,str,str,str,str,str)
        self.tree_results = d_customs.TreeClass()
        self.tree_results.set_model(self.results_store)
        self.sel_result = self.tree_results.get_selection()
        self.tree_results.connect("cursor-changed", self.show_result)
        self.tree_results.set_grid_lines(Gtk.TreeViewGridLines.HORIZONTAL)
        raq = Gtk.TreeViewColumn('#', Gtk.CellRendererText(), text=1)
        raq.set_max_width(50)
        self.tree_results.append_column(raq)
        poems = Gtk.TreeViewColumn('القصيدة', Gtk.CellRendererText(), text=2)
        self.tree_results.append_column(poems)
        poems.set_max_width(300)
        eldimwan = Gtk.TreeViewColumn('الشاعر', Gtk.CellRendererText(), text=3)
        self.tree_results.append_column(eldimwan)
        eldimwan.set_max_width(300)
        elbaher = Gtk.TreeViewColumn('البحر', Gtk.CellRendererText(), text=4)
        self.tree_results.append_column(elbaher)
        elbaher.set_max_width(120)
        elgharadh = Gtk.TreeViewColumn('الغرض', Gtk.CellRendererText(), text=5)
        self.tree_results.append_column(elgharadh)
        elgharadh.set_max_width(80)
        elrawi = Gtk.TreeViewColumn('الروي', Gtk.CellRendererText(), text=6)
        self.tree_results.append_column(elrawi)
        elrawi.set_expand(True)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_results)
        scroll.set_size_request(-1, 200)
        vb.pack_start(scroll, True, True, 0)
        self.pack2(vb, False, True)
        self.show_all()
        
# class عارض نتائج البحث في الكتب-------------------------------------------------------------------

class ShowResultBooks(Gtk.Box):
   
    def __init__(self, parent):
        self.parent = parent
        self.text = ''
        self.ls_term = []
        self.build()
    
    def show_result(self, *a):
        model, i = self.sel_result.get_selected()
        if i:
            id_page = model.get_value(i, 0)
            book = model.get_value(i, 2)
            self.parent.my_booksviewer.db = Books(join(d_customs.BOOKS_DIR, book+'.asm'))
            self.parent.my_booksviewer.lab_nm_book.set_label('كتاب : '+book)
            self.parent.my_booksviewer.show_page(id_page)
            self.parent.my_booksviewer.search_now(self.text)
    
    def search_in_book(self, list_books, text, dict_perf):
        text = d_araby.fuzzy_plus(text)
        self.text = text
        for t in text.split(u' '):
            self.ls_term.append(t)
        self.cursive = dict_perf['cursive']
        text = text.replace('"','')
        text = text.replace("'","")
        ls_term = []
        if dict_perf['with_tachkil'] == True: 
            cond = 'nass LIKE ?'
        else:
            cond = 'fuzzy(nass) LIKE ?'
        if dict_perf['identical'] == True:  pfx, sfx = '% ', ' %'
        else: pfx, sfx = '%', '%'
        if dict_perf['cursive'] == True:
            condition = 'fuzzy(nass) LIKE ?'
            ls_term.append(pfx+text+sfx)
        else: 
            for a in text.split(u' '):
                ls_term.append(pfx+a+sfx)
            if dict_perf['one_term'] == True:
                condition = ' OR '.join([cond]*len(ls_term))
            else :
                condition = ' AND '.join([cond]*len(ls_term))
        n = 0
        n_r = 0 # a عدد النتائج
        for nm_book in list_books:
            n += 1
            book = join(d_customs.BOOKS_DIR, nm_book+'.asm')
            con = sqlite3.connect(book)
            con.create_function('fuzzy', 1, d_araby.fuzzy_plus)
            cur = con.cursor()
            len_book = len(cur.execute('SELECT id FROM pages').fetchall())
            parts = int(len_book/200)
            remainder = len_book-(200*parts)
            v = 0
            while v in range(parts+1):
                while (Gtk.events_pending()): Gtk.main_iteration()
                p1 = v*200
                p2 = (v+1)*200
                if v < parts:
                    cond = 'id BETWEEN {} and {}'.format(p1, p2)
                elif v == parts:
                    cond = 'id BETWEEN {} and {}'.format(p1, remainder)
                elif v > parts:
                    pass  
                cur.execute("""SELECT id, part, page FROM pages WHERE {} AND {}""".format(cond, condition), ls_term)
                i_pgs = cur.fetchall()
                for i in i_pgs:
                    j = i[0]
                    try: pg = int(i[2])
                    except: pg = 1
                    try: pr = int(i[1])
                    except: pr = 1
                    cur.execute('SELECT tit FROM titles WHERE id<=?', (j,)) 
                    try: tit = cur.fetchall()[-1][0]
                    except: tit = '......'
                    n_r += 1
                    self.store_results.append([j, n_r, nm_book, tit, pr, pg])
                    self.progress.set_fraction(float(n)/(float(len(self.store_results))))
                    self.lab_n_result.set_text('عدد النتائج : {}'.format(n_r, ))
                v += 1
            cur.close()
            con.close()
        self.progress.set_fraction(0.0)
        self.progress.hide()
        results_books = []
        if n_r>0:
            for a in self.store_results:
                results_books.append([a[0], a[1], a[2], a[3], a[4], a[5]])
            output = open(join(d_customs.HOME_DIR, 'books', 'آخر بحث.pkl'), 'wb')
            pickle.dump((self.text, results_books), output)
            output.close()
   
    def sav_result_cb(self, *a):
        nm = self.sav_result_entry.get_text()
        if nm == "":
            d_customs.erro(self.parent, "أدخل الاسم أولا.")
        elif nm in os.listdir(join(d_customs.HOME_DIR, 'books')): 
            d_customs.erro(self.parent, "يوجد بحث محفوظ بنفس الاسم !!")
        else:
            output = open(join(d_customs.HOME_DIR, 'books', nm+'.pkl'), 'wb')
            pickle.dump((self.text, self.results_list), output)
            output.close()
        self.sav_result_entry.set_text("")
    
    def close_search(self, *a):
        self.parent.my_booksviewer.vbox_side.show_all()
        for a in self.parent.my_booksviewer.vbox_search.get_children():
            self.parent.my_booksviewer.vbox_search.remove(a)
    
    def build(self, *a):
        Gtk.Box.__init__(self, spacing=7, orientation=Gtk.Orientation.VERTICAL)
        hb = Gtk.Box(spacing=7, orientation=Gtk.Orientation.HORIZONTAL)
        sav_result_btn = Gtk.ToolButton()
        sav_result_btn.set_icon_name('document-save')
        hb.pack_start(sav_result_btn, False, False, 0)
        sav_result_btn.connect('clicked', self.sav_result_cb)
        self.sav_result_entry = Gtk.Entry()
        self.sav_result_entry.set_placeholder_text('حفظ النتائج')
        hb.pack_start(self.sav_result_entry, False, False, 0)
        self.n_result = Gtk.Label()
        hb.pack_start(self.n_result, False, False, 0)
        self.lab_n_result = Gtk.Label()
        hb.pack_start(self.lab_n_result, False, False, 0)
        self.progress = Gtk.ProgressBar()
        hb.pack_start(self.progress, True, True, 0)
        self.pack_start(hb, False, False, 0)
        close_btn = Gtk.Button('أغلق')
        close_btn.connect('clicked', self.close_search)
        hb.pack_end(close_btn, False, False, 0)
        
        self.store_results = Gtk.ListStore(int,int,str,str,int,int)
        self.tree_results = d_customs.TreeClass()
        self.tree_results.set_model(self.store_results)
        self.sel_result = self.tree_results.get_selection()
        self.tree_results.connect("cursor-changed", self.show_result)
        self.tree_results.set_grid_lines(Gtk.TreeViewGridLines.HORIZONTAL)
        raq = Gtk.TreeViewColumn('#', Gtk.CellRendererText(), text=1)
        raq.set_max_width(80)
        self.tree_results.append_column(raq)
        books = Gtk.TreeViewColumn('الكتاب', Gtk.CellRendererText(), text=2)
        books.set_max_width((self.parent.get_size()[0]-300)/3)
        self.tree_results.append_column(books)
        elbab = Gtk.TreeViewColumn('الباب', Gtk.CellRendererText(), text=3)
        elbab.set_max_width(((self.parent.get_size()[0]-300)/3)*2)
        self.tree_results.append_column(elbab)
        elbaher = Gtk.TreeViewColumn('الجزء', Gtk.CellRendererText(), text=4)
        self.tree_results.append_column(elbaher)
        elbaher.set_max_width(80)
        elgharadh = Gtk.TreeViewColumn('الصفحة', Gtk.CellRendererText(), text=5)
        self.tree_results.append_column(elgharadh)
        elgharadh.set_max_width(80)
        elgharadh.set_expand(True)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_results)
        scroll.set_size_request(-1, 200)
        self.pack_start(scroll, True, True, 0)
        self.show_all()

# class نافذة البحث-------------------------------------------------------------------

class Searcher(Gtk.Dialog):
   
    def __init__(self, parent):
        self.parent = parent
        self.showpoem = ShowPoem(self.parent)
        self.selected_list_poets = []
        self.build()
   
    def load_poets(self, *a):
        self.store_poets.clear()
        ages = d_tools.age_poet
        for a in ages:
            aa = self.store_poets.append(None, [None, a[0], a[1], a[0]])
            poets = self.parent.db.poet_of_age(a[0])
            for b in poets:
                self.store_poets.append(aa, [None, b[0], b[1], a[0]])
        self.store_poets.append(aa, [None, 0, 'ما لا يعرف قائله', 9])
   
    def search_in_index(self, model, path, i, my_poet):
        txt = model.get(i,2)[0]
        text, model0, path0, i0 = my_poet
        if d_araby.fuzzy(text) in d_araby.fuzzy(txt) and path.compare(path0) > 0: 
            self.tree_poets.expand_to_path(path)
            self.tree_poets.scroll_to_cell(path)
            self.sel_poets.select_path(path)
            return True 
        else:
            return False
    
    def search_entry_cb(self, *a):
        text = self.ent_search.get_text()
        model = self.store_poets
        i = model.get_iter_first()
        path = model.get_path(i)
        try: self.store_poets.foreach(self.search_in_index, [text, model, path, i])
        except: pass
        
    def search_cb(self, *a):
        model, i = self.sel_poets.get_selected()
        if not i:
            i = model.get_iter_first()
        path = model.get_path(i)
        text = self.ent_search.get_text()
        if text == u'': return
        try: self.store_poets.foreach(self.search_in_index, [text, model, path, i])
        except: pass
    
    def select_o(self, model, path, i, bool1):
        bool0 = model.get_value(i,0)
        if bool0 != bool1: 
            model.set_value(i,0, bool1)
            self.add_to_list(model, i, bool1)
            return False
    
    def select_all(self, btn, store):
        if btn.get_title() == u"علّم الجميع":
            store.foreach(self.select_o, True)
            btn.set_title(u"ألغ تعليم الجميع")
        else:
            store.foreach(self.select_o, False)
            btn.set_title(u"علّم الجميع")
        
    def select_assemble(self, btn, *a):
        nm = btn.get_name()
        self.dict_assemble[nm] = btn.get_active()
            
    def select_perf(self, btn):
        nm = btn.get_name()
        self.dict_perf[nm] = btn.get_active()
    
    def fixed_toggled0(self, cell, path, model):
        itr = model.get_iter((path),)
        fixed = model.get_value(itr, 0)
        fixed = not fixed
        model.set(itr, 0, fixed)
    
    def fixed_toggled(self, cell, path, model):
        itr = model.get_iter((path),)
        fixed = model.get_value(itr, 0)
        if model.iter_has_child(itr):
            n_iters = self.store_poets.iter_n_children(itr)
            d = 0
            while d  < n_iters:
                iter1 = model.get_iter((int(path),d),)
                fixed1 = model.get_value(iter1, 0)
                fixed1 = not fixed
                model.set(iter1, 0, fixed1)
                self.add_to_list(model, iter1, fixed1)
                d += 1
        fixed = not fixed
        model.set(itr, 0, fixed)
        self.add_to_list(model, itr, fixed)
        
    def add_to_list(self, model, itr, fixed):
        id_poet = model.get_value(itr, 1)
        i = model.iter_parent(itr)
        if i != None:
            if fixed: 
                if id_poet not in self.selected_list_poets:
                    self.selected_list_poets.append(id_poet)
            else:
                if id_poet in self.selected_list_poets:
                    idx = self.selected_list_poets.index(id_poet, )
                    self.selected_list_poets.pop(idx)
    
    def search_in_poems(self, text):
        list_selected = []
        for a in self.selected_list_poets:
            list_selected += self.parent.db.poems_id(a)
        for a in self.store_assembles:
            if a[0] :
                poems_id = self.parent.db.get_poems_assemble(a[1])
                list_selected += poems_id
        if self.fav_dawawin.get_active():
            list_fav_poets = self.parent.db.favorite_poets()
            for a in list_fav_poets:
                list_selected += self.parent.db.poems_id(a[0])
        if self.fav_poem.get_active():
            for a in self.parent.db.favorite_poems():
                list_selected.append(a[0])
        if list_selected == []:
            d_customs.erro(self.parent, 'أنت لم تحدد أين ستبحث')
        else:
            try:
                if len(self.list_terms) == 50: self.list_terms.pop(0)
                if text in self.list_terms: self.list_terms.remove(text)
                self.list_terms.append(text)
                output = open(join(d_customs.HOME_DIR, u'last-terms.pkl'), 'wb')
                pickle.dump(self.list_terms, output)
                output.close()
            except: pass
            self.hide()
            self.parent.main_notebook.set_current_page(4)
            self.parent.search_result_item.set_sensitive(True)
            sr = ShowResult(self.parent)
            self.parent.resultsearch.append_page(sr,TabLabel(sr, 'بحث عن : '+text))
            self.parent.resultsearch.set_current_page(-1)
            while (Gtk.events_pending()): Gtk.main_iteration()
            sr.search(text, self.dict_perf, list_selected)
    
    def search_in_books(self, text):
        sea = ShowResultBooks(self.parent)
        list_books = []
        for a in self.store_books:
            if a[0]:
                list_books.append(a[1])
        self.hide()
        self.parent.main_notebook.set_current_page(10)
        for c in self.parent.my_booksviewer.vbox_search.get_children():
            self.parent.my_booksviewer.vbox_search.remove(c)
        self.parent.my_booksviewer.vbox_search.pack_start(sea, False, False, 0)
        self.parent.my_booksviewer.vbox_side.hide()
        sea.search_in_book(list_books, text, self.dict_perf)
    
    def search(self, *a):
        text = self.entry_search.get_text()
        if text == '':
            d_customs.erro(self.parent, 'أدخل النص المراد البحث عنه')
        else:
            if self.stack.get_visible_child_name() == 'n1': self.search_in_poems(text)
            else: self.search_in_books(text)
        
    def del_history(self, *a):
        self.list_terms = []
        output = open(join(d_customs.HOME_DIR, u'last-terms.pkl'), 'wb')
        pickle.dump(self.list_terms, output)
        output.close()
        self.list_ts.clear()
        d_customs.info(self.parent, "تمّ مسح الكلمات المبحوث عنها سابقاً")
    
    def build(self, *a):
        Gtk.Dialog.__init__(self, parent=self.parent)
        self.set_border_width(3)
        self.set_icon_name("dawawin")
        area = self.get_content_area()
        area.set_spacing(3)
        
        hb_bar = Gtk.HeaderBar()
        hb_bar.set_show_close_button(True)
        self.set_titlebar(hb_bar)
        vbox1 = Gtk.Box(spacing=3,orientation=Gtk.Orientation.VERTICAL)
        area.pack_start(vbox1, True, True, 0)
        self.set_size_request(800,550)
        self.connect('delete-event', lambda w,*a: w.hide() or True)
        #---------------------------------------------------
        self.stack = Gtk.Stack()
        self.stack.set_transition_type(Gtk.StackTransitionType.SLIDE_LEFT_RIGHT)
        self.stack.set_transition_duration(1000)
        stack_switcher = Gtk.StackSwitcher()
        stack_switcher.set_stack(self.stack)
        hb_bar.set_custom_title (stack_switcher)
        
        hbox = Gtk.Box(spacing=1,orientation=Gtk.Orientation.HORIZONTAL)
        self.entry_search = Gtk.SearchEntry()
        try: self.list_terms = pickle.load(open(join(d_customs.HOME_DIR, u'last-terms.pkl'), "rb"))
        except: self.list_terms = []
        completion = Gtk.EntryCompletion()
        self.list_ts = Gtk.ListStore(str)
        for a in self.list_terms:
            self.list_ts.append([a])
        completion.set_model(self.list_ts)
        completion.set_text_column(0)
        self.entry_search.set_completion(completion)
        self.entry_search.set_size_request(500,-1)
        self.entry_search.connect('activate', self.search)
        self.entry_search.set_placeholder_text('أدخل النص المراد البحث عنه')
        self.btn_search = Gtk.Button('بحث')
        hbox.pack_start(self.btn_search, False, False, 0)
        hbox.pack_start(self.entry_search, True, True, 0)
        self.btn_search.connect('clicked', self.search)
        clear_terms = Gtk.Button('-')
        clear_terms.set_tooltip_text('حذف الكلمات المبحوث عنها سابقا')
        clear_terms.connect('clicked', self.del_history)
        hbox.pack_start(clear_terms, False, False, 0)
        vbox1.pack_start(hbox, False, False, 0)
        #-------------------------------------------------------
        vbox11 = Gtk.Box(spacing=7,orientation=Gtk.Orientation.VERTICAL)
        hbox = Gtk.Box(spacing=7,orientation=Gtk.Orientation.HORIZONTAL)
        vbox = Gtk.Box(spacing=3,orientation=Gtk.Orientation.VERTICAL)
        hb = Gtk.Box(spacing=3,orientation=Gtk.Orientation.HORIZONTAL)
        self.ent_search = Gtk.SearchEntry()
        self.ent_search.set_placeholder_text('بحث عن ديوان')
        self.ent_search.connect('changed', self.search_entry_cb)
        hb.pack_end(self.ent_search, False, False, 0)
        self.ent_search.connect('activate', self.search_cb)
        vbox.pack_start(hb, False, False, 0)
        hbox.pack_start(vbox, False, False, 0)
        self.store_assembles = Gtk.ListStore(GObject.TYPE_BOOLEAN, GObject.TYPE_INT, GObject.TYPE_STRING)
        self.tree_assembles = Gtk.TreeView(self.store_assembles)
        self.tree_assembles.set_rules_hint(True)
        celltext = Gtk.CellRendererText()
        celltext.set_property("ellipsize", Pango.EllipsizeMode.END)
        celltoggle = Gtk.CellRendererToggle()
        celltoggle.set_property('activatable', True)
        columntoggle = Gtk.TreeViewColumn("#", celltoggle)
        columntext = Gtk.TreeViewColumn("المجموع", celltext, text = 2 )
        columntext.set_expand(True)
        columntoggle.add_attribute( celltoggle, "active", 0)
        celltoggle.connect('toggled', self.fixed_toggled0, self.store_assembles)
        self.tree_assembles.append_column(columntoggle)
        self.tree_assembles.append_column(columntext)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_assembles)
        assembles = self.parent.db.get_assembles()
        for a in assembles:
            self.store_assembles.append([None, a[0], a[1]])
        vbox.pack_start(scroll,True, True, 0)
        self.fav_poem = Gtk.CheckButton('القصائد المفضلة')
        self.fav_dawawin = Gtk.CheckButton('الدواوين المفضلة')
        vbox.pack_start(self.fav_dawawin, False, False, 0)
        vbox.pack_start(self.fav_poem, False, False, 0)
        
        self.store_poets = Gtk.TreeStore(GObject.TYPE_BOOLEAN, GObject.TYPE_INT, GObject.TYPE_STRING, GObject.TYPE_INT)
        self.tree_poets = Gtk.TreeView()
        self.tree_poets.set_model(self.store_poets)
        self.sel_poets = self.tree_poets.get_selection()
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_poets)
        scroll.set_size_request(200, -1)
        celltext = Gtk.CellRendererText()
        celltext.set_property("ellipsize", Pango.EllipsizeMode.END)
        celltoggle = Gtk.CellRendererToggle()
        celltoggle.set_property('activatable', True)
        columntoggle = Gtk.TreeViewColumn("ضمّ", celltoggle)
        columntoggle.set_clickable(True)
        columntoggle.connect('clicked', lambda *a:
                             self.tree_poets.collapse_all()) 
        columntext = Gtk.TreeViewColumn("علّم الجميع", celltext, text = 2 )
        columntext.set_clickable(True)
        columntext.connect('clicked', self.select_all, self.store_poets) 
        columntext.set_expand(True)
        columntoggle.add_attribute( celltoggle, "active", 0)
        celltoggle.connect('toggled', self.fixed_toggled, self.store_poets)
        self.tree_poets.append_column(columntoggle)
        self.tree_poets.append_column(columntext)
        hbox.pack_start(scroll, True, True, 0)
        vbox11.pack_start(hbox, True, True, 10)
        #------------------------------------------------------
        vbox22 = Gtk.Box(spacing=7,orientation=Gtk.Orientation.VERTICAL)
        self.store_books = Gtk.ListStore(GObject.TYPE_BOOLEAN, GObject.TYPE_STRING)
        self.tree_books = Gtk.TreeView(self.store_books)
        self.tree_books.set_rules_hint(True)
        celltext = Gtk.CellRendererText()
        celltext.set_property("ellipsize", Pango.EllipsizeMode.END)
        celltoggle = Gtk.CellRendererToggle()
        celltoggle.set_property('activatable', True)
        columntoggle = Gtk.TreeViewColumn("#", celltoggle)
        columntext = Gtk.TreeViewColumn("علّم الجميع", celltext, text = 1 )
        columntext.set_clickable(True)
        columntext.connect('clicked', self.select_all, self.store_books) 
        columntext.set_expand(True)
        columntoggle.add_attribute( celltoggle, "active", 0)
        celltoggle.connect('toggled', self.fixed_toggled0, self.store_books)
        self.tree_books.append_column(columntoggle)
        self.tree_books.append_column(columntext)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(self.tree_books)
        list_n = os.listdir(d_customs.BOOKS_DIR)
        for v in list_n:
            if v[-4:] == '.asm': self.store_books.append([None, v[:-4]])
        vbox22.pack_start(scroll,True, True, 10)
        #-------------------------------------------------------
        self.stack.add_titled(vbox11, 'n1', 'في الدواوين')
        self.stack.add_titled(vbox22, 'n2', 'في المكتبة')
        vbox1.pack_start(self.stack, True, True, 0)
        #-------------------------------------------------------
        box = Gtk.Box(spacing=7,orientation=Gtk.Orientation.HORIZONTAL)
        box.set_border_width(7)
        self.dict_perf = {}
        for a in [[u'بدون لواصق', u'identical'],
        [u'عبارة متصلة', u'cursive'], 
        [u'إحدى الكلمات', u'one_term'],  
        #[u'نفس البيت', u'one_verse'], 
        [u'مع التشكيل', u'with_tachkil']]:
            btn = Gtk.CheckButton(a[0])
            btn.set_name(a[1])
            box.pack_start(btn, False, False, 0)
            btn.connect('toggled', self.select_perf)
            self.dict_perf[a[1]] = False
        vbox1.pack_start(Gtk.Separator(), False, False, 0)
        vbox1.pack_start(box, False, False, 0)
        self.load_poets()

        
