# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
##############################################################################

import re
import d_config, d_araby
            
# a قوائم خاصة-----------------------------------------------

sex_poet = [
            [1, 'الرجال'],
            [2, 'النساء']
            ]

elnaw3   = [
            [1, 'قريض'],
            [2, 'أرجوزة'],
            [3, 'مُوشحة'],
            [4, 'رُباعيّة'],
            [5, 'شعر حر'],
            [6, 'مخمّسة'],
            ]

age_poet = [
            [1, 'الجاهلي'],
            [2, 'المخضرمون'],
            [3, 'صدر الإسلام'],
            [4, 'الأموي'],
            [5, 'العباسي'],
            [10, 'الفاطمي'],
            [11, 'الأيوبي'],
            [6, 'المملوكي'],
            [7, 'العثماني'],
            [8, 'الحديث'],
            [9, 'غير معروف'],
            ]

elgharadh = [
            [1, 'وصف'],
            [8, 'تشبيه'], 
            [2, 'فخر'], 
            [3, 'حماسة'], 
            [4, 'نسيب'],
            [6, 'شكوى'],
            [7, 'عتاب'],
            [24, 'اعتذار'],
            [25, 'هجاء'],
            [26, 'وعيد'],
            [9, 'رثاء'], 
            [10, 'مدح'],
            [11, 'اقتضاء'],
            [12, 'علمي'], 
            [13, 'دفاع'], 
            [14, 'مناجاة'], 
            [15, 'زهد'], 
            [16, 'ملحمة'], 
            [17, 'إلغاز'], 
            [18, 'تأريخ'], 
            [19, 'هزل'], 
            [20, 'حكمة'],
            [21, 'قصصي'], 
            [22, 'هِنات'], 
            [23, 'خليط'], 
            ]

elkawafi = [
            [1, 'مطلقة'],
            [2, 'مقيدة']
            ]

elrawi   = [ 
            [1, "ألف"], 
            [2, "باء"], 
            [3, 'تاء' ], 
            [4, 'تاء مربوطة' ], 
            [5, 'ثاء' ],
            [6, 'جيم' ], 
            [7, 'حاء' ], 
            [8, 'خاء' ], 
            [9, 'دال' ], 
            [10, 'ذال' ],
            [11, 'راء' ], 
            [12, 'زاي' ], 
            [13, 'سين' ], 
            [14, 'شين' ], 
            [15, 'صاد' ],
            [16, 'ضاد' ], 
            [17, 'طاء' ], 
            [18, 'ظاء' ], 
            [19, 'عين' ], 
            [20, 'غين' ],
            [21, 'فاء' ], 
            [22, 'قاف' ], 
            [23, 'كاف' ], 
            [24, 'لام' ], 
            [25, 'ميم' ],
            [26, 'نون' ], 
            [27, 'هاء' ], 
            [28, 'واو' ], 
            [29, 'ياء' ], 
            [30, 'همزة' ],
            ]

elbalad   = [ 
            [1, "الجزائر"], 
            [2, "تونس"], 
            [3, 'المغرب' ], 
            [4, 'موريطانيا' ], 
            [5, 'ليبيا' ],
            [6, 'مصر' ], 
            [7, 'فلسطين' ], 
            [8, 'لبنان' ], 
            [9, 'الأردن' ], 
            [10, 'سوريا' ],
            [11, 'العراق' ], 
            [12, 'السعودية' ], 
            [13, 'الكويت' ], 
            [14, 'البحرين' ], 
            [15, 'قطر' ],
            [16, 'الإمارات' ], 
            [17, 'سلطنة عمان' ], 
            [18, 'اليمن' ], 
            [19, 'السودان' ], 
            [20, 'جيبوتي' ],
            [21, 'الصومال' ],
            [22, 'غير معروف'],
            ]

elbehor = [
            [1, 'الطَّوِيل'], 
            [2, 'المَدِيد'], 
            [3, 'البَسِيط'], 
            [4, 'الوافِر'], 
            [5, 'الكامِل'], 
            [6, 'الهَزَج'], 
            [7, 'الرَجَز'], 
            [8, 'الرَّمَل'], 
            [9, 'السَّريع'], 
            [10, 'المُنْسَرِح'], 
            [11, 'الخفيف'], 
            [12, 'المضارع'], 
            [13, 'المقتضب'], 
            [14, 'المجتث'], 
            [15, 'المتقارب'], 
            [16, 'المتدارك'], 
            ]

ela3aridh = [
        [1, 'عروض تامّة مقبوضة وضرب صحيح',],
        [2, 'عروض تامّة مقبوضة وضرب مقبوض',],
        [3, 'عروض تامّة مقبوضة وضرب محذوف',],
        [4, 'عروض مجزوءة صحيحة وضرب صحيح'],
        [5, 'عروض مجزوءة محذوفة وضرب محذوف'],
        [6, 'عروض مجزوءة محذوفة وضرب مقصور'],
        [7, 'عروض مجزوءة محذوفة وضرب أبتر'],
        [8, 'عروض مجزوءة مخبونة محذوفة وضرب مخبون محذوف'],
        [9, 'عروض مجزوءة مخبونة محذوفة وضرب أبتر'],
        [10, 'عروض مشطورة صحيحة وضرب صحيح'],
        [11, 'عروض تامّة مخبونة وضرب مخبون'],
        [12, 'عروض تامّة مخبونة وضرب مقطوع'],
        [13, 'عروض مجزوءة صحيحة وضرب مذال'],
        [14, 'عروض مجزوءة صحيحة وضرب مقطوع'],
        [15, 'عروض مجزوءة مقطوعة وضرب مقطوع'],
        [16, 'عروض مخلّعة مكبولة وضرب مكبول'],
        [17, 'عروض تامّة مقطوفة وضرب مقطوف'],
        [18, 'عروض مجزوءة صحيحة وضرب أعصب'],
        [19, 'عروض تامّة صحيحة وضرب صحيح'],
        [20, 'عروض تامّة صحيحة وضرب مقطوع'],
        [21, 'عروض تامّة صحيحة وضرب مضمر أحذّ'],
        [22, 'عروض تامّة حذّاء وضرب أحذّ'],
        [23, 'عروض تامّة حذّاء وضرب مضمر أحذّ'],
        [24, 'عروض مجزوءة صحيحة وضرب مرفّل'],
        [25, 'عروض مجزوءة صحيحة وضرب محذوف'],
        [26, 'عروض مشطورة صحيحة وهي الضرب نفسه'],
        [27, 'عروض منهوكة صحيحة وهي الضرب نفسه'],
        [28, 'عروض تامّة محذوفة وضرب صحيح'],
        [29, 'عروض تامّة محذوفة وضرب محذوف'],
        [30, 'عروض تامّة محذوفة وضرب مقصور'],
        [31, 'عروض مجزوءة صحيحة وضرب مسبّغ'],
        [32, 'عروض تامّة مكسوفة مطويّة وضرب مكسوف مطويّ'],
        [33, 'عروض تامّة مكسوفة مطويّة وضرب مطويّ موقوف'],
        [34, 'عروض تامّة مكسوفة مطويّة وضرب أصلم'],
        [35, 'عروض تامّة مكسوفة مخبولة وضرب مكسوف مخبول'],
        [36, 'عروض تامّة مكسوفة مخبولة وضرب أصلم'],
        [37, 'عروض مشطورة موقوفة وهي الضرب نفسه'],
        [38, 'عروض تامّة صحيحة وضرب مطويّ'],
        [39, 'عروض منهوكة موقوفة وهي الضرب نفسه'],
        [40, 'عروض منهوكة مكسوفة وهي الضرب نفسه'],
        [41, 'عروض تامّة صحيحة وضرب محذوف'],
        [42, 'عروض مجزوءة صحيحة وضرب مخبون مقصور'],
        [43, 'عروض مجزوءة مطويّة وضرب مطويّ'],
        [44, 'عروض تامّة صحيحة وضرب مقصور'],
        [45, 'عروض تامّة صحيحة وضرب أبتر'],
        ]

ela3aridh_in_behor = {
        1:[1, 2, 3],
        2:[4, 5, 6, 7, 8, 9, 10],
        3:[11, 12, 4, 13, 14, 15, 16],
        4:[17, 4, 18],
        5:[19, 20, 21, 22, 23, 4, 13, 24, 14],
        6:[4, 25],
        7:[19, 20, 4, 26, 27],
        8:[28, 29, 30, 4, 31, 25],
        9:[32, 33, 34, 35, 36, 37],
        10:[38, 20, 39, 40],
        11:[19, 41, 29, 4, 42],
        12:[4,],
        13:[43,],
        14:[4,],
        15:[19, 44, 41, 45, 5, 7],
        16:[19, 4, 13, 24],
        }

# a أخذ الرقم وإعادة الاسم-----------------------------------------

def get_name(ls, n):
    if n == 0: return 'لا شيء'
    for a in ls:
        if n == a[0]:
            return a[1]
        
# a أخذ الاسم وإعادة الرقم-----------------------------------------

def get_int(ls, nm):
    nm = nm.strip()
    for a in ls:
        if nm in a[1]:
            return a[0]
        
# a أخذ الرقم وإعادة الموضع---------------------------------------

def get_index(ls, n):
    if n == 0: return -1
    for a in ls:
        if n == a[0]:
            idx = ls.index(a)
            return idx

# a أخذ الرقم وإعادة موضع العروض----------------------------------

def get_index_arodh(b, a):
    if a == 0: return -1
    for c in ela3aridh_in_behor[b]:
        if c == a:
            idx = ela3aridh_in_behor[b].index(a)
            return idx

# a أخذ الحرف وإعادة رقم الروي----------------------------------

def get_int_rawi(h):
    if h not in d_araby.LETTERS: return 0
    if h == 'ى': h = 'ا'
    rawi = d_araby.NAMES[h]
    if rawi in ['همزة على الألف' ,'همزة على الواو' ,'همزة تحت الألف' , 'همزة على الياء' ]:
        rawi = 'همزة'
    return get_int(elrawi, rawi)


# a حذف المسافات الزائدة والأسطر الفارغة---------------------------
    
def right_space(text):
    text = text.expandtabs(1)
    text = re.sub(' +', ' ', text)
    text = re.sub('\n \n', '\n', text)
    text = re.sub('\n ', '\n', text)
    text = re.sub(' \n', '\n', text)
    text = re.sub('\n+', '\n', text)
    txt = text.strip()
    return txt

# a تحديد شطر أو جزء منه فقط------------------------------------

def one_half(text):
    ls = text.split('  ')
    txt = d_araby.stripTatweel(ls[0])
    return txt

# a الكلمة الأولى فقط--------------------------------------------

def first_term(text):
    text = re.sub('\n', ' ', text)
    text = re.sub(' +', ' ', text)
    text = text.strip()
    ls = text.split(' ')
    txt = d_araby.stripTatweel(ls[0])
    return txt

# a تقسيم القصيدة المدخلة إلى أبيات-----------------------------
    
def my_split(text, a3aridh):
    list_abiat = []
    text = right_space(text)
    l_abiat = text.splitlines(1)
    n = 0
    for a in l_abiat:
        if '*' in a and len(a) > 15:
            half = a.split('*')
            h1 = half[0].strip()
            h2 = half[1].strip()
            list_abiat.append([h1, h2])
            n += 1
        else:
            if a3aridh == 1:
                list_abiat.append([a, 'half']) 
                n += 1
            else:
                list_abiat.append([a, 'title']) 
    if is_machtor(text):
        n = len(text.splitlines(1))+text.count('*')
    return list_abiat, n

# a تحديد نوع قصيدة القريض أمشطور أم تام----------------------
    
def is_machtor(text):
    mashtor = True
    l_abiat = text.splitlines(1)
    if '*' in l_abiat[-1]:
        mashtor = False
    return mashtor

# a إعادة قافية القصيدة بعد تخمينها-----------------------------
    
def kafia_poem(text):
    if is_machtor(text):
        list_poem = my_split(text, 1)[0]
    else:
        list_poem = my_split(text, 0)[0]
    for a in list_poem:
        if a[1] == 'half':
            v = 0
        elif a[1] == 'title':
            continue
        else:
            v = 1
        if d_araby.isWeak(a[v][-1]): return 1
        elif d_araby.isHaraka(a[v][-1]): return 1
        elif d_araby.isSukun(a[v][-1]): return 2
    return 2

# a إعادة روي القصيدة بعد تخمينه-----------------------------
    
def rawi_poem(text):
    if is_machtor(text):
        list_poem, n = my_split(text, 1)
    else:
        list_poem, n = my_split(text, 0)
    if len(list_poem) == 1:
        txt = d_araby.stripTashkeel(text)
        if txt[-1] == 'ا':
            if txt[-2] == 'و':
                return txt[-3]
            else:
                return txt[-2]
        if text[-2:] == 'هْ':
            return txt[-2]
        elif text[-1] in ['ي', 'و', 'ه']:
            return txt[-2]
        elif txt[-1] == 'ة':
            return 'ت'
        elif txt[-1] == 'ى':
            return 'ا'
        elif txt[-4:] == 'عمرو':
            return txt[-2]
        else:
            return txt[-1]
    elif len(list_poem) > 1:
        n = 0
        ls = []
        for a in list_poem:
            if n == 2: break
            if a[1] == 'half':
                ls.append(a[0])
                n += 1
            elif a[1] == 'title':
                if len(list_poem) == 2:
                    r = rawi_poem(' '.join(list_poem[-1]))
                    return r
                else:
                    continue
            else:
                ls.append(a[1])
        txt1 = d_araby.stripTashkeel(ls[0]).strip()
        txt2 = d_araby.stripTashkeel(ls[1]).strip()
        h11 = txt1[-1]
        h12 = txt1[-2]
        h13 = txt1[-3]
        h21 = txt2[-1]
        h22 = txt2[-2]
        h23 = txt2[-3]
        if h11 == 'ا' and h12 == 'ه':
            if h13 == h23: return h13
            else: return h12
        if h11 in ['ا', 'ى', 'ه', 'ة', 'و', 'ي']:
            if h12 == h22 or h12 == h21: return h12
            else: return h11
        else: return h11
        
# a إعادة اسم القصيدة ونصها ومعلوماتها-------------------------
    
def name_poem(text):
    new_text = ''
    n = 0
    naw3 = 1
    gharadh = 0
    baher = 0
    kafia = 0
    rawi = 0
    text = right_space(text)
    l_abiat = text.splitlines(1)
    for a in l_abiat:
        if '=' in a:
            n += 1
            d = a.split(' ')
            if 'النوع' in a:
                try: naw3 = get_int(elnaw3, d[-1])
                except: naw3 = 1
            if 'الغرض' in a:
                try: gharadh = get_int(elgharadh, d[-1])
                except: gharadh = 0
            if 'القافية' in a:
                try: kafia = get_int(elkawafi, d[-1])
                except: kafia = 0
            if 'الروي' in a:
                try: rawi = get_int(elrawi, d[-1])
                except: rawi = 0 
            if 'البحر' in a:
                try: baher = get_int(elbehor, d[-1])
                except: baher = 0
        else:
            new_text += a+'\n'
    if len(l_abiat) > n:
        if '*' in l_abiat[n]:
            half = l_abiat[n].split('*')
            name = half[0]
        else:
            name = l_abiat[n]
        name = re.sub('\n+', '', name)
        if kafia == 0:
            kafia = kafia_poem(new_text)
        if rawi == 0:
            h = rawi_poem(new_text)
            rawi = get_int_rawi(h)
        return name, new_text, naw3, gharadh, baher, rawi, kafia
    else:
        return '', '', '', '', '', '', ''

# a قائمة بكلمات القصيدة وعددها-----------------------------
    
def n_words(text):
    txt = re.sub('\*', '', text)
    text = right_space(txt)
    ls = text.split()
    return ls, len(ls)

# a إعادة أبيات محددة من القصيدة-----------------------------
    
def get_abiat(text, v1, v2, t):
    a3aridh = is_machtor(text)
    if '*' not in text: t = 1
    l_abiat, n = my_split(text, a3aridh)
    lst = []
    for a in range(n):
        if a >= (v1-1)/t and a <= (v2-1)/t:
            if l_abiat[a][1] != 'title':
                if l_abiat[a][1] != 'half':
                    lst.append(l_abiat[a][0]+' * '+l_abiat[a][1])
                else:
                    lst.append(l_abiat[a][0])
    if len(lst) > 0:
        return '\n'.join(lst)
    else: return None

# a إعادة موضع أطول شطر في القصيدة-----------------------------
    
def longer_half(text, label, a3aridh):
    l_abiat, n_abiat = my_split(text, a3aridh)
    s = 0
    i = 0
    c = 0
    for a in l_abiat:
        if a[1] != 'title':
            label.set_text(a[0])
            pangolayout = label.get_layout()
            d = pangolayout.get_pixel_size()
            if d[0] > s :
                s = d[0]
                c = 0
                i = l_abiat.index(a, )
            if a[1] != 'half':
                label.set_text(a[1])
                pangolayout = label.get_layout()
                d1 = pangolayout.get_pixel_size()
                if d1[0] > s :
                    s = d1[0]
                    c = 1
                    i = l_abiat.index(a, )
    return (i*2)+c, n_abiat

# a حساب طول أطول شطر بالبكسلات-----------------------------
    
def length_Half(poem, label, length, size_font, width_window, a3aridh):
    list_verses = my_split(poem, a3aridh)[0]
    a1 = int(length/2)
    a2 = length%2
    lengther = list_verses[a1][a2]
    label.set_text(lengther)
    pangolayout = label.get_layout()
    d = pangolayout.get_pixel_size()
    label.set_text('حــــب')
    pangolayout = label.get_layout()
    t = pangolayout.get_pixel_size()
    label.set_text('حب')
    pangolayout = label.get_layout()
    s = pangolayout.get_pixel_size()
    label.set_text(' ')
    pangolayout = label.get_layout()
    e = pangolayout.get_pixel_size()
    long_verse = d[0]+10
    long_tatwil = (t[0]-s[0])/4
    long_space = e[0]
    return load_poem(label, list_verses, long_verse, 
                     long_tatwil, long_space, size_font, width_window)

# a إيجاد موضع لزيادة التطويل---------------------------------

def my_re(labeltext):
    for s in d_araby.tatwil_locations:
        if ''.join(s) in labeltext:
            return ''.join(s)

# a زيادة التطويلات لتعديل طول الأبيات---------------------------

def ta3dil_by_tatweel(text, label, long_verse, long_tatwil):
    min_v = int(d_config.getf('min_long'))
    if long_verse > min_v: pass
    else: long_verse = min_v
    label.set_text(text)
    pangolayout = label.get_layout()
    s = pangolayout.get_pixel_size()
    if long_tatwil == 0 : return text
    rn = int((long_verse-s[0])/long_tatwil)
    re_text = my_re(text)
    tatwil = '\u0640'*rn
    try: new_text = text.replace(re_text, re_text[:-1]+tatwil+re_text[-1], 1)
    except: new_text = text
    return new_text

# a زيادة المسافات لتعديل طول الأبيات---------------------------

def ta3dil_by_space(text, label, long_verse, long_space):
    min_v = int(d_config.getf('min_long'))
    if long_verse > min_v: pass
    else: long_verse = min_v
    label.set_text(text)
    pangolayout = label.get_layout()
    s = pangolayout.get_pixel_size()
    list_text = text.split()
    n_all = (long_verse-s[0])/long_space
    n_one = int(n_all/((len(list_text))-1))
    n_add = n_all%((len(list_text))-1)
    if n_all <= 0 : return text
    new_text = ''
    for a in list_text:
        if a == list_text[-1]: new_text += a
        else:
            new_text += a+' '+' '*n_one
            if n_add > 0:
                new_text += " "
                n_add -= 1
    return new_text

def ta3dil(text, label, long_verse, long_tatwil, long_space):
    if d_config.getf('tandhid') == 0:
        return ta3dil_by_tatweel(text, label, long_verse, long_tatwil)
    else: 
        return ta3dil_by_space(text, label, long_verse, long_space)

# a تعديل الأشطر وجمعها------------------------------------------

def load_poem(label, list_verses, long_verse, long_tatwil, long_space, size_font, width_window):
    poem = ''
    max_v = int(d_config.getf('max_long'))
    min_v = int(d_config.getf('min_long'))
    b_h = (d_config.getn('b_half')+1)*2
    half_space = (width_window-30)/2
    if half_space >= long_verse*5/6: v = (long_verse*2)/3
    else: v = (2*half_space)-long_verse
    if d_config.getf('tarakeb') == 0 or long_verse > max_v or \
    long_verse > half_space-((size_font*b_h)/2) or min_v > half_space-((size_font*b_h)/2):
        t = 2
        for a in list_verses:
            if a[1] == 'title':
                poem += right_space(a[0])+'\n'
            elif a[1] == 'half':
                poem += re.sub('\n\n', '\n', ta3dil(a[0], label, long_verse, long_tatwil, long_space)+'\n')
            else:
                h1 = ta3dil(a[0], label, long_verse, long_tatwil, long_space)
                h2 = ta3dil(a[1], label, long_verse, long_tatwil, long_space)
                poem += h1+' '*int(v/long_space)+'\n'
                poem += ' '*int(v/long_space)+h2+'\n'
    else:
        t = 1
        for a in list_verses:
            if a[1] == 'title':
                poem += right_space(a[0])+'\n'
            elif a[1] == 'half':
                poem += re.sub('\n\n', '\n', ta3dil(a[0], label, long_verse, long_tatwil, long_space)+'\n')
            else:
                h1 = ta3dil(a[0], label, long_verse, long_tatwil, long_space)
                h2 = ta3dil(a[1], label, long_verse, long_tatwil, long_space)
                poem += h1
                poem += ' '*int(size_font*b_h/long_space)
                poem += h2+'\n'
    return poem, t

# a عدد الابيات والقصائد ---------------------------------------------------------------

def nn_abiat_poems(n, v):
    try: n = int(n)
    except: n = 1
    if v == 1: 
        n1 = 'قصيدة واحدة'
        n2 = 'قصيدتان'
        n3 = 'قصائد'
        n4 = 'قصيدةً'
        n5 = 'قصيدةٍ'
    elif v == 2: 
        n1 = 'بيت واحد'
        n2 = 'بيتان'
        n3 = 'أبيات'
        n4 = 'بيتًا'
        n5 = 'بيتٍ'
    if n == 1: text = n1
    elif n == 2: text = n2
    elif n%100 in range(3, 10): text = str(n)+' '+n3
    elif n == 10: text = str(n)+' '+n3
    elif n%100 > 10: text = str(n)+' '+n4
    elif n%100 == 0: text = str(n)+' '+n5
    else: text = str(n)+' '+n4
    return text
