#! /usr/bin/python3
# -*- coding: utf-8 -*-

##############################################################################
#a########  "قُلۡ بِفَضلِ ٱللَّهِ وَبِرَحمَتِهِۦ فَبِذَٰلِكَ فَليَفرَحُواْ هُوَ خَيرُُ مِّمَّا يَجمَعُونَ"  #########
##############################################################################

#a ماذا سأفعل؟
#a تصدير القصائد بصيغة pdf odt
#a خاصية البحث في نفس البيت

import d_customs, d_config
from os.path import dirname, realpath
from gi.repository import Gtk, Gdk
from d_favorites import Favorites
from d_abiat import MyAbiat
from d_metrics import Metrics
from d_dict import Explanatory
from d_fun import MyFun
from d_theme import MyTheme
from d_contacts import MyDB
from d_dawawin import dawawin_page
from d_filter import FilterPoem
from d_viewer import ViewerPoem
from d_search import ResultSearch, Searcher
from d_face import Face
from d_marks import SavedMarks
from d_result import SavedResult
from d_preference import Preference
from d_share import ImportExport
from d_add import AddPoem
from d_organize import Organize
from d_count import Count
from d_repair import Repair
from d_search import ShowResult
from d_books import BooksViewer
from d_assemble import AssemblePoems
import sys


Gtk.Widget.set_default_direction(Gtk.TextDirection.RTL)
ACCEL_CTRL_KEY, ACCEL_CTRL_MOD = Gtk.accelerator_parse("<Ctrl>")
ACCEL_SHFT_KEY, ACCEL_SHFT_MOD = Gtk.accelerator_parse("<Shift>")
ACCEL_ALT_KEY, ACCEL_ALT_MOD = Gtk.accelerator_parse("<Alt>")
     
# class الرئيس--------------------------------------------------------
        
class DwawinApp(Gtk.Window):
            
    def quit_app(self, *a):
        Gtk.main_quit()       
        
    def __init__(self,*a):
        self.main_notebook = Gtk.Notebook()
        self.last_pages = [0,]
        self.search_win = None
        self.entry_search = Gtk.SearchEntry()
        Gtk.Window.__init__(self)
        self.set_border_width(3)
        self.set_default_size(1400, 600)
        self.maximize()
        self.axl = Gtk.AccelGroup()
        self.add_accel_group(self.axl)
        self.db = MyDB()
        self.theme = MyTheme()
        self.favorites = Favorites(self)
        self.my_abiat = MyAbiat(self)
        self.metrics = Metrics(self)
        self.my_dict = Explanatory(self)
        self.my_booksviewer = BooksViewer(self)
        self.my_fun = MyFun(self)
        self.my_face = Face(self)
        self.dawawin_page = dawawin_page(self)
        self.filter_page = FilterPoem(self)
        self.assemblepoems = AssemblePoems(self)
        self.viewerpoem = ViewerPoem(self)
        self.resultsearch = ResultSearch(self)
        self.organiz = Organize(self)
        self.showresult = ShowResult
        self.build()
    
    def refresh(self, *a):
        n = self.main_notebook.get_n_pages()
        for a in range(n):
            try:
                ch = self.main_notebook.get_nth_page(a)
                ch.change_font()
            except: pass
        n = self.viewerpoem.get_n_pages()
        for a in range(n):
            try:
                ch = self.viewerpoem.get_nth_page(a)
                ch.change_font()
                ch.build(self.theme.fontmp)
            except: pass
    
    def show_help(self, *a):
        # interface--------------------------------------
        dlg = Gtk.Dialog(parent=self)
        dlg.set_icon_name("asmaa")
        dlg.set_default_size(900, 600)
        box = dlg.vbox
        
        hb_bar = Gtk.HeaderBar()
        hb_bar.set_show_close_button(True)
        dlg.set_titlebar(hb_bar)
        hb_bar.set_title('المساعدة')
        
        view_help = d_customs.ViewClass()
        view_help_bfr = view_help.get_buffer()
        with open(d_customs.MY_HELP) as f: view_help_bfr.set_text(f.read())
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(view_help)
        #----------------------------
        box.pack_start(scroll, True, True, 0)
        dlg.show_all()
    
    def toggled_btn_daw(self, btn, v):
        if btn.get_active():
            if v == 1: 
                self.btn_filter.set_active(False)
                self.btn_assemble.set_active(False)
                self.main_notebook.set_current_page(1)
            elif v == 2: 
                self.btn_daw.set_active(False)
                self.btn_assemble.set_active(False)
                self.main_notebook.set_current_page(2)
            elif v == 3: 
                self.btn_daw.set_active(False)
                self.btn_filter.set_active(False)
                self.main_notebook.set_current_page(11)
     
    def switch_page(self, widget, page, n):
        if n == 0:
            self.btnbox_browser.hide()
            self.btnbox_dawawin.hide()
            self.entry_search.set_placeholder_text('')
            if self.my_face.face_notebook.get_current_page() == 1: self.entry_search.set_placeholder_text('بحث في النص')
            elif self.my_face.face_notebook.get_current_page() == 3: self.entry_search.set_placeholder_text('بحث في النص/المعجم')
        elif n == 1:
            self.btnbox_browser.hide()
            self.btnbox_dawawin.show_all()
            self.btn_filter.set_active(False)
            self.btn_assemble.set_active(False)
            self.btn_daw.set_active(True)
            self.entry_search.set_placeholder_text('بحث عن قصيدة')
        elif n ==2:
            self.btnbox_browser.hide()
            self.btnbox_dawawin.show_all()
            self.btn_filter.set_active(True)
            self.btn_daw.set_active(False)
            self.btn_assemble.set_active(False)
            self.entry_search.set_placeholder_text('بحث عن قصيدة')
        elif n ==11:
            self.btnbox_browser.hide()
            self.btnbox_dawawin.show_all()
            self.btn_filter.set_active(False)
            self.btn_daw.set_active(False)
            self.btn_assemble.set_active(True)
            self.entry_search.set_placeholder_text('بحث عن قصيدة')
        elif n ==3:
            self.btnbox_browser.show_all()
            self.btnbox_dawawin.hide()
            self.entry_search.set_placeholder_text('بحث في النص')
        elif n == 4:
            self.btnbox_browser.hide()
            self.btnbox_dawawin.hide()
            self.entry_search.set_placeholder_text('بحث في النص')
        elif n in [5, 6, 7, 8, 9]:
            self.btnbox_browser.hide()
            self.btnbox_dawawin.hide()
            self.entry_search.set_placeholder_text('بحث عن قصيدة')
        elif n == 10:
            self.btnbox_browser.show_all()
            self.btnbox_dawawin.hide()
            self.prev_poem.set_sensitive(True)
            self.next_poem.set_sensitive(True)
            self.entry_search.set_placeholder_text('بحث في النص')
        if n not in [4, 3]: d_config.setv('start0', n) 
        if n != self.last_pages[-1]:
            if n in self.last_pages:
                self.last_pages.remove(n)
            self.last_pages.append(n)

    def back_to_previous(self, *a):
        if len(self.last_pages) == 1: return
        del self.last_pages[-1]
        self.main_notebook.set_current_page(self.last_pages[-1])  

    def show_last_page(self, *a):
        for a in self.my_face.list_btn:
            if d_config.getv('start') == a.get_name():
                a.set_active(True)
        self.switch_page(self.main_notebook, 0, d_config.getn('start0'))
        self.main_notebook.set_current_page(d_config.getn('start0'))
            
    
    def search_on_page(self, *a):
        text = self.entry_search.get_text()
        n = self.main_notebook.get_current_page()
        ch = self.main_notebook.get_nth_page(n)
        ch.search_on_page(text)
    
    def search_on_active(self, *a):
        text = self.entry_search.get_text()
        n = self.main_notebook.get_current_page()
        ch = self.main_notebook.get_nth_page(n)
        ch.search_on_active(text)
        
    def near_page(self, v):
        n = self.main_notebook.get_current_page()
        ch = self.main_notebook.get_nth_page(n)
        ch.near_page(v)
        
    def move_in_page(self, v):
        n = self.main_notebook.get_current_page()
        ch = self.main_notebook.get_nth_page(n)
        ch.move_in_page(v)
    
    def show_win_searh(self, *a):
        if self.search_win == None:
            self.search_win = Searcher(self)
            self.search_win.show_all()
        else: self.search_win.show_all()
    
    def full_screen(self, *a):
        if self.full == 1:
            self.unfullscreen()
            self.full = 0
        else:
            self.fullscreen()
            self.full = 1
     
    def show_dawawin(self, *a):
        if self.btn_filter.get_active(): self.main_notebook.set_current_page(2)
        else: self.main_notebook.set_current_page(1)
     
    def to_assemble(self, id_poem):
        list_assemble = self.db.get_assembles()
        dlg = Gtk.Dialog(parent=self)
        dlg.set_icon_name("Dawawin")
        area = dlg.get_content_area()
        area.set_spacing(6)
        dlg.set_title('المواضع المحفوظة')
        dlg.set_default_size(350, 300)
        store_assemble = Gtk.ListStore(int, str, str)
        for a in list_assemble:
            store_assemble.append(a)
        tree_assemble = d_customs.TreeClass()
        def ok_m(w, *a):
            model, i = tree_assemble.get_selection().get_selected()
            if i: 
                id_assemble = model.get_value(i, 0)
                self.db.to_assemble([id_poem,], id_assemble)
                dlg.destroy()
        tree_assemble.connect("row-activated", ok_m)
        column = Gtk.TreeViewColumn('اسم المجموع',Gtk.CellRendererText(),text = 1)
        tree_assemble.append_column(column)
        tree_assemble.set_model(store_assemble)
        scroll = Gtk.ScrolledWindow()
        scroll.set_shadow_type(Gtk.ShadowType.IN)
        scroll.add(tree_assemble)
        area.pack_start(scroll, True, True, 0)
        dlg.show_all()
     
    # a البناء-------------------------------------------------------------------- 
    
    def build(self,*a):
        self.full = 0
        self.set_icon_name('dawawin')
        self.connect("delete_event", self.quit_app)
        self.connect("destroy", self.quit_app)
        self.agr = Gtk.AccelGroup()
        self.add_accel_group(self.agr)
       
        hb_bar = Gtk.HeaderBar()
        hb_bar.set_show_close_button(True)
        self.set_titlebar(hb_bar)
        self.set_title("دواوين العرب")
        #hb_bar.set_title("دواوين العرب")
        
        #- btns_pages----------------------------
        menu_pages = Gtk.Menu()   
        win_face = Gtk.MenuItem("الواجهة")
        win_face.add_accelerator("activate", self.axl, Gdk.KEY_F2, 0, Gtk.AccelFlags.VISIBLE)
        win_face.connect('activate', lambda *a: self.main_notebook.set_current_page(0))
        menu_pages.append(win_face)     
        win_dawawin = Gtk.MenuItem("الدواوين")
        win_dawawin.add_accelerator("activate", self.axl, Gdk.KEY_F3, 0, Gtk.AccelFlags.VISIBLE)
        win_dawawin.connect('activate', self.show_dawawin)
        menu_pages.append(win_dawawin)
        win_books = Gtk.MenuItem("المكتبة")
        win_books.add_accelerator("activate", self.axl, Gdk.KEY_F4, 0, Gtk.AccelFlags.VISIBLE)
        win_books.connect('activate', lambda *a: self.main_notebook.set_current_page(10))
        menu_pages.append(win_books)
        menu_pages.append(Gtk.SeparatorMenuItem.new())
        self.poems_tgl = Gtk.MenuItem("القصائد المفتوحة")
        self.poems_tgl.connect('activate', lambda *a: self.main_notebook.set_current_page(3))
        self.poems_tgl.set_sensitive(False)
        menu_pages.append(self.poems_tgl)
        self.search_result_item = Gtk.MenuItem("نتائج البحث المفتوحة")
        self.search_result_item.connect('activate', lambda *a: self.main_notebook.set_current_page(4))
        menu_pages.append(self.search_result_item)
        self.search_result_item.set_sensitive(False)
        menu_pages.append(Gtk.SeparatorMenuItem.new())
        back_win= Gtk.MenuItem("النافذة السابقة")
        back_win.add_accelerator("activate", self.axl, Gdk.KEY_BackSpace, ACCEL_CTRL_MOD, Gtk.AccelFlags.VISIBLE)
        back_win.connect('activate', self.back_to_previous)
        menu_pages.append(back_win)
        
        btn_pages = Gtk.MenuButton()
        btn_pages.set_popup (menu_pages)
        img = Gtk.Image.new_from_icon_name('go-home', Gtk.IconSize.BUTTON)
        btn_pages.set_image(img)
        menu_pages.show_all()
        hb_bar.pack_start(btn_pages)
        
        #- btns_action----------------------------
        btnbox_action = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)
        Gtk.StyleContext.add_class(btnbox_action.get_style_context(), "linked")
        btn_find = Gtk.Button()
        img = Gtk.Image.new_from_icon_name('edit-find', Gtk.IconSize.BUTTON)
        btn_find.set_image(img)
        btn_find.set_tooltip_text('نافذة البحث')
        btn_find.connect('clicked', self.show_win_searh)
        btnbox_action.pack_start(btn_find, False, False, 0)
    
        menu_option = Gtk.Menu()   
        fh = Gtk.MenuItem("كبّر الخط")
        fh.connect("activate", lambda *a: self.near_page(1))
        fh.add_accelerator("activate", self.axl, Gdk.KEY_plus, ACCEL_CTRL_MOD, Gtk.AccelFlags.VISIBLE)
        menu_option.append(fh)
        fs = Gtk.MenuItem("صغّر الخط")
        fs.connect("activate", lambda *a: self.near_page(-1))
        fs.add_accelerator("activate", self.axl, Gdk.KEY_minus, ACCEL_CTRL_MOD, Gtk.AccelFlags.VISIBLE)
        menu_option.append(fs)
        menu_option.append(Gtk.SeparatorMenuItem.new())
        win_marks = Gtk.MenuItem("نافذة العلامات المرجعيّة")
        win_marks.connect('activate', lambda *a: SavedMarks(self))
        menu_option.append(win_marks)     
        win_results = Gtk.MenuItem("نافذة البحوث المحفوظة")
        win_results.connect('activate', lambda *a: SavedResult(self))
        menu_option.append(win_results)
        menu_option.append(Gtk.SeparatorMenuItem.new())
        win_prefs = Gtk.MenuItem("التفضيلات")
        win_prefs.add_accelerator("activate", self.axl, Gdk.KEY_F8, 0, Gtk.AccelFlags.VISIBLE)
        win_prefs.connect("activate", lambda *a: Preference(self))
        menu_option.append(win_prefs)
        menu_option.append(Gtk.SeparatorMenuItem.new())
        how_search = Gtk.MenuItem("كيف أبحث؟")
        msg = '''
        للبحث في دواوين العرب في مجموعة من الكتب أو الدواوين 
        يتعين البحث بواسطة نافذة البحث.
        أما للبحث في الكتاب المفتوح أو القصيدة المعروضة 
        أو الأبيات المفضلة أو المعجم ، فيجب البحث من خلال مربع الإدخال 
        الموجود في رأسية النافذة من جهة اليسار، حيث :
        - بمجرد الكتابة فيها يعلم النتائج في نفس الصفحة المعروضة.
        - أما بالضغط على مفتاح الإدخال فيتم البحث في جميع الكتاب
         أو الديوان أو الأبيات المفضلة أو المعاجم، بحسب الصفحة المعروضة. 
        - في صفحة الدواوين والتصفية والمجاميع يتم البحث عن قصيدة. 
        '''
        how_search.connect("activate", lambda *a: d_customs.info(self, msg))
        menu_option.append(how_search)
        btn_menu = Gtk.MenuButton()
        btn_menu.set_popup (menu_option)
        img = Gtk.Image.new_from_icon_name('system-run', Gtk.IconSize.BUTTON)
        btn_menu.set_image(img)
        menu_option.show_all()
        btnbox_action.pack_start(btn_menu, False, False, 0)
        
        hb_bar.pack_start(btnbox_action)
        
        #- btns_dawawin----------------------------
        self.btnbox_dawawin = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)
        Gtk.StyleContext.add_class(self.btnbox_dawawin.get_style_context(), "linked")
        self.btn_daw = Gtk.ToggleButton('الدواوين')
        self.btn_daw.connect('toggled', self.toggled_btn_daw, 1)
        self.btn_daw.set_size_request(80, -1)
        self.btnbox_dawawin.pack_start(self.btn_daw, False, False, 0)
        self.btn_filter = Gtk.ToggleButton('التصفية')
        self.btn_filter.connect('toggled', self.toggled_btn_daw, 2)
        self.btn_filter.set_size_request(80, -1)
        self.btnbox_dawawin.pack_start(self.btn_filter, False, False, 0)
        self.btn_assemble = Gtk.ToggleButton('المجاميع')
        self.btn_assemble.connect('toggled', self.toggled_btn_daw, 3)
        self.btn_assemble.set_size_request(80, -1)
        self.btnbox_dawawin.pack_start(self.btn_assemble, False, False, 0)
        
        #- btns_browser----------------------------
        self.btnbox_browser = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)
        Gtk.StyleContext.add_class(self.btnbox_browser.get_style_context(), "linked")
        #-----------------------------
        self.prev_poem = Gtk.Button()
        self.prev_poem.set_size_request(80, -1)
        img = Gtk.Image()
        img.set_from_icon_name('go-previous-rtl', Gtk.IconSize.BUTTON)
        self.prev_poem.set_image(img)
        self.prev_poem.set_tooltip_text('السابقة')
        self.prev_poem.connect('clicked',  lambda *a: self.move_in_page(-1))
        self.prev_poem.add_accelerator("clicked",self.axl, Gdk.KEY_Right, ACCEL_ALT_MOD, Gtk.AccelFlags.VISIBLE)
        self.btnbox_browser.pack_start(self.prev_poem, False, False, 0)
        #--------------------------------------
        self.next_poem = Gtk.Button()
        self.next_poem.set_size_request(80, -1)
        img = Gtk.Image()
        img.set_from_icon_name('go-next-rtl', Gtk.IconSize.BUTTON)
        self.next_poem.set_image(img)
        self.next_poem.set_tooltip_text('التالية')
        self.next_poem.connect('clicked',  lambda *a: self.move_in_page(1))
        self.next_poem.add_accelerator("clicked",self.axl, Gdk.KEY_Left, ACCEL_ALT_MOD, Gtk.AccelFlags.VISIBLE)
        self.btnbox_browser.pack_start(self.next_poem, False, False, 0)
        
        box_title = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)
        box_title.pack_start(self.btnbox_dawawin, False, False, 0)
        box_title.pack_start(self.btnbox_browser, False, False, 0)
        hb_bar.set_custom_title(box_title)
        
        #- entry_search----------------------------
        hb_bar.pack_end(self.entry_search)
        self.entry_search.connect('changed', self.search_on_page)
        self.entry_search.connect('activate', self.search_on_active)
        
        #- main_notebook----------------------------
        self.main_notebook.set_scrollable(True)
        self.main_notebook.set_show_tabs(False)
        
        self.main_notebook.append_page(self.my_face, Gtk.Label("0"))
        self.main_notebook.append_page(self.dawawin_page, Gtk.Label("1"))
        self.main_notebook.append_page(self.filter_page, Gtk.Label("2"))
        self.main_notebook.append_page(self.viewerpoem, Gtk.Label("3"))
        self.main_notebook.append_page(self.resultsearch, Gtk.Label("4"))
        self.main_notebook.append_page(self.organiz, Gtk.Label('5'))
        self.main_notebook.append_page(AddPoem(self), Gtk.Label('6'))
        self.main_notebook.append_page(ImportExport(self), Gtk.Label('7'))
        self.main_notebook.append_page(Count(self), Gtk.Label('8'))
        self.main_notebook.append_page(Repair(self), Gtk.Label('9'))
        self.main_notebook.append_page(self.my_booksviewer, Gtk.Label("10"))
        self.main_notebook.append_page(self.assemblepoems, Gtk.Label("11"))
        
        
        self.add(self.main_notebook)
        self.main_notebook.connect("switch-page", self.switch_page)
        
        self.axl.connect(Gdk.KEY_F1, 0, Gtk.AccelFlags.VISIBLE, self.show_help)
        self.axl.connect(Gdk.KEY_F11, 0, Gtk.AccelFlags.VISIBLE, self.full_screen)
        self.axl.connect(Gdk.KEY_F6, 0, Gtk.AccelFlags.VISIBLE, self.show_win_searh)
        self.axl.connect(Gdk.KEY_F2, 0, Gtk.AccelFlags.VISIBLE, lambda *a: self.main_notebook.set_current_page(0))
        self.axl.connect(Gdk.KEY_F3, 0, Gtk.AccelFlags.VISIBLE, lambda *a: self.main_notebook.set_current_page(1))
        self.axl.connect(Gdk.KEY_F4, 0, Gtk.AccelFlags.VISIBLE, lambda *a: self.main_notebook.set_current_page(10))
        self.axl.connect(Gdk.KEY_F8, 0, Gtk.AccelFlags.VISIBLE, lambda *a: self.preference_win.show_all())
        self.axl.connect(Gdk.KEY_equal, ACCEL_CTRL_MOD, Gtk.AccelFlags.VISIBLE, lambda *a: self.near_page(1))
        self.axl.connect(Gdk.KEY_plus, ACCEL_CTRL_MOD, Gtk.AccelFlags.VISIBLE, lambda *a: self.near_page(1))
        self.axl.connect(Gdk.KEY_KP_Add, ACCEL_CTRL_MOD, Gtk.AccelFlags.VISIBLE, lambda *a: self.near_page(1))
        self.axl.connect(Gdk.KEY_minus, ACCEL_CTRL_MOD, Gtk.AccelFlags.VISIBLE, lambda *a: self.near_page(-1))
        self.axl.connect(Gdk.KEY_KP_Subtract, ACCEL_CTRL_MOD, Gtk.AccelFlags.VISIBLE, lambda *a: self.near_page(-1))
        self.axl.connect(Gdk.KEY_BackSpace, ACCEL_CTRL_MOD, Gtk.AccelFlags.VISIBLE, self.back_to_previous)
        
        self.show_all()
        d_customs.greet.destroy()
        self.show_last_page()

#----------------------------------------------------


def main(): 
    Dwa = DwawinApp()
    Gtk.main()

if __name__ == "__main__":
    main()